/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include <mysql/mysql.h>
#include <libsql++.h>
#include <string>
using std::string;
#include <libcgi++.h>
#include <libwolfshade.h>
#include <ctype.h>

#include "WolfshadeWeb.h"
#include "BaseForm.h"


namespace cgi
{


BaseForm::BaseForm(Web *web,const string &name)
:WebForm(web,name)
,m_strColor("#ffffc0")
{
}


BaseForm::~BaseForm()
{
}


Database *BaseForm::GetDatabase()
{
	WolfshadeWeb *web = static_cast<WolfshadeWeb *>(GetWeb());
	return web -> GetDatabase();
}


long BaseForm::GetStart()
{
	WolfshadeWeb *web = static_cast<WolfshadeWeb *>(GetWeb());
	return web -> GetStart();
}


long BaseForm::GetAntal()
{
	WolfshadeWeb *web = static_cast<WolfshadeWeb *>(GetWeb());
	return web -> GetAntal();
}


long BaseForm::GetZone()
{
	WolfshadeWeb *web = static_cast<WolfshadeWeb *>(GetWeb());
	return web -> GetZone();
}


long BaseForm::GetRace()
{
	WolfshadeWeb *web = static_cast<WolfshadeWeb *>(GetWeb());
	return web -> GetRace();
}


long BaseForm::GetClass()
{
	WolfshadeWeb *web = static_cast<WolfshadeWeb *>(GetWeb());
	return web -> GetClass();
}


long BaseForm::GetObjtype()
{
	WolfshadeWeb *web = static_cast<WolfshadeWeb *>(GetWeb());
	return web -> GetObjtype();
}


long BaseForm::GetMaterial()
{
	WolfshadeWeb *web = static_cast<WolfshadeWeb *>(GetWeb());
	return web -> GetMaterial();
}


char *BaseForm::htmlcolor(const string &x)
{
	string s;
	int fgcolor = -1; // -1 == normal, 0 == black, 7 == white
	int bgcolor = -1;
	bool bold = false;
	bool ul = false;
	bool fl = false; // blink
	bool infont = false;
static	char slask[2000];

	for (size_t i = 0; i < x.size(); i++)
	{
		if (x[i] == 13)
		{
			s += "<br>";
		}
		else
		if (x[i] == ' ')
		{
			s += "&nbsp;";
		}
		else
		if (x[i] == '&')
		{
//			int fgo = fgcolor;
//			int bgo = bgcolor;
//			bool boldo = bold;
			bool ulo = ul;
			bool flo = fl;
			bool normal = false;

			i++;
			switch (x[i])
			{
			case 'n': // normal
				fgcolor = -1;
				bgcolor = -1;
				bold = false;
				ul = false;
				fl = false;
				normal = true;
				break;

			case 'r': // red
				fgcolor = 1;
				bold = false;
				break;
			case 'g': // green
				fgcolor = 2;
				bold = false;
				break;
			case 'y': // yellow
				fgcolor = 3;
				bold = false;
				break;
			case 'b': // blue
				fgcolor = 4;
				bold = false;
				break;
			case 'm': // magenta
				fgcolor = 5;
				bold = false;
				break;
			case 'c': // cyan
				fgcolor = 6;
				bold = false;
				break;
			case 'w': // white
				fgcolor = 7;
				bold = false;
				break;
			case 'l': // black
				fgcolor = 0;
				bold = false;
				break;

			case 'R': // RED
				fgcolor = 1;
				bold = true;
				break;
			case 'G': // GREEN
				fgcolor = 2;
				bold = true;
				break;
			case 'Y': // YELLOW
				fgcolor = 3;
				bold = true;
				break;
			case 'B': // BLUE
				fgcolor = 4;
				bold = true;
				break;
			case 'M': // MAGENTA
				fgcolor = 5;
				bold = true;
				break;
			case 'C': // CYAN
				fgcolor = 6;
				bold = true;
				break;
			case 'W': // WHITE
				fgcolor = 7;
				bold = true;
				break;
			case 'L': // BLACK
				fgcolor = 0;
				bold = true;
				break;

			case 'e': // background red
				bgcolor = 1;
				break;
			case 'k': // background green
				bgcolor = 2;
				break;
			case 'p': // background yellow
				bgcolor = 3;
				break;
			case 'u': // background blue
				bgcolor = 4;
				break;
			case 'a': // background magenta
				bgcolor = 5;
				break;
			case 'f': // background cyan
				bgcolor = 6;
				break;
			case 'h': // background white
				bgcolor = 7;
				break;
			case 'i': // background black
				bgcolor = 0;
				break;
			case 'U': // underline
				ul = true;
				break;
			case 'F': // flashing
				fl = true;
				break;
			}
			if (flo)
			{
				s += "</blink>";
			}
			if (ulo)
			{
				s += "</u>";
			}
			if (infont)
			{
				s += "</font>";
			}
			infont = false;
			if (!normal)
			{
				s += "<font style=\"";
				if (fgcolor > -1)
				{
					s += "color: #";
					s += (fgcolor & 1) ? "FF" : "00";
					s += (fgcolor & 2) ? "FF" : "00";
					s += (fgcolor & 4) ? "FF" : "00";
					s += ";";
				}
				if (bgcolor > -1)
				{
					s += "background-color: #";
					s += (bgcolor & 1) ? "FF" : "00";
					s += (bgcolor & 2) ? "FF" : "00";
					s += (bgcolor & 4) ? "FF" : "00";
					s += ";";
				}
				if (bold)
				{
					s += "font-weight: bold";
				}
				s += "\">";
				infont = true;
				if (ul)
				{
					s += "<u>";
				}
				if (fl)
				{
					s += "<blink>";
				}
			}
		}
		else
		{
			s += x[i];
		}
	}
	if (infont)
	{
		s += "</font>";
	}
	strcpy(slask, s.c_str());
	return slask;
}


char *BaseForm::nocolor(const string &str)
{
	string s;
static	char slask[1000];

	for (size_t i = 0; i < str.size(); i++)
	{
		if (str[i] == '&')
			i++;
		else
			s += str[i];
	}
	strcpy(slask, s.c_str());
	return slask;
}


void BaseForm::textarea(const string &txt,const string &name,const string &str,bool bPreview /*= false*/)
{
	int qrows = 1;
	for (size_t i = 0; i < str.size(); i++)
	{
		if (str[i] == '\n')
			qrows++;
	}
	printf("<tr bgcolor=%s>",m_strColor.c_str());
	printf("<td>%s</td>",txt.c_str());
	printf("<td>");
	printf("<textarea name=\"%s\" rows=%d cols=81>",name.c_str(),qrows);
	printf("%s",str.c_str());
	printf("</textarea>");
	if (bPreview)
	{
		printf("<br><div style=\"background-color: #808080\">%s</div>",htmlcolor(str.c_str()));
	}
	printf("</td>");
	printf("</tr>");
}


long BaseForm::asciiconvert(const string &str)
{
	long flags = 0;
	bool is_number = true;

	for (size_t i = 0; i < str.size(); i++)
	{
		if (islower(str[i]))
			flags |= 1 << (str[i] - 'a');
		else 
		if (isupper(str[i]))
			flags |= 1 << (25 + (str[i] - 'A'));
		if (!isdigit(str[i]))
			is_number = false;
	}

  	if (is_number)
    		flags = atol(str.c_str());

  	return flags;
}


void BaseForm::inputnum(const string &title,const string &name,long value,int vad)
{
	printf("<tr bgcolor=%s>",m_strColor.c_str());
	nbprintf("<td>&nbsp;%s&nbsp;</td>",title.c_str() );
	printf("<td><input type=text size=8 name=%s value=%ld>",name.c_str(),value);
	if (vad != VALUE_WHATEVER && value > 0)
	{
		printf("<div style=\"background-color: #808080\">");
	}
	switch (vad)
	{
	case VALUE_WHATEVER: // default
		break;
	case VALUE_IS_MOB:
		if (value > 0)
		{
			db::Mob mob(GetDatabase(),value);
			ShowMob(mob,true);
		}
		break;
	case VALUE_IS_OBJ:
		if (value > 0)
		{
			db::Obj obj(GetDatabase(),value);
			ShowObj(obj,true);
		}
		break;
	case VALUE_IS_ROOM:
		if (value > 0)
		{
			db::Room room(GetDatabase(),value);
			ShowRoom(room,true);
		}
		break;
	case VALUE_IS_ZONE:
		if (value > 0)
		{
			db::Zone zone(GetDatabase(),value);
			ShowZone(zone,true);
		}
		break;
	}
	if (vad != VALUE_WHATEVER && value > 0)
	{
		printf("</div>");
	}
	printf("</td>");
	printf("</tr>");
}


void BaseForm::inputcheck(const string &title,const string &name,bool checked)
{
	printf("<tr bgcolor=%s>",m_strColor.c_str());
	nbprintf("<td>&nbsp;%s&nbsp;</td>",title.c_str() );
	printf("<td><input type=checkbox name=%s value=1%s>",name.c_str(),checked ? " CHECKED" : "");
	printf("</td>");
	printf("</tr>");
}


void BaseForm::inputselect(Query &q,const string &title,const string &name,const string &query,long value,bool bNocolor)
{
	printf("<tr bgcolor=%s>",m_strColor.c_str());
	nbprintf("<td>&nbsp;%s&nbsp;</td>",title.c_str());
	printf("<td>");
	printf("<select name=%s>",name.c_str());
	printf("<option value=0>");
	q.get_result( (char *)query.c_str());
	while (q.fetch_row())
	{
		long num = q.getval();
		printf("<option value=%ld%s>%s",
			num,
			(num == value) ? " SELECTED" : "",
			bNocolor ? nocolor(q.getstr()) : q.getstr());
	}
	q.free_result();
	printf("</select>");
	printf("</td>");
	printf("</tr>");
}


void BaseForm::inputstr(const string &title,const string &name,int size,const string &value,bool bPreview /*= false*/)
{
	printf("<tr bgcolor=%s>",m_strColor.c_str());
	nbprintf("<td>&nbsp;%s&nbsp;</td>",title.c_str());
	printf("<td><input type=text size=%d name=%s value=\"%s\">",size,name.c_str(),value.c_str());
	if (bPreview)
	{
		printf("<br><div style=\"background-color: #808080\">%s</div>",htmlcolor(value.c_str()));
	}
	printf("</td>");
	printf("</tr>");
}


void BaseForm::inputsubmit(const string &title)
{
	printf("<tr bgcolor=%s>",m_strColor.c_str());
	printf("<td align=middle colspan=2>");
	printf("&nbsp;<input type=submit name=%s value=\"%s\">&nbsp;",GetFormName().c_str(),title.c_str());
	printf("</td>");
	printf("</tr>");
}


void BaseForm::inputbit(Query &q,const string &title,const string &name,const string &query,long flags,int brk,bool bRadio /*= false*/)
{
	int i = 1;

	printf("<tr bgcolor=%s>",m_strColor.c_str());
	nbprintf("<td>&nbsp;%s&nbsp;</td>",title.c_str());
	printf("<td>");
	q.get_result( (char *)query.c_str());
	while (q.fetch_row())
	{
		long num = q.getval();
		long bit = 1 << num;
		printf("&nbsp;<input type=%s name=%s value=%ld%s>%s&nbsp;",
			bRadio ? "radio" : "checkbox",
			name.c_str(),
			bit,(flags & bit) ? " CHECKED" : "",q.getstr());
		if (i && i % brk == 0)
		{
			printf("<br>");
		}
		i++;
	}
	q.free_result();
	printf("</td>");
	printf("</tr>");
}


void BaseForm::ShowMob(db::Mob &x,bool bLink,bool bTd)
{
	WolfshadeWeb *web = static_cast<WolfshadeWeb *>(GetWeb());

	if (bTd)
		printf("<td>");
//	printf("&nbsp;<font color=#ffffff>#%ld</font>&nbsp;",x.num);
	if (bLink)
		printf("<a class=edit href=%s?page=%ld&mobform=edit&edit=%ld>",
			GetCgiName().c_str(),web -> GetMenuMob(),x.num);
	printf("&nbsp;%s&nbsp;",htmlcolor(x.name));
	if (bLink)
		printf("</a>");
	printf("&nbsp;|&nbsp;<font color=#ffffff>%ld</font>&nbsp;",x.num);
	if (bTd)
		printf("</td>");
}


void BaseForm::ShowObj(db::Obj &x,bool bLink,bool bTd)
{
	WolfshadeWeb *web = static_cast<WolfshadeWeb *>(GetWeb());

	if (bTd)
		printf("<td>");
	if (bLink)
		printf("<a class=edit href=%s?page=%ld&objectform=edit&edit=%ld>",
			GetCgiName().c_str(),web -> GetMenuObj(),x.num);
	printf("&nbsp;%s&nbsp;",htmlcolor(x.name));
	if (bLink)
		printf("</a>");
	printf("&nbsp;|&nbsp;<font color=#ffffff>%ld</font>&nbsp;",x.num);
	if (bTd)
		printf("</td>");
}


void BaseForm::ShowRoom(db::Room &x,bool bLink,bool bTd,bool bNonum)
{
	WolfshadeWeb *web = static_cast<WolfshadeWeb *>(GetWeb());

	if (bTd)
		printf("<td>");
	if (bLink)
		printf("<a class=edit href=%s?page=%ld&roomform=edit&edit=%ld>",
			GetCgiName().c_str(),web -> GetMenuRoom(),x.num);
	printf("&nbsp;%s&nbsp;",htmlcolor(x.name));
	if (bLink)
		printf("</a>");
	if (!bNonum)
		printf("|&nbsp;<font color=#ffffff>%ld</font>&nbsp;",x.num);
	if (x.virtual_room)
	{
		printf("|&nbsp;<font color=#ffffff>virtual</font>&nbsp;");
		printf("|&nbsp;<font face=courier>%s</font>&nbsp;",htmlcolor(x.virtual_char));
		printf("|&nbsp;<font color=#ffffff>%c</font>&nbsp;",*x.design_char);
	}
	if (bTd)
		printf("</td>");
}


void BaseForm::ShowZone(db::Zone &x,bool bLink,bool bTd)
{
	WolfshadeWeb *web = static_cast<WolfshadeWeb *>(GetWeb());

	if (bTd)
		printf("<td>");
	if (bLink)
		printf("<a class=edit href=%s?page=%ld&zoneform=edit&edit=%ld&xzonex=%ld>",
			GetCgiName().c_str(),web -> GetMenuZone(),x.num,x.num);
	printf("&nbsp;%s&nbsp;",htmlcolor(x.name));
	if (bLink)
		printf("</a>");
	printf("&nbsp;|&nbsp;<font color=#ffffff>%ld</font>&nbsp;",x.num);
	if (bTd)
		printf("</td>");
}


void BaseForm::ShowVirtual(db::Vzone &x,bool bLink,bool bTd,bool bNonum)
{
	WolfshadeWeb *web = static_cast<WolfshadeWeb *>(GetWeb());

	if (bTd)
		printf("<td>");
	if (bLink)
		printf("<a class=edit href=%s?page=%ld&virtualform=edit&edit=%ld>",
			GetCgiName().c_str(),web -> GetMenuVirtual(),x.num);
	printf("&nbsp;%s&nbsp;",htmlcolor(x.name));
	if (bLink)
		printf("</a>");
	if (!bNonum)
		printf("&nbsp;|&nbsp;<font color=#ffffff>%ld</font>&nbsp;",x.num);
	if (bTd)
		printf("</td>");
}


long BaseForm::EditingZone()
{
	long zonesize = 0;

	if (GetZone())
	{
		db::Zone zone(GetDatabase(),GetZone());
		printf("<table><tr>");
		printf("<td>Editing Zone</td>");
		printf("<td><div style=\"background-color: #808080\">");
		ShowZone(zone,true);
		printf("</div></td>");
		printf("<td>[ <a href=%s?xzonex=0>End Edit</a> ]</td>",GetCgiName().c_str());
		printf("</tr></table>");
		printf("<br>");
		zonesize = zone.size;
	}
	return zonesize;
}


void BaseForm::ShowRace(db::Race &x,bool bLink,bool bTd)
{
	WolfshadeWeb *web = static_cast<WolfshadeWeb *>(GetWeb());

	if (bTd)
		printf("<td>");
	if (bLink)
		printf("<a class=edit href=%s?page=%ld&raceform=edit&edit=%ld>",
			GetCgiName().c_str(),web -> GetMenuRace(),x.num);
	printf("&nbsp;%s&nbsp;",htmlcolor(x.name));
	if (bLink)
		printf("</a>");
	printf("&nbsp;|&nbsp;<font color=#ffffff>%ld</font>&nbsp;",x.num);
	if (bTd)
		printf("</td>");
}


void BaseForm::ShowWeapon(db::Weapon &x,bool bLink,bool bTd)
{
	WolfshadeWeb *web = static_cast<WolfshadeWeb *>(GetWeb());

	if (bTd)
		printf("<td>");
	if (bLink)
		printf("<a class=edit href=%s?page=%ld&weaponform=edit&edit=%ld>",
			GetCgiName().c_str(),web -> GetMenuWeapon(),x.num);
	printf("&nbsp;%s&nbsp;",htmlcolor(x.name));
	if (bLink)
		printf("</a>");
	printf("&nbsp;|&nbsp;<font color=#ffffff>%ld</font>&nbsp;",x.num);
	if (bTd)
		printf("</td>");
}


void BaseForm::inputdie(const string &title,const string &name,long val1,long val2)
{
	printf("<tr bgcolor=%s>",m_strColor.c_str());
	nbprintf("<td>&nbsp;%s&nbsp;</td>",title.c_str() );
	printf("<td><input type=text size=8 name=%s1 value=%ld>",name.c_str(),val1);
	printf("&nbsp;D&nbsp;");
	printf("<input type=text size=8 name=%s2 value=%ld>",name.c_str(),val2);
	printf("</td>");
	printf("</tr>");
}


void BaseForm::ShowSkill(db::Skill &x,bool bLink,bool bTd)
{
	WolfshadeWeb *web = static_cast<WolfshadeWeb *>(GetWeb());

	if (bTd)
		printf("<td>");
	if (bLink)
		printf("<a class=edit href=%s?page=%ld&skillform=edit&edit=%ld>",
			GetCgiName().c_str(),web -> GetMenuSkill(),x.num);
	printf("&nbsp;%s&nbsp;",htmlcolor(x.name));
	if (bLink)
		printf("</a>");
	printf("&nbsp;|&nbsp;<font color=#ffffff>%ld</font>&nbsp;",x.num);
	if (bTd)
		printf("</td>");
}


void BaseForm::ShowResource(db::Resource &x,bool bLink,bool bTd)
{
	WolfshadeWeb *web = static_cast<WolfshadeWeb *>(GetWeb());

	if (bTd)
		printf("<td>");
	if (bLink)
		printf("<a class=edit href=%s?page=%ld&resourceform=edit&edit=%ld>",
			GetCgiName().c_str(),web -> GetMenuResource(),x.num);
	printf("&nbsp;%s&nbsp;",htmlcolor(x.name));
	if (bLink)
		printf("</a>");
	printf("&nbsp;|&nbsp;<font color=#ffffff>%ld</font>&nbsp;",x.num);
	if (bTd)
		printf("</td>");
}


long BaseForm::AddPic(long num,const string &filename)
{
	db::Pic pic(GetDatabase(),num);
	size_t x = 0;
	for (size_t i = 0; i < filename.size(); i++)
		if (filename[i] == '.')
			x = i + 1;
	strcpy(pic.ext,filename.c_str() + x);
	pic.save();
	{
		Query q(GetDatabase());
		vector<string> sv;
		string query;
		Base64 bomb;
		char slask[100];
		bomb.encode_from_file( (char *)filename.c_str(),sv);
		query = "update pic set pic='";
		for (vector<string>::iterator it = sv.begin(); it != sv.end(); it++)
		{
			query += *it;
			query += '\n';
		}
		sprintf(slask,"' where num=%ld",pic.num);
		query += slask;
		q.execute( (char *)query.c_str());
	}
	return pic.num;
}


} // namespace cgi


