/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _CGI_BASEFORM_H
#define _CGI_BASEFORM_H


namespace cgi
{


enum {
	VALUE_WHATEVER = 0,
	VALUE_IS_MOB,
	VALUE_IS_OBJ,
	VALUE_IS_ROOM,
	VALUE_IS_ZONE
};


class BaseForm : public WebForm
{
public:
	BaseForm(Web *,const string &);
	virtual ~BaseForm();

	Database *GetDatabase();
	long GetStart();
	long GetAntal();
	long GetZone();
	long GetRace();
	long GetClass();
	long GetObjtype();
	long GetMaterial();

	char *htmlcolor(const string &);
	char *nocolor(const string &);
	void textarea(const string &,const string &,const string &,bool = false);
	long asciiconvert(const string &);
	void inputnum(const string &,const string &,long,int = VALUE_WHATEVER);
	void SetColor(const string &str) { m_strColor = str; }
	void inputselect(Query &,const string &,const string &,const string &,long,bool = false);
	void inputstr(const string &,const string &,int size,const string &,bool = false);
	void inputsubmit(const string &);
	void inputbit(Query &q,const string &title,const string &name,const string &query,long flags,int brk,bool radio = false);
	void inputdie(const string &title,const string &name,long,long);
	void inputcheck(const string &title,const string &name,bool);
	void ShowMob(db::Mob &,bool = false,bool = false);
	void ShowObj(db::Obj &,bool = false,bool = false);
	void ShowRoom(db::Room &,bool = false,bool = false,bool = false);
	void ShowZone(db::Zone &,bool = false,bool = false);
	void ShowVirtual(db::Vzone &,bool = false,bool = false,bool = false);
	void ShowRace(db::Race &,bool = false,bool = false);
	void ShowWeapon(db::Weapon &,bool = false,bool = false);
	void ShowSkill(db::Skill &,bool = false,bool = false);
	void ShowResource(db::Resource &,bool = false,bool = false);

	long EditingZone();
	long AddPic(long,const string &);

private:
	string m_strColor;
};


} // namespace cgi


#endif // _CGI_BASEFORM_H

