//////////////////////////////////////////////////////////////
//Wolfshade MUD server
//Copyright (C) 1999 Demetrius and John Comes
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//////////////////////////////////////////////////////////////
/*
*
*  CCharIntermediate
*
*
*
*/

#include "stdinclude.h"
#ifdef PRAGMAHDRSTOP
#pragma hdrstop
#endif
#include <arpa/telnet.h>
// Database includes
#include <mysql/mysql.h>
#include <libsql++.h>
#include <libwolfshade.h>
//
//#include "CRandom.h"
//#include "MySocket.h"
#ifndef _WOLFSHADE_WINDOWS_
#include <sys/socket.h>
#include <sys/types.h>
#include <errno.h>
#endif
#include "affect.h"
#include "main.h"
#include "CMobManager.h"
#include "CGame.h"

#include "CCharIntermediate.h"

#define NOT_ALLOWED_NAMES "files/namesnotallowed.txt"
#define NUM_OF_BONUS 3
#define TITLESCREEN "files/titlescreen.txt"
#define CTITLESCREEN "files/ansititlescreen.txt"

//#define DEB(x) x; fflush(stderr);
#define DEB(x)


MyMap<MyString,bool> CCharIntermediate::NamesNotAllowed;
bool CCharIntermediate::m_bInited = false;
//MyString CCharIntermediate::m_strRaceList;
const int CCharIntermediate::VOID_TIME = (CMudTime::PULSES_PER_REAL_MIN*3);
MyString CCharIntermediate::TitleScreen;
MyString CCharIntermediate::AnsiTitleScreen;


static char off_string[] = 
{
/*
	(char) IAC,
	(char) WILL,
	(char) TELOPT_ECHO,
*/
	(char)  0,
};


static char on_string[] = 
{
/*
	(char) IAC,
	(char) WONT,
	(char) TELOPT_ECHO,
	(char) TELOPT_NAOFFD,
	(char) TELOPT_NAOCRD,
*/
	(char)  0,
};


const char *CCharIntermediate::m_strBonus = 
	"\r\n"
	"a) Strength     \t b) Agility\r\n"
	"c) Luck         \t d) Intelligence\r\n"
	"e) Wisdom       \t f) Charisma\r\n" 
	"g) Constitution \t h) Power:\r\n" 
	"i) Dexterity\r\n" 
	"Letter: ";


//menu

const char * CCharIntermediate::m_strMenu = 
	"\r\n\r\n" 
" &B____________________________________________\r\n" 
"(	&R0.&L  Account Menu&B                     )\r\n"
"(	&R1.&L  Enter Game&B                       )\r\n"
"(	&R2.&L  Change Password&B                  )\r\n"
"(	&R3.&L  Enter Character Description.&B     )\r\n"
"(	&R4.&L  Delete a Character.&B              )\r\n"
" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~&n\r\n";


const bool CCharIntermediate::Matrix[TOTAL_RACES][TOTAL_CLASSES] = 
{
/*NO RACE*/		  {0,0,0,0,0,0,0,0,0,0,0,0,0,0},
/*RACE_TROLL*/		  {0,1,0,0,1,0,0,0,0,0,0,0,0,0},
/*RACE_OGRE*/		  {0,1,0,0,1,0,0,0,0,0,0,0,0,0},
/*RACE_ORC*/		  {0,1,1,1,1,1,0,1,0,1,0,0,0,0},
/*RACE_GNOLL*/		  {0,1,0,0,1,1,0,1,0,1,0,0,0,0},
/*RACE_DUERGAR_DWARF*/	  {0,1,1,0,1,0,0,0,0,1,0,0,0,0},
/*RACE_DROW_ELF*/	  {0,1,1,1,1,0,0,1,0,1,0,0,0,0},
/*RACE_HALF_DROW_ELF*/	  {0,1,1,0,1,0,0,1,0,1,0,0,0,0},
/*RACE_GITHYANKI*/	  {0,1,1,1,1,0,0,1,0,1,0,1,0,0},
/*RACE_DRACONIAN*/	  {0,1,0,1,1,0,0,0,0,1,0,1,0,0},
/*RACE_IMP*/		  {0,1,0,1,1,0,0,0,0,0,0,0,0,0},
/*RACE_GNOME*/		  {0,1,0,1,0,0,0,0,0,0,0,0,1,0},
/*RACE_GREY_ELF*/	  {0,1,1,1,1,1,1,0,1,0,0,0,0,0},
/*RACE_KENDER*/		  {0,1,0,0,1,0,0,0,0,0,0,0,0,0},
/*RACE_MOUNTAN_DWARF*/	  {0,1,1,0,1,0,0,0,1,0,0,0,0,0},
/*RACE_BROWNIE*/	  {0,1,1,1,1,0,1,0,1,0,0,0,1,0},
/*RACE_PIXIE*/		  {0,1,0,1,1,0,0,0,0,0,0,0,1,0},
/*RACE_CENTAUR*/	  {0,1,1,0,1,1,1,0,0,0,0,0,0,0},
/*RACE_SAURIAL*/	  {0,1,0,1,0,0,1,0,1,0,0,0,0,0},
/*RACE_HALF_GREY_ELF*/	  {0,1,1,1,1,1,1,0,1,0,0,0,0,0},
/*RACE_HUMAN*/		  {0,1,1,1,1,1,1,1,1,1,0,0,0,0},
/*RACE_THRIKREEN*/	  {0,1,0,0,0,1,0,0,0,0,0,0,0,0},
/*RACE_MINOTAUR*/	  {0,1,0,1,1,0,0,0,0,0,0,0,0,0},
/*RACE_HALF_ORC*/	  {0,1,1,1,1,1,1,1,1,1,0,0,0,0},
/*RACE_BARBARIAN*/	  {0,1,0,0,1,0,0,0,0,0,0,0,0,0},
/*RACE_KENKU*/		  {0,1,0,1,1,1,0,0,0,0,0,0,0,0},
/*RACE_MUL*/		  {0,1,0,0,1,0,0,0,0,0,0,0,0,0},
/*RACE_ILLITHID*/	  {0,0,0,0,0,0,0,0,0,0,0,0,0,1}
};


/////////////////////////////
// non statics
//create a character intermediate from a description

CCharIntermediate::CCharIntermediate(CGame *pGame,sPlayerDescriptor *desc)
:CCharacterAttributes(pGame)
{
	InitStatics();
	m_nBonus=0;
	m_pDesc = desc;
	m_nTimeSinceLastCmd = 0;
	ChangeState(STATE_TITLE_QUESTION);
}


//////////////////////////////////////////////////////////////////
//Makes a character intermediate from a charintermediate... used to move
//characters to and from q to game
//Only a newly rolled character will get moved to the Que via this
//constructor so we will use it to set up a new character.  Because
//by this time we have the all the data we need to set up a start character
// written 4/6/98
/////////////////////////////////////////////////////////////////

CCharIntermediate::CCharIntermediate(CCharIntermediate *ch)
:CCharacterAttributes(ch)
{
	InitStatics();
	m_nBonus=0;
	m_nTimeSinceLastCmd = 0;
	m_pDesc = ch->m_pDesc;
}


////////////////////////////////////
//	Overloaded CCharIntermediate
//	used if character rents, camps, or
//  dies. 
///////////////////////////////////

CCharIntermediate::CCharIntermediate(CCharacter * pCh)
:CCharacterAttributes(pCh)
{
	InitStatics();
	m_nBonus=0;
	m_nTimeSinceLastCmd = 0;
	m_pDesc = pCh->GetDescriptor();
}


CCharIntermediate::~CCharIntermediate()
{

}


//checks for a command in the command buffer and moves it to the current
//command buffer if need be

bool CCharIntermediate::HasCommand()
{
	int returnat;
	if(m_pDesc->IsPlaying())
	{
		return false;
	}
	else if((returnat = m_pDesc->CommandBuf.Find('\r','\n'))==-1)
	{
		m_nTimeSinceLastCmd++;
		if(m_nTimeSinceLastCmd>=VOID_TIME)
		{
			SendToChar("bye...\r\n");
			ChangeState(STATE_LINK_DEAD);
		}
		return false;
	}
	else
	{
		m_nTimeSinceLastCmd=0;
		if(m_pDesc->IsWritingDescription())
		{
			int nNum;
			if(m_pDesc->CommandBuf.GetLength()>=MAX_LONG_STR)
			{
				SendToChar("Description too long...it will be truncated.\r\n");
				m_strLongDescription = m_pDesc->CommandBuf.Left(MAX_LONG_STR);
				m_pDesc->CommandBuf = m_pDesc->CommandBuf.Right(MAX_LONG_STR);
				SendToChar(m_strMenu);
				ChangeState(STATE_MENU);
			}
			else if((nNum=m_pDesc->CommandBuf.Count('^'))>0)
			{
				int pos = m_pDesc->CommandBuf.Find('^',nNum);
				if(m_pDesc->CommandBuf[pos+1]=='D')
				{
					m_strLongDescription = m_pDesc->CommandBuf.Left(returnat);
					m_pDesc->CommandBuf = m_pDesc->CommandBuf.Right(returnat);
					SendToChar(m_strMenu);
					ChangeState(STATE_MENU);
				}
			}
			return false;
		}
		else
		{
			CurrentCommand = m_pDesc->CommandBuf.Left(returnat);
			CurrentCommand.SkipSpaces();
			m_pDesc->CommandBuf = m_pDesc->CommandBuf.Right(returnat+1);
			return true;
		}
	}
}


void CCharIntermediate::SendToChar(MyString strSend) const
{
	strSend.Colorize(Prefers(PREFERS_COLOR));
	SendToSocket(strSend);
}


/*
void CCharIntermediate::SendToChar(const char *strSend) 
{
	SendToChar(MyString(strSend));
}
*/


////////////////////////////
//	Reads in from a file all the
//	names that are not allowed.
//	written by: Demetrius Comes
//	8-31-98
////////////////////////////

void CCharIntermediate::ReadNotAllowedNames()
{
	FILE *fil;
	MyString strName;
	bool bDummy;
	char slask[200];

	if ((fil = fopen(NOT_ALLOWED_NAMES,"rt")) != NULL)
	{
		fgets(slask,200,fil);
		while (!feof(fil))
		{
			while (strlen(slask) && (slask[strlen(slask) - 1] == 13 || slask[strlen(slask) - 1] == 10))
				slask[strlen(slask) - 1] = 0;
			strName = slask;
			if(!NamesNotAllowed.Lookup(strName,bDummy))
			{
				NamesNotAllowed.Add(strName,true);
			}
			else
			{
				ErrorLog << "Duplicate names in the names not allowed file: " << strName << endl;
			}
			//
			fgets(slask,200,fil);
		}
	}
/*
	ifstream NameFile(NOT_ALLOWED_NAMES,ios::in);
	MyString strName;
	bool bDummy;
	while(NameFile.good())
	{
		NameFile >> strName;
		if(!NamesNotAllowed.Lookup(strName,bDummy))
		{
			NamesNotAllowed.Add(strName,true);
		}
		else
		{
			ErrorLog << "Duplicate names in the names not allowed file: "
				<< strName << endl;
		}
	}
*/
}


//////////////////////////
//	checks to insure name
//  is legal
///////////////////////

bool CCharIntermediate::IsLegalName()
{
	bool bIsLegal = true;
	bool bDummy;
	MyString strToChar;
	for(register int i=0;i<m_strName.GetLength();i++)
	{
		if(m_strName[i] < 65 || m_strName[i] > 122 
			|| (m_strName[i] > 90 && m_strName[i] < 97))
		{
			strToChar = "\r\nNo funky characters in a name.\r\n";
			bIsLegal = false;
		}
		if(!i)
		{
			m_strName[i] = toupper(m_strName[i]);
		}
		else
		{
			m_strName[i] = tolower(m_strName[i]);
		}
	}
	if(m_strName.GetLength()<=2)
	{
		strToChar = "\r\nYour name is not long enough (>2).\r\n";
		bIsLegal = false;
	}
	else if(m_strName.GetLength()>MAX_NAME_SIZE)
	{
		strToChar.Format("\r\nYour name is too long (<=%d)!\r\n",MAX_NAME_SIZE);
		bIsLegal = false;
	}
	else if(NamesNotAllowed.Lookup(m_strName,bDummy)
		|| CMobManager::IsMobName(m_strName))
	{
		strToChar = "\r\nThat name has been disallowed.\r\n";
		bIsLegal = false;
	}
	else if(!(m_strName.GetWordAfter(1).IsEmpty()))
	{
		strToChar = "\r\nA name can only be ONE word!\r\b";
		bIsLegal = false;
	}
	if(!bIsLegal)
	{
		strToChar += "\r\nWhat is Thy Name?";
	}
	SendToChar(strToChar);
	return bIsLegal;
}


void CCharIntermediate::InitStatics()
{
	if(m_bInited)
	{
		return;
	}
	m_bInited = true;
	ReadNotAllowedNames();
	BootFileStrings();
//	MakeRaceList();
}


void CCharIntermediate::MakeRaceList(MyString &str)
{
	MyString strEvils("&LEvils:&n");
	bool evils = false;
	MyString strGoods("&WGoodies: &n");
	bool goodies = false;
	MyString strAlien("&wAlien: &n");
	bool alien = false;
	MyString strNeutral("&wNeutrals: &n");
	bool neutrals = false;
	db::Account acct(GetDatabase(),m_lAccountNum);
	size_t l = strlen(acct.avail_races);
	for(register size_t i = 1;i < TOTAL_PLAYER_RACES;i++)
	if (i < l && acct.avail_races[i] == '1')
	{
		if(cGRR.GetRaceReference(i)->IsRace(CRacialReference::RACE_EVIL))
		{
			strEvils.Format("%s\r\n%3d %-20s",(char *)strEvils,i,GVM.GetColorRaceName(i));
			evils = true;
		}
		else if(cGRR.GetRaceReference(i)->IsRace(CRacialReference::RACE_GOODIES))
		{
			strGoods.Format("%s\r\n%3d %-20s",(char *)strGoods,i,GVM.GetColorRaceName(i));
			goodies = true;
		}
		else if(cGRR.GetRaceReference(i)->IsRace(CRacialReference::RACE_NEUTRAL))
		{
			strNeutral.Format("%s\r\n%3d %-20s",(char *)strNeutral,i,GVM.GetColorRaceName(i));
			neutrals = true;
		}
		else if(cGRR.GetRaceReference(i)->IsRace(CRacialReference::RACE_ALIEN))
		{
			strAlien.Format("%s\r\n%3d %-20s",(char *)strAlien,i,GVM.GetColorRaceName(i));
			alien = true;
		}
	}
	str = "";
	if (evils)
	{
		str += strEvils;
		str += "\r\n";
	}
	if (goodies)
	{
		str += strGoods;
		str += "\r\n";
	}
	if (neutrals)
	{
		str += strNeutral;
		str += "\r\n";
	}
	if (alien)
	{
		str += strAlien;
		str += "\r\n";
	}
/*
	m_strRaceList.Format("%s\r\n%s\r\n%s\r\n%s\r\n",
		(char *)strEvils,(char *)strGoods, 
		(char *)strNeutral, (char *)strAlien);
*/
}


void CCharIntermediate::SendClassList(short nRace)
{
	MyString strClasses = "&WClasses:&n\r\n";
	MyString strTemp;
	for(register int i = 1;i < TOTAL_CLASSES;i++)
	{
		if(Matrix[nRace][i])
		{
			strTemp.Format("%3d %-20s\r\n",i,GVM.GetColorClass(i));
			strClasses += strTemp;
		}
	}
	SendToChar(strClasses);
}


///////////////////////////////////////////////
//BootFileStrings
//Boots MOTD and title screens
//////////////////////////////////////////////

void CCharIntermediate::BootFileStrings()
{	
	CAscii Title(CTITLESCREEN,ios::in /*| ios:: nocreate*/);
	if (Title)
	{
		Title.ReadFileString(AnsiTitleScreen,EOF);
		Title.close();
	}
	else
	{
		ErrorLog << "No Ansi Titlescreen loaded!" << endl;
	}
	CAscii Title2(TITLESCREEN,ios::in /*| ios::nocreate*/);
	if(Title2)
	{
		Title2.ReadFileString(TitleScreen,EOF);
		Title2.close();
	}
	else
	{
		ErrorLog << "No Titlescreen loaded! (Non-Ansi)" << endl;
	}
}


//////////////////////////////
//	Actually calls the write function

void CCharIntermediate::SendToSocket(const MyString &str) const 
{
	MyString tmp = str;

	// prompt logic
	if (!m_pDesc -> m_bDirty)
	{
		m_pDesc -> m_bDirty = true;
		tmp = "\r\n";
		tmp += str;
	}
#ifdef SOCKETSTHREAD
	m_pDesc -> m_lock.Lock();
	m_pDesc -> m_buf += tmp;
	if (!m_pDesc -> m_sent)
	{
		int n = send(m_pDesc -> m_ConnectedSocket, m_pDesc -> m_buf.c_str(), m_pDesc -> m_buf.size(), 0);
		if (n > 0)
		{
			m_pDesc -> m_sent = n;
		}
	}
	m_pDesc -> m_lock.Unlock();
#else
	if(send(m_pDesc->m_ConnectedSocket,(const char *)tmp/*str*/,tmp.GetLength(),0)<0)
	{
#ifdef _WOLFSHADE_WINDOWS_
		if (WSAGetLastError() != WSAEWOULDBLOCK) 
#else
#ifdef EWOULDBLOCK
		if (errno == EWOULDBLOCK)
			errno = EAGAIN;
#endif /* EWOULDBLOCK */
		if (errno != EAGAIN)
#endif //woflshade_windows
		{
			ErrorLog << "Socket " << m_pDesc->m_ConnectedSocket << " bad write for player " << GetName() << endl;
			m_pDesc->ChangeState(STATE_LINK_DEAD);
		}
	}
#endif
}


void CCharIntermediate::SendPassword(db::Account &acct)
{
	FILE *fil;
	char fn[200];
	char sys[200];

	sprintf(fn,"/tmp/acct%ld",acct.num);
	if ((fil = fopen(fn,"wt")) != NULL)
	{
		fprintf(fil,"From: admin@mud.godeaters.net\n");
		fprintf(fil,"To: %s\n",acct.email);
		fprintf(fil,"Subject: Your Account Password\n");
		fprintf(fil,"\n");
		fprintf(fil,"Account Information\n\n");
		fprintf(fil,"\tAccount Name : %s\n",acct.login);
		fprintf(fil,"\tYour Email : %s\n",acct.email);
		fprintf(fil,"\n");
		fprintf(fil,"Your Account Password Is\n\n");
		fprintf(fil,"\t%s\n\n",acct.password);
		fprintf(fil,"Yours Truly\n");
		fprintf(fil," admin@mud.godeaters.net\n");
		fclose(fil);
	}

	sprintf(sys,"cat %s | /usr/sbin/sendmail %s > /dev/null 2>/dev/null",fn,acct.email);
	system( sys );
}


#define NicePrompt(x,y) \
{ \
	MyString bogus = "     &B___________________________&b___&n\r\n&b_&B___/&n   "; \
	bogus.Format("%s&W%s&n %c ",(char *)bogus,x,y); \
	SendToChar( bogus ); \
}


#define NiceToo(x,y) \
{ \
	MyString bogus = "        "; \
	bogus.Format("%s&W%s&n %c ",(char *)bogus,x,y); \
	SendToChar( bogus ); \
}


void CCharIntermediate::ShowAccountMenu()
{
	Query q(GetGame() -> GetDatabase());
	MyString tmp;
	char sql[200];

	NicePrompt("Account Menu",' ');
	SendToChar("\r\n");

//	tmp.Format("\r\n&cCharacter list for Account&n : &W%s&n\r\n\r\n",(char *)m_strAccountName);
//	SendToChar( tmp );

	SendToChar("\r\n&cYour Characters&n\r\n\r\n");
	for (int slot = 1; slot <= 7; slot++)
	{
		sprintf(sql,"select * from player where account=%ld and slot=%d",m_lAccountNum,slot);
		db::Player pl(GetGame() -> GetDatabase(),sql);
		db::Race race(GetDatabase(),pl.race);
		db::Classes pclass(GetDatabase(),pl.pclass);
		db::Mob_sex sex(GetDatabase(),pl.sex);
		MyString tmp;
		if (pl.num)
		{
			while (strlen(pl.name) <= MAX_NAME_SIZE)
				strcat(pl.name," ");
			tmp.Format("&g%4d. &w%s&n %s %s %s\r\n",pl.slot,pl.name,
				sex.name,
				race.name,
				pclass.name);
		}
		else
		{
			tmp.Format("&g%4d.  &l-<free>-&n\r\n",slot);
		}
		SendToChar( tmp );
	}
	SendToChar( "\r\n"
//		"   0. Xyzzy Bogus\r\n"
		"&g   0)&n Leave Game\r\n"
		"\r\n&cAccount Menu Selection&n : ");
}


void CCharIntermediate::SendPrompt(int state)
{
	static const char *strNamesSpeach = "Insure your name is a fantasy, roll playing type name.\r\nIf it isn't please say no and try again.\r\n";
	MyString Info;

	ChangeState( state );

	switch (state)
	{
	case STATE_GET_NAME:
		SendToChar("\r\nWhat is Thy Name?");
		break;
	case STATE_GET_SAVED_PASSWORD:
		SendToChar( off_string );
		SendToChar("\r\nPassword: ");
		break;
	case STATE_CONFIRM_NEW_PLAYER_NAME:
		Info.Format("\r\n%sAre you sure you want to be known as %s? ",
			strNamesSpeach,
			(char *)m_strName);
		SendToChar(Info);
		break;
	case STATE_GET_PASSWORD:
		SendToChar( off_string );
		SendToChar("\r\nPassword: ");
		break;
	case STATE_CONFIRM_NEW_PASSWORD:
		SendToChar( off_string );
		SendToChar("\r\nRetype password for confirmation: ");
		break;
	case STATE_PICK_RACE:
		MakeRaceList( Info );
		SendToChar(Info); //m_strRaceList);
		break;
	case STATE_PICK_CLASS:
		SendClassList( m_pAttributes->GetRace() );
		break;
	case STATE_ROLL_CHAR:
		m_pAttributes->RollNewStats(Info);
		SendToChar(Info);
		break;
	case STATE_PICK_SEX:
		SendToChar("\nAre you male or female (m/f)");
		break;
	case STATE_BONUS:
		SendToChar(m_strBonus);
		break;
	case STATE_KEEP_CHAR:
		SendToChar("\r\nDo you wish to use this character? 'y' ");
		break;
	case STATE_MENU:
		NicePrompt("Player Menu",' ');
		SendToChar("\r\n");
		SendToChar(m_strMenu);
		break;
	case STATE_CHANGE_PASSWORD:
		SendToChar( off_string );
		SendToChar("Please enter your new password: ");
		break;
	case STATE_ENTER_DESCRIPTION:
		Info.Format("Your current description is:\r\n%s\r\nEnter description type ^D (carot shift d) when done.\r\n",
			(char *)m_strLongDescription);
		SendToChar(Info);
		break;
	case STATE_CONFIRM_DELETE:
		SendToChar("\r\nAre you sure?\r\n");
		break;
	case STATE_MOTD:
		SendToChar(MOTD);
		SendToChar("\r\nReturn");
		break;
	case STATE_CHANGE_PASSWORD_CONFIRM:
		SendToChar( off_string );
		SendToChar("\r\nRetype password to confirm: ");
		break;
	case STATE_GET_ACCOUNT:
//		SendToChar("\r\n&cEnter Account Name&n : ");
		NicePrompt("Account Name", ':');
		break;
	case STATE_CONFIRM_NEW_ACCOUNT_NAME:
		Info.Format("\r\n&cCreate a New Account named '&w%s&c'?&n ",
			(char *)m_strAccountName);
		SendToChar( Info );
		break;
	case STATE_GET_EMAIL:
		SendToChar("\r\n&cTo receive your Account Password, Please&n"
			"\r\n&cEnter Your Valid Email Address&n : ");
		break;
	case STATE_ACCOUNT_MENU:
		ShowAccountMenu();
		break;
	case STATE_ACCOUNT_PASSWORD:
		SendToChar( off_string );
		SendToChar("\r\n&cEnter Account Password&n : ");
//		NiceToo("Account Password", ':');
		break;
	case STATE_CREATE_PLAYER_QUESTION:
		SendToChar("\r\n&cThere is no character at that slot. Do you wish to create one?&n ");
		break;
	case STATE_NEW_NAME_QUESTION:
		SendToChar("\r\n&cEnter the name for your new character&n : ");
		break;
	}
}


//handles the player when he/she is at the title screen

void CCharIntermediate::StateTitle()
{
	switch(CurrentCommand[0])
	{
		case 'n': case 'N':
			m_nPreference&=~PREFERS_COLOR;
			SendToChar(TitleScreen);
			break;
		default:
			m_nPreference|=PREFERS_COLOR;
			SendToChar(AnsiTitleScreen);
			break;
	}
	SendPrompt( STATE_GET_ACCOUNT );
//	SendPrompt( STATE_GET_NAME );
}


//handles the player when he/she is at get Name prompt

void CCharIntermediate::StateGetName()
{
	m_strName = CurrentCommand;
	if(IsLegalName())
	{
		//is player saved?
		if(IsPlayerSaved())
		{
			SendPrompt( STATE_GET_SAVED_PASSWORD );
			return;
		}
		SendPrompt( STATE_CONFIRM_NEW_PLAYER_NAME );
	}	
}


//handles the player when he/she is at confirm name prompt for new characters

void CCharIntermediate::StateConfirmName()
{
	switch(CurrentCommand[0])
	{
		case 'n': case 'N':
			SendToChar("\r\nWhat is it then?\r\n");
			SendPrompt( STATE_NEW_NAME_QUESTION ); //STATE_GET_NAME );
			break;
		case 'y': case 'Y':
			SendPrompt( STATE_PICK_RACE ); //GET_PASSWORD );
			break;
		default:
			SendToChar("\r\ny or n please! \r\n");
			break;
	}
}


//handles the player when he/she is at get pass word prompt

void CCharIntermediate::StateGetPassWord()
{
	SendToChar( on_string );
	m_strPassword = CurrentCommand;
	SendPrompt( STATE_CONFIRM_NEW_PASSWORD );
}


//handles the player when he/she is at confirm pass word for new characters

void CCharIntermediate::StateConfirmPassword()
{
	SendToChar( on_string );
	if(CurrentCommand==m_strPassword)
	{
		SendToChar("\r\nEntering new character generation\r\n");
		SendPrompt( STATE_PICK_RACE );
	}
	else
	{
		SendToChar("\nPasswords don't match... bye!");
		ChangeState(STATE_LINK_DEAD);
		m_pDesc->CommandBuf = "\r\n";
	}
}


//handles the player when he/she is at race class prompt

void CCharIntermediate::StatePickRace()
{
	MyString Info;
	short int Num = CurrentCommand.MakeInt();
	db::Account acct(GetDatabase(),m_lAccountNum);
	size_t l = strlen(acct.avail_races);
	if(Num<=0 || Num>=TOTAL_PLAYER_RACES || (size_t)Num >= l || acct.avail_races[Num] != '1')
	{
		SendToChar("That's not a choice!\r\n");
		SendPrompt( STATE_PICK_RACE );
		return;
	}
	m_pAttributes->SetRace(Num); 
	Info.Format("You will be a %s.\r\n\r\n",
		GVM.GetColorRaceName(m_pAttributes->GetRace()));
	m_lPlayerSetHomeTown = m_lLastRentRoom = m_pAttributes->GetHomeTown();
	SendToChar(Info);
	SendPrompt( STATE_PICK_CLASS );
}


//handles the player when he/she is at race class prompt

void CCharIntermediate::StatePickClass()
{
	MyString Info;
	short int Num = CurrentCommand.MakeInt();
	if(Num==-1 || Num>=TOTAL_CLASSES || (!Matrix[GetRace()][Num]))
	{
		SendToChar("That's not a choice!\r\n");
		SendPrompt( STATE_PICK_CLASS );
		return;
	}
	m_pAttributes->SetClass(Num);
	Info.Format("You will be a %s.\r\n\r\n",
		GVM.GetClassName(m_pAttributes->GetClass()));
	SendToChar(Info);
	if(m_pAttributes->GetRace()==RACE_ILLITHID)
	{
		m_pAttributes->SetSex(NONE);
		SendPrompt( STATE_ROLL_CHAR );
	}
	else
	{
		SendPrompt( STATE_PICK_SEX );
	}
}


//handles the player when he/she is at pick sex prompt

void CCharIntermediate::StatePickSex()
{
	MyString Info;
	switch(CurrentCommand[0])
	{
	case 'm':case 'M':
		m_pAttributes->SetSex(MALE);
		SendPrompt( STATE_ROLL_CHAR );
		break;
	case 'f':case 'F':
		m_pAttributes->SetSex(FEMALE);
		SendPrompt( STATE_ROLL_CHAR );
		break;
	default:
		SendToChar("m or f please!\r\n");
		SendPrompt( STATE_PICK_SEX );
		break;
	}
}


//handles the player when he/she is at roll character prompt

void CCharIntermediate::StateRollChar()
{
	MyString Info;
	switch(CurrentCommand[0])
	{
	case 'n': case 'N':
		SendPrompt( STATE_BONUS );
		m_nAlignment = m_pAttributes->GetStartingAlignment();
		m_nMovePts = m_nMaxMovePts = m_pAttributes->GetStartingMoves();
		m_nManaPts = m_nMaxManaPts = m_pAttributes->GetStartingMana();
		break;
	default:
		SendPrompt( STATE_ROLL_CHAR );
		break;
	}
}


///////////////////////////
//	Allows the player to do bonus
//	to attributes
//////////////////////////

#define ATT_RANGE(a,b) (((m_pAttributes->BaseStats[a] + b) <= 100) ? (m_pAttributes->BaseStats[a] + b) : 100)

void CCharIntermediate::StateBonus()
{
	short nBonus = DIE(7)+3;
	switch(tolower(CurrentCommand[0]))
	{
	case 'a':
		//check for max!
		m_pAttributes->AffectedStats[STR] = 
			m_pAttributes->BaseStats[STR]=ATT_RANGE(STR,nBonus);
		break;
	case 'b':
		m_pAttributes->AffectedStats[AGI] = 
			m_pAttributes->BaseStats[AGI]=ATT_RANGE(AGI,nBonus);
		break;
	case 'c':
		m_pAttributes->AffectedStats[LUCK] = 
			m_pAttributes->BaseStats[LUCK]=ATT_RANGE(LUCK,nBonus);
		break;
	case 'd':
		m_pAttributes->AffectedStats[INT] = 
			m_pAttributes->BaseStats[INT]=ATT_RANGE(INT,nBonus);
		break;
	case 'e':
		m_pAttributes->AffectedStats[WIS] = 
			m_pAttributes->BaseStats[WIS]=ATT_RANGE(WIS,nBonus);
		break;
	case 'f':
		m_pAttributes->AffectedStats[CHA] = 
			m_pAttributes->BaseStats[CHA]=ATT_RANGE(CHA,nBonus);
		break;
	case 'g':
		m_pAttributes->AffectedStats[CON] = 
			m_pAttributes->BaseStats[CON]=ATT_RANGE(CON,nBonus);
		break;
	case 'h':
		m_pAttributes->AffectedStats[POW] = 
			m_pAttributes->BaseStats[POW]=ATT_RANGE(POW,nBonus);
		break;
	case 'i':
		m_pAttributes->AffectedStats[DEX] = 
			m_pAttributes->BaseStats[DEX]=ATT_RANGE(DEX,nBonus);
		break;
	default:
		SendToChar("\r\nThat is not an attribute.\r\n");
		SendPrompt( STATE_BONUS );
		return;
	}
	MyString Info;
	m_pAttributes->GetStatMessage(Info);
	if(++m_nBonus>=NUM_OF_BONUS)
	{
		Info.Format("\r\nYour final stats are:\r\n%s\r\n",
			(char *)Info);
		SendToChar(Info);
		SendPrompt( STATE_KEEP_CHAR );
		m_nBonus=0;
	}
	else
	{
		Info.Format("\r\nYour stats are now\r\n%s\r\nBonus:\r\n %s",
			(char *)Info,m_strBonus);
		SendToChar(Info);
	}
}


//handles the player when he/she see motd

void CCharIntermediate::StateMOTD()
{
	SendPrompt( STATE_ACCOUNT_MENU );
}


//handles the player when he/she is at menu

void CCharIntermediate::StateMenu()
{
	MyString strToChar;
	switch(CurrentCommand.MakeInt())
	{
	case 0:
		SendPrompt( STATE_ACCOUNT_MENU );
//		SendToChar("Bye\r\n");
//		ChangeState(STATE_LINK_DEAD);
		break;
	case 1:
		ChangeState(STATE_PLAYING);
		break;
	case 2:
		SendPrompt( STATE_CHANGE_PASSWORD );
		break;
	case 3:
		SendPrompt( STATE_ENTER_DESCRIPTION );
		break;
	case 4:
		SendPrompt( STATE_CONFIRM_DELETE );
		break;
	default:
		SendPrompt( STATE_MENU );
		break;
	}
}


/////////////////////////////////////
//	Handles if we find a character saved
//	or currently in the game and link dead
//	written by: Demetrius Comes
//	6/5/98
/////////////////////////////////////

void CCharIntermediate::StateGetSavedPassword()
{
	CCharacter *pCh;
	// echo on
	SendToChar( on_string );
	//are they currently playing
	if((pCh = GVM.FindCharacter(m_strName,NULL))
		&& !pCh->IsNPC())
	{
		if(CurrentCommand==pCh->GetPassword())
		{
			if(pCh->IsLinkDead())
			{
				pCh->SetDescriptor(m_pDesc);
				pCh->SendToChar("You take over your body again! =)\r\n");
				ChangeState(STATE_KILL_INTERMEDIATE);
			}
			else
			{
				SendToChar("That character is already playing.\r\n");
				ChangeState(STATE_LINK_DEAD);
			}
		}
		else
		{
			SendToChar("Passwords don't match!\r\n");
			ChangeState(STATE_LINK_DEAD);
		}
	}
	else 
	{
		//do passwords match saved?
		if(CurrentCommand==m_strPassword)
		{
			SendPrompt( STATE_MOTD ); // unused state - ignore this
		}
		else
		{
			SendToChar("Passwords don't match!\r\n");
			ChangeState(STATE_LINK_DEAD);
		}
	}
}


void CCharIntermediate::StateKeepChar()
{
	switch(tolower(CurrentCommand[0]))
	{
	case 'n':
		SendToChar("\r\nResetting character...\r\n");
		SendPrompt( STATE_PICK_RACE );
		break;
	default:
		SendToChar("Yup, it's a keeper! \r\n");
		{
			// create player record in DB
			Query q(GetGame() -> GetDatabase());
			MyString sql;
			char slask[256];
			strncpy(slask,(char *)m_strName,255);
			q.safestr(slask);
			sql.Format("select * from player where name='%s'",slask);
			db::Player pl(GetGame() -> GetDatabase(),sql);
			strncpy(pl.name,(char *)m_strName,255);
			pl.account = m_lAccountNum;
			pl.slot = m_nSlot;
			pl.race = m_pAttributes -> GetRace();
			pl.pclass = m_pAttributes -> GetClass();
			pl.sex = m_pAttributes -> GetSex();
			pl.save();
		}
		// to player menu
		SendPrompt( STATE_MENU );
		break;
	}
}


void CCharIntermediate::StateConfirmDeletion()
{
	if(CurrentCommand.Compare("yes"))
	{
		Query q(GetDatabase());
		char sql[200];
		char slask[200];
		strcpy(slask,(char *)m_strName);
		q.safestr(slask);
		sprintf(sql,"delete from player where account=%ld and name='%s'",m_lAccountNum,slask);
		q.execute(sql);
		DeleteChar();
		SendToChar("\r\nYour character has been deleted.\r\n");
//		ChangeState(STATE_LINK_DEAD);
		SendPrompt( STATE_ACCOUNT_MENU );
	}
	else
	{
		SendToChar("You must type 'yes' to delete your character.\r\n");
		SendPrompt( STATE_MENU );
	}
}


/////////////////////////////////
//	Allows player to change password

void CCharIntermediate::StateChangePassword()
{
	SendToChar( on_string );
	m_strPassword = CurrentCommand;
	SendPrompt( STATE_CHANGE_PASSWORD_CONFIRM );
}


/////////////////////////////////
//	Checks to see if they have typed the same password twice

void CCharIntermediate::StateConfirmPasswordChange()
{
	SendToChar( on_string );
	if(m_strPassword==CurrentCommand)
	{
		if(!SaveToFile(false))
		{
			SendToChar("You must enter the game at least once before changing your password.\r\n");
		}
		else
			SendToChar("\r\nYour password has been changed.\r\n");
	}
	else
	{
		SendToChar("The passwords do not match.\r\nYOUR PASSWORD HAS NOT BEEN CHANGED!\r\n");
		if(!IsPlayerSaved())
		{
			ErrorLog << "CRITICAL ERROR: " << m_strName << " was not in saved player list through they tried to change password.\r\n";
			SendToChar("Error with your player file, please notify a god.\r\n");
			ChangeState(STATE_LINK_DEAD);
			return;
		}
	}
	SendPrompt( STATE_MENU );
}


void CCharIntermediate::StateGetAccount()
{
	Query q(GetGame() -> GetDatabase());
	MyString sql;
	char slask[256];

	m_strAccountName = CurrentCommand;
	strncpy(slask,(char *)m_strAccountName,255);
	q.safestr(slask);
	sql.Format("select * from account where login='%s'",slask);
	db::Account acct(GetGame() -> GetDatabase(),(char *)sql);
	if (!acct.num)
	{
		SendToChar("\r\n&rAccount Does Not Exist&n");
		SendPrompt( STATE_CONFIRM_NEW_ACCOUNT_NAME );
	}
	else
	{
		SendPrompt( STATE_ACCOUNT_PASSWORD );
	}
}


void CCharIntermediate::StateConfirmNewAccountName()
{
	switch (CurrentCommand[0])
	{
	case 'y':
	case 'Y':
		SendPrompt( STATE_GET_EMAIL );
		break;
	default:
		SendToChar("\r\nOk.\r\n");
		SendPrompt( STATE_GET_ACCOUNT );
	}
}


bool CCharIntermediate::ValidEmail(char *email)
{
	// bad shell characters
	if (strstr(email," "))
		return false;
	if (strstr(email,";"))
		return false;
	if (strstr(email,"<"))
		return false;
	if (strstr(email,">"))
		return false;
	if (strstr(email,"'"))
		return false;
	if (strstr(email,"`"))
		return false;
	if (strstr(email,"*"))
		return false;
	// a very limited sanity check
	char *s = strstr(email,"@");
	if (!s)
		return false;
	if (!strstr(s + 1,"."))
		return false;
	return true;
}


void CCharIntermediate::StateGetEmail()
{
	if (!ValidEmail( (char *)CurrentCommand))
	{
		SendPrompt( STATE_GET_EMAIL );
		return;
	}
	db::Account acct(GetGame() -> GetDatabase());
	int l = 8 + random() % 4;
	char password[20];
	char *randomstr = "0123456789abcdefghijklmnopqrstuvwxyz0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
	for (int i = 0; i < l; i++)
		sprintf(password + i,"%c",randomstr[random() % strlen(randomstr)]);
	strncpy(acct.login, (char *)m_strAccountName, 39);
	strcpy(acct.password, password);
	strncpy(acct.email, (char *)CurrentCommand, 255);
	acct.save();
	SendPassword( acct );
	m_lAccountNum = acct.num;
	SendPrompt( STATE_ACCOUNT_MENU );
}


void CCharIntermediate::StateAccountMenu()
{
	int selection = atoi((char *)CurrentCommand);

	if (CurrentCommand[0] == 'x' ||
		CurrentCommand[0] == 'X')
	{
		SendToChar("\r\n&GBye, bye...&n\r\n\r\n");
		ChangeState(STATE_LINK_DEAD);
	}
	else
	if (isdigit(CurrentCommand[0]))
	{
/*
		// old character name entry
		if (!selection)
			SendPrompt( STATE_GET_NAME );
		else
*/
		if (!selection)
		{
			SendToChar("\r\n&GBye, bye...&n\r\n\r\n");
			ChangeState(STATE_LINK_DEAD);
		}
		else
		if (selection > 0 && selection <= 7)
		{
			MyString sql;
			sql.Format("select * from player where account=%ld and slot=%d",m_lAccountNum,selection);
			db::Player pl(GetGame() -> GetDatabase(),(char *)sql);
			if (pl.num)
			{
				m_strName = pl.name;
				if(IsLegalName())
				{
					//is player saved?
					if(IsPlayerSaved())
					{
						m_nSlot = selection;
						SendPrompt( STATE_MENU ); //STATE_GET_SAVED_PASSWORD );
						return;
					}
				}
			}
			else
			{
				SendPrompt( STATE_CREATE_PLAYER_QUESTION );
				m_nSlot = selection;
				return;
			}
			SendPrompt( STATE_ACCOUNT_MENU );
		}
		else
		{
			SendToChar("\r\n&rHuh?\r\n");
			SendPrompt( STATE_ACCOUNT_MENU );
		}
	}
	else
	{
		SendToChar("\r\n&rHuh?\r\n");
		SendPrompt( STATE_ACCOUNT_MENU );
	}
}


void CCharIntermediate::StateAccountPassword()
{
	Query q(GetGame() -> GetDatabase());
	MyString sql;
	char slask[256];
	char password[256];

	SendToChar( on_string );

	strncpy(slask,(char *)m_strAccountName,255);
	q.safestr(slask);
	strncpy(password,(char *)CurrentCommand,255);
	q.safestr(password);
	sql.Format("select * from account where login='%s' and password='%s'",slask,password);
	db::Account acct(GetGame() -> GetDatabase(),(char *)sql);
	if (!acct.num)
	{
		SendToChar("\r\n&rBad Login.&n\r\n");
		ChangeState(STATE_LINK_DEAD);
	}
	else
	{
		m_lAccountNum = acct.num;
		SendPrompt( STATE_MOTD ); //STATE_ACCOUNT_MENU );
	}
}


void CCharIntermediate::StateCreatePlayerQuestion()
{
	if (CurrentCommand[0] == 'y' ||
		CurrentCommand[0] == 'Y')
	{
		SendToChar("\r\n&GGreat!&n\r\n");
		SendPrompt( STATE_NEW_NAME_QUESTION );
		// %! do a better reset of char attrs here
		Reset(); // now it's better
	}
	else
	{
		SendToChar("\r\n&gOkidoki.&n\r\n");
		SendPrompt( STATE_ACCOUNT_MENU );
	}
}


void CCharIntermediate::StateNewNameQuestion()
{
	m_strName = CurrentCommand;
	if(IsLegalName())
	{
		//is player saved?
		if(IsPlayerSaved())
		{
			SendToChar("\r\n&rPlayer already exists.&n\r\n");
			SendPrompt( STATE_ACCOUNT_MENU );
			return;
		}
		SendPrompt( STATE_CONFIRM_NEW_PLAYER_NAME );
	}
}


//init our array of function pointers
// I would have like to make this a member variable
// of CCharIntermediate but can't seem to get the syntax right.
// anyone know how?

void (CCharIntermediate::*StateFnc[])()=
{
	&CCharIntermediate::StateTitle,
	&CCharIntermediate::StateGetName,
	&CCharIntermediate::StateConfirmName,
	&CCharIntermediate::StateGetPassWord,
	&CCharIntermediate::StateConfirmPassword,
	&CCharIntermediate::StatePickRace,
	&CCharIntermediate::StatePickClass,
	&CCharIntermediate::StatePickSex,
	&CCharIntermediate::StateRollChar,
	&CCharIntermediate::StateBonus,
	&CCharIntermediate::StateMOTD,
	&CCharIntermediate::StateMenu,
	&CCharIntermediate::StateGetSavedPassword,
	&CCharIntermediate::StateKeepChar,
	&CCharIntermediate::StateConfirmDeletion,
	&CCharIntermediate::StateChangePassword,
	&CCharIntermediate::StateConfirmPasswordChange,
	&CCharIntermediate::StateGetAccount,
	&CCharIntermediate::StateConfirmNewAccountName,
	&CCharIntermediate::StateGetEmail,
	NULL,
	&CCharIntermediate::StateAccountMenu,
	&CCharIntermediate::StateAccountPassword,
	&CCharIntermediate::StateCreatePlayerQuestion,
	&CCharIntermediate::StateNewNameQuestion

};


//executes command

void CCharIntermediate::ExecuteState()
{
	char *statext[] = {
"StateTitle",
"StateGetName",
"StateConfirmName",
"StateGetPassWord",
"StateConfirmPassword",
"StatePickRace",
"StatePickClass",
"StatePickSex",
"StateRollChar",
"StateBonus",
"StateMOTD",
"StateMenu",
"StateGetSavedPassword",
"StateKeepChar",
"StateConfirmDeletion",
"StateChangePassword",
"StateConfirmPasswordChange",
"StateGetAccount",
"StateConfirmNewAccountName",
"StateGetEmail",
"<playing>",
"StateAccountMenu",
"StateAccountPassword",
"StateCreatePlayerQuestion",
"StateNewNameQuestion","",""};
DEB(
	fprintf(stderr,"receiving cmdline for state %d: %s\n",m_pDesc->GetState(),statext[m_pDesc->GetState()]);
)

	(this->*StateFnc[m_pDesc->GetState()])();
}



