/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "stdinclude.h"
// Database includes
#include <mysql/mysql.h>
#include <libsql++.h>
#include <libwolfshade.h>
//
#include "CRoom.h"
#include "CMobManager.h"
#include "CObjectManager.h"
#include "CGame.h"
#include "CFightTimer.h"

//#define DEB(x) x; fflush(stdout);
#define DEB(x)


CFightTimer::CFightTimer(CGame *pGame,CTimerFactory *fac,CMobManager *pMobManager,CCharacter *pAtt,CCharacter *pDef,long pulses)
:CTimer(fac, pulses)
,m_pAttacker(pAtt)
,m_pDefender(pDef) 
,m_pMobManager(pMobManager)
,m_pGame(pGame)
{
//	fprintf(stderr,"CFightTimer()\n");
}


CFightTimer::~CFightTimer()
{
//	fprintf(stderr,"~CFightTimer()\n");
}


void CFightTimer::Run()
{
DEB(printf("CFightTimer::Run()\n");)
	//are we fighting and can we fight
	if ( /*(m_pDefender = m_pAttacker -> IsFighting()) != NULL &&*/
		m_pAttacker -> CanFight() &&
		!m_pDefender -> IsDead() &&
		m_pAttacker -> IsInRoom(m_pDefender) )
	{
		//if are defender isn't fighting
		//and not in the fightLL make him fight
		if (!IsFighting(m_pDefender) && // -> IsFighting() &&
			m_pDefender -> CanFight() /*&&
			!m_FightLL.DoesContain(m_pDefender)*/)
		{
//				m_FightLL.Add(m_pDefender);
			long pulses = 2 * CMudTime::PULSES_PER_REAL_SECOND;
			GetFactory() -> AddTimer(new CFightTimer(m_pGame,GetFactory(),m_pMobManager,m_pDefender,m_pAttacker,pulses));
			m_pDefender -> AssertFighting(m_pAttacker);
		}

		//Add memory for NPC's and track target
		m_pAttacker -> AddMemory(m_pDefender);

		//attack target
		m_pAttacker -> Attack();

		//check for autoflee
		m_pDefender -> DoAutoFlee();

		//if you can't fight stop fighting
		if (!m_pAttacker -> CanFight() || 
			!IsFighting(m_pAttacker) || // -> IsFighting() ||
			!m_pAttacker -> IsInRoom(m_pDefender))
		{
DEB(printf(" m_pAttacker -> AssertFighting(NULL)\n");)
			m_pAttacker -> AssertFighting(NULL);
			//must remove them from LL other wise
			//KillChar calls stopallfromfighting
			//and that will remove them from LL with
			//OUT having the position variable!
//				m_FightLL.Remove(m_pAttacker,pos);
			KillTimer();
			//if your dead from you from LL and kill you
			//KillChar set all characters fighting you to
			//assertfighting(NULL)
			if (m_pAttacker -> IsDead())
			{
				KillChar(m_pAttacker);
			}
		}

		//if your defender can't fight stop them from fighting
		if (!m_pDefender -> CanFight() ||
			!IsFighting(m_pDefender) || // -> IsFighting() ||
			!m_pAttacker -> IsInRoom(m_pDefender))
		{
DEB(printf(" m_pDefender -> AssertFighting(NULL)\n");)
			m_pDefender -> AssertFighting(NULL);
			//must remove them from LL other wise
			//KillChar calls stopallfromfighting
			//and that will remove them from LL with
			//OUT having the position variable!
//				m_FightLL.Remove(m_pDefender,pos);
DEB(printf("GetFightTimer(m_pDefender)\n");)
			{
				CFightTimer *tmp = static_cast<CFightTimer *>(GetFightTimer(m_pDefender));
				if (tmp)
					tmp -> KillTimer();
				else
				{
DEB(printf("GetFightTimer() returns NULL\n");)
				}
//			GetFightTimer(m_pDefender) -> KillTimer();
			}
			if (m_pDefender -> IsDead())
			{
DEB(printf("Call KillChar()\n");)
				KillChar(m_pDefender);
			}
		}
	}
	//your not fighting anyone or the person your
	//fighting has left the room.
	else
	{
		m_pAttacker -> AssertFighting(NULL);
//			m_FightLL.Remove(m_pAttacker,pos);
		KillTimer();
	}
DEB(printf("CFightTimer::Run() ok\n");)
}


bool CFightTimer::IsFighting(CCharacter *pCh)
{
	for (timers_t::iterator it = GetList().begin(); it != GetList().end(); it++)
	{
		CFightTimer *tmp = dynamic_cast<CFightTimer *>(*it);
		if (tmp && !tmp -> KillThis() )
		{
			if (tmp -> GetAttacker() == pCh)
				return true;
		}
	}
	return false;
}


CCharacter *CFightTimer::GetAttacker() 
{ 
	return m_pAttacker; 
}


CCharacter *CFightTimer::GetDefender() 
{ 
	return m_pDefender; 
}


CTimer *CFightTimer::GetFightTimer(CCharacter *pCh)
{
	for (timers_t::iterator it = GetList().begin(); it != GetList().end(); it++)
	{
		CFightTimer *tmp = dynamic_cast<CFightTimer *>(*it);
		if (tmp && !tmp -> KillThis() )
		{
			if (tmp -> GetAttacker() == pCh)
				return tmp;
		}
	}
	return NULL;
}


//////////////////////////////////////
//	Kill Character
//	Remove from Room LL
//	Remove from Game LL
//	save char
//	Make a CCharIntermediate setting state to menu
//	Add to MySocket::NotCharYet
//	written by: Demetrius Comes
//	5/19/98
//////////////////////////////////////

void CFightTimer::KillChar(CCharacter * pDeadChar)
{
	//if player is not in a room then thay have already been killed
	if (pDeadChar -> GetRoom() -> DoesContain(pDeadChar))
	{
		m_pGame -> StopAllFromFighting(pDeadChar);
//		long lPos = 0;

		//send death message
		pDeadChar -> GetRoom() -> DeathCry(pDeadChar);

		//now remove from room
		pDeadChar -> GetRoom() -> Remove(pDeadChar);
		pDeadChar -> UpDatePosition(POS_DEAD,false);

		//put save here instead of in DoCharacterCommands
		//that way if we crash after they died there is no
		//chance of the death not saving
		pDeadChar -> SetFuguePlane();

		//add the corpse to the room
		if (pDeadChar -> ShouldMakeCorpse())
		{
			CObject *pObj = new CCorpse(pDeadChar);
			pDeadChar -> GetRoom() -> Add(pObj, false);
			CObjectManager::Add(pObj);
		}
		if (!pDeadChar -> IsNPC())
		{
			pDeadChar -> Save(true);
		}
		else
		{
			m_pMobManager -> ReduceNumberInGame(pDeadChar -> GetVnum());
		}
	}
}


/*
void CFightTimer::StopAllFromFighting(CCharacter *pCh)
{
	for (timers_t::iterator it = GetList().begin(); it != GetList().end(); it++)
	{
		CFightTimer *tmp = dynamic_cast<CFightTimer *>(*it);
		if (tmp && !tmp -> KillThis() )
		{
			if (tmp -> GetDefender() == pCh)
			{
				tmp -> KillTimer();
			}
		}
	}
}
*/


MyString CFightTimer::GetExtra()
{
	MyString tmp;
	tmp.Format("Attacker: %s  Defender: %s",
		(char *)GetAttacker() -> GetName(),
		(char *)GetDefender() -> GetName());
	return tmp;
}



