#include "stdinclude.h"
// Database includes
#include <mysql/mysql.h>
#include <libsql++.h>
#include <libwolfshade.h>
//
#include "CGame.h"
#include "CRoom.h"
#include "CGen.h"

//#define DEB(x) x; fflush(stdout);
#define DEB(x) 


CGen::CGen(CGame *pGame,long xmax,long ymax)
:m_x(xmax)
,m_y(ymax)
,m_pGame(pGame)
,m_vnumstart(0)
,m_bCampable(false)
{
	Query q(GetDatabase());

	m_visit = new bool[xmax * ymax];

	q.get_result("select * from room where virtual_room<>0");
	while (q.fetch_row())
	{
		db::Room *tmp = new db::Room(GetDatabase(),&q);
		CRoom room(GetGame());
		room.ReadRoom(GetDatabase(),*tmp);
		m_room[tmp -> num] = tmp;
		m_VirtualRoom[tmp -> num] = new CRoom(&room);
	}
	q.free_result();

} // constructor


CGen::~CGen()
{
DEB(printf("~CGen()\n");)
	delete m_visit;

DEB(printf("~CGen() 1\n");)
	for (rooms_t::iterator it = m_room.begin(); it != m_room.end(); it++)
	{
		delete (*it).second;
	}
DEB(printf("~CGen() 2\n");)
	for (vrooms_t::iterator it = m_VirtualRoom.begin();
		it != m_VirtualRoom.end(); it++)
	{
DEB(printf("~CGen() delete CRoom\n");)
		delete (*it).second;
	}

DEB(printf("~CGen()...\n");)
} // destructor


Database *CGen::GetDatabase()
{
	return m_pGame -> GetDatabase();
}


CRoom *CGen::GetVirtualRoom(long num)
{
	return m_VirtualRoom[num];
}


db::Room *CGen::GetRoom(long num)
{
	return m_room[num];
}


char CGen::GetAt(sPos &p)
{
	return 0;
}


void CGen::SetAt(sPos &pos,char c)
{
}


long CGen::GetVnum(sPos &pos)
{
	return pos.y * m_x + pos.x + m_vnumstart;
}


long CGen::GetVnumStart()
{
	return m_vnumstart;
}


void CGen::SetVnumStart(long x)
{
	m_vnumstart = x;
}


long CGen::GetVnumEnd()
{
	return m_vnumstart + m_x * m_y;
}


CGen::sPos CGen::GetPosFromVnum(long vnum)
{
	sPos pos(m_x,m_y,1);
	pos.x = (vnum - GetVnumStart()) % m_x;
	pos.y = (vnum - GetVnumStart()) / m_x;
	return pos;
}


bool CGen::visited(sPos &pos)
{
	return m_visit[pos.x + pos.y * m_x];
}


void CGen::SetVisited(sPos &pos)
{
	m_visit[pos.x + pos.y * m_x] = true;
}


void CGen::ClearVisited()
{
	for (int i = 0; i < m_x * m_y; i++)
		m_visit[i] = false;
}


void CGen::Connect(CRoom *pRoom,int dir,CRoom *pToRoom)
{
	pRoom->m_Doors[dir] = new CRoom::sDoor();
	pRoom->m_Doors[dir]->DoorType = 1;
	pRoom->m_Doors[dir]->ToRoom = pToRoom->GetVnum();
	pRoom->m_Doors[dir]->m_pToRoom = pToRoom;
}


void CGen::Connect(CRoom *pRoom,int dir,long vnum)
{
	CRoom *pToRoom;
	pRoom->m_Doors[dir] = new CRoom::sDoor();
	pRoom->m_Doors[dir]->DoorType = 1;
	pRoom->m_Doors[dir]->ToRoom = vnum;
	if (GetGame()->GetWorld()->GetWorldMap().Lookup(vnum,pToRoom))
	{
		pRoom->m_Doors[dir]->m_pToRoom = pToRoom;
		// reverse connect
		int rev = CWorld::ReverseDirection(dir);
		if (pToRoom->m_Doors[rev] && pToRoom->m_Doors[rev]->ToRoom == pRoom->GetVnum() )
		{
			pToRoom->m_Doors[rev]->m_pToRoom = pRoom;
		}
		else
		{
			printf("huh?\n");
//			exit(-1);
		}
	}
}


bool CGen::CanCamp()
{
	return m_bCampable;
}


void CGen::SetCampable(bool x)
{
	m_bCampable = x;
}


// CGen::sPos implementation

bool CGen::sPos::operator==(const sPos &r)
{
	if (x == r.x && y == r.y && z == r.z)
		return true;
	return false;
}


CGen::sPos &CGen::sPos::operator=(const sPos &r)
{
	x = r.x;
	y = r.y;
	z = r.z;
	mx = r.mx;
	my = r.my;
	mz = r.mz;
	return *this;
}


CGen::sPos::sPos(const sPos &p)
{
	x = p.x;
	y = p.y;
	z = p.z;
	mx = p.mx;
	my = p.my;
	mz = p.mz;
}


CGen::sPos::sPos(int xm,int ym,int zm) 
{
	x = y = z = 0;
	mx = xm;
	my = ym;
	mz = zm;
}


CGen::sPos::sPos(const sPos &p,int x0,int y0,int z0)
{
	x = p.x + x0;
	y = p.y + y0;
	z = p.z + z0;
	mx = p.mx;
	my = p.my;
	mz = p.mz;
DEB(	printf("x=%d:%d  y=%d:%d  z=%d:%d\n",x,mx,y,my,z,mz);)
	while (x < 0)
		x += mx;
	while (x >= mx && mx)
		x -= mx;
	while (y < 0)
		y += my;
	while (y >= my && my)
		y -= my;
	while (z < 0)
		z += mz;
	while (z >= mz && mz)
		z -= mz;
}


/*
CGen::sPos CGen::sPos::GetPos(int xo,int yo,int zo)
{
	sPos pos = *this;
	pos.x += xo;
	pos.x = (pos.x < 0) ? pos.x + mx : pos.x;
	pos.x = (pos.x >= mx) ? pos.x - mx : pos.x;
	pos.y += yo;
	pos.y = (pos.y < 0) ? pos.y + my : pos.y;
	pos.y = (pos.y >= my) ? pos.y - my : pos.y;
	pos.z += zo;
	pos.z = (pos.z < 0) ? pos.z + mz : pos.z;
	pos.z = (pos.z >= mz) ? pos.z - mz : pos.z;
	return pos;
}
*/


void CGen::sPos::MoveNorth()
{
	y = !y ? my - 1 : y - 1;
}


void CGen::sPos::MoveSouth()
{
	y = (y + 1 >= my) ? 0 : y + 1;
}


void CGen::sPos::MoveEast()
{
	x = (x + 1 >= mx) ? 0 : x + 1;
}


void CGen::sPos::MoveWest()
{
	x = !x ? mx - 1 : x - 1;
}


bool CGen::sPos::MoveUp()
{
	if (z > 0)
	{
		z--;
		return true;
	}
	return false;
}


bool CGen::sPos::MoveDown()
{
	if (z < mz - 1)
	{
		z++;
		return true;
	}
	return false;
}


// CGen::CArea implementation

CGen::CArea::CArea(class CGen *p):pGen(p) 
{
}


CGen::CArea::~CArea() 
{
}


CGen::CArea &CGen::CArea::operator=(CArea &r)
{
	pos_t::iterator it;
	pGen = r.pGen;
	while ((it = positions.begin()) != positions.end())
		positions.erase(it);
	for (it = r.begin(); it != r.end(); it++)
		positions.insert(positions.end(),*it);
	return *this;
}


CGen::pos_t::iterator CGen::CArea::begin() 
{ 
	return positions.begin(); 
}


CGen::pos_t::iterator CGen::CArea::end() 
{ 
	return positions.end(); 
}


size_t CGen::CArea::size() 
{ 
	return positions.size(); 
}


bool CGen::CArea::InList(sPos &pos)
{
	for (pos_t::iterator it = begin(); it != end(); it++)
	{
		if (*it == pos)
			return true;
	}
	return false;
}


void CGen::CArea::Add(sPos &pos)
{
	pGen -> SetVisited(pos);
	positions.insert(positions.end(),pos);
	{
		sPos pos2(pos);
		pos2.MoveNorth();
		if (pGen -> GetAt(pos2) != 'X' && !pGen -> visited(pos2))
		{
			Add(pos2);
		}
		pos2 = pos;
		pos2.MoveSouth();
		if (pGen -> GetAt(pos2) != 'X' && !pGen -> visited(pos2))
		{
			Add(pos2);
		}
		pos2 = pos;
		pos2.MoveEast();
		if (pGen -> GetAt(pos2) != 'X' && !pGen -> visited(pos2))
		{
			Add(pos2);
		}
		pos2 = pos;
		pos2.MoveWest();
		if (pGen -> GetAt(pos2) != 'X' && !pGen -> visited(pos2))
		{
			Add(pos2);
		}
	}
}


const CGen::sPos &CGen::CArea::GetPosition(int x)
{
	return positions[x];
}



