
#ifndef _CGEN_H
#define _CGEN_H

#include <map>

class CGame;
namespace db { class Room; }
class Database;
class CRoom;


class CGen
{
protected:
  typedef std::map<long,db::Room *> rooms_t;
  typedef std::map<long,CRoom *> vrooms_t;
public:
  struct sPos
  {
  	int x;
  	int y;
  	int z;
  	int mx;
  	int my;
  	int mz;
  	bool operator==(const sPos &r);
	sPos &operator=(const sPos &r);
	sPos(const sPos &p);
	sPos(int xm,int ym,int zm);
	sPos(const sPos &,int,int,int = 0);
//	sPos GetPos(int,int,int);
	void MoveNorth();
	void MoveSouth();
	void MoveEast();
	void MoveWest();
	bool MoveUp();
	bool MoveDown();
  };
protected:
  typedef std::vector<sPos> pos_t;

  class CArea
  {
  public:
  			CArea(class CGen *p);
  			~CArea();
    CArea &		operator = (CArea &r);
    pos_t::iterator 	begin();
    pos_t::iterator 	end();
    size_t		size();
    bool		InList(sPos &pos);
    void		Add(sPos &pos);
    const sPos &	GetPosition(int);

  private:
    CGen *		pGen;
    pos_t		positions;
  };
  typedef std::vector<CArea *> areas_t;

public:
			CGen(CGame *,long,long);
  virtual		~CGen();

  CGame *		GetGame() { return m_pGame; }
  Database *		GetDatabase();
  CRoom *		GetVirtualRoom(long);
  db::Room *		GetRoom(long);

  virtual char		GetAt(sPos &);
  virtual void		SetAt(sPos &,char);
  virtual long		GetVnum(sPos &);
  long			GetVnumStart();
  void			SetVnumStart(long);
  virtual long		GetVnumEnd();
  virtual sPos		GetPosFromVnum(long);
  bool			CanCamp();
  void			SetCampable(bool);

  virtual bool		visited(sPos &);
  virtual void		SetVisited(sPos &);
  virtual void		ClearVisited();
  virtual long		GetSizeX() { return m_x; }
  virtual long		GetSizeY() { return m_y; }
  virtual long		GetSizeZ() { return 1; }
  virtual long		GetSeed() { return 0; }

  void			Connect(CRoom *,int,CRoom *);
  void			Connect(CRoom *,int,long vnum);

protected:
  long			m_x;
  long			m_y;

private:
  CGame *		m_pGame;
  bool *		m_visit;
  rooms_t		m_room;
  vrooms_t		m_VirtualRoom;
  long			m_vnumstart;
  bool			m_bCampable;

};


#endif // _CGEN_H

