/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _CLISTENTHREAD_H
#define _CLISTENTHREAD_H

#include "CThread.h"


class CMutex;
class MySocketsThread;

class CListenThread : public CThread
{
public:
			CListenThread(CGame *,MySocket *,CMutex *,int,int = 1234);
			~CListenThread();

  void			Run();

  bool 			NewConnections();
  void 			NewDescriptor();
  void 			KickOutExceptionSet();

private:
  int			NonBlock(SOCKET);
  //
  SOCKET		ListenSocket;
  CMutex *		m_pMutex;
  struct linger		ld;
  int			m_nPort;
  CGame *		m_pGame;
  int			m_MaxPlayers;
  MySocket *		m_pConnections;
};


#endif // _CLISTENTHREAD
