#ifndef _CNPCMAGE_H
#define _CNPCMAGE_H

#include "CNPC.h"
#include "CMageClass.h"
#include "CMobAIManager.h"

class CNPCMage : public CMage, public CNPC
{
	friend class CMobAIManager<CNPCMage>;
private:
	bool IsGreaterElemental(CCharacter *pCh);
	void DoInit();
protected:
	virtual void DoCast(const CInterp *pInterp, bool bForceCast);
	virtual void DoGeneralAI(const CInterp *pInterp);
	virtual short int CalcACWouldHit() {return CalcACMobWouldHit();}
	virtual bool LostConcentration() {return false;} //mobs don't loose concentration
protected:
	static bool m_bInit;
	static CMobAIManager<CNPCMage> m_MobAI;
	static MyList<const CSpell<CMage> *> m_SpellAI[LVL_IMP+1];
	static const short MAX_GREY_MAGE_FOLLOWERS;
	static const short MAX_GREY_MAGE_MAJOR_ELEMENTALS;
	static const short MIN_MANA_FOR_DEFENSIVE; //%
	static const int DO_DEFENSIVE_AI;
protected:
	bool GeneralDefense();
	bool GeneralOffense();
	bool DoGreyAI(const CInterp *pInterp);
public:
	virtual void DoAI(const CInterp *pInterp);
	CNPCMage(CMobPrototype &mob, CRoom *pPutInRoom);
	virtual ~CNPCMage();
	virtual short GetMaxHitPointsPerLevel();
};

#endif // _CNPCMAGE_H

