/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _CRESETTIMER_H
#define _CRESETTIMER_H




class CResetTimer : public CTimer
{
public:
	CResetTimer(CTimerFactory *fac,CZoneManager *p,CMobManager *p2,CObjectManager *p3)
	:CTimer(fac,CMudTime::PULSES_PER_CHECK_ZONE_RESET)
	,pZoneManager(p)
	,pMobManager(p2)
	,pObjectManager(p3) {}
	~CResetTimer() {}

	void Run() {
		pZoneManager -> ResetZones(false,*pObjectManager,*pMobManager);
	}
	MyString GetType() { return "CResetTimer"; }

private:
	CZoneManager *pZoneManager;
	CMobManager *pMobManager;
	CObjectManager *pObjectManager;
};




#endif // _CRESETTIMER_H

