/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _CRESOURCECHARTIMER_H
#define _CRESOURCECHARTIMER_H

#include "CBaseCharacterTimer.h"
#include "CMessageManager.h"


class CResourceCharTimer : public CBaseCharacterTimer
{
public:
	CResourceCharTimer(CTimerFactory *fac,long pulses,CCharacter *pCh,int skill)
	:CBaseCharacterTimer(fac,pulses,pCh)
	,m_skill(skill)
	,m_state(0) {
		CCharacter::m_MsgManager -> SkillMsg(pCh,NULL,skill,SKILL_KILLED);
	}
	~CResourceCharTimer() {}

	void Run() {
		switch (m_state)
		{
		case 0:
			CCharacter::m_MsgManager -> SkillMsg(GetCharacter(),NULL,m_skill,SKILL_DIDNT_WORK);
			break;
		case 1:
			CCharacter::m_MsgManager -> SkillMsg(GetCharacter(),NULL,m_skill,SKILL_DIDNT_WORK);
			break;
		case 2:
			CCharacter::m_MsgManager -> SkillMsg(GetCharacter(),NULL,m_skill,SKILL_WORKED);
			KillTimer();
			GetCharacter() -> ClearResourceTimer();
			break;
		}
		m_state++;
	}
	MyString GetType() { return "CResourceCharTimer"; }

private:
	CGame *m_pGame;
	int m_skill;
	int m_state;
};




#endif // _CRESOURCECHARTIMER_H

