/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _CRESOURCETIMER_H
#define _CRESOURCETIMER_H

#include "CGame.h"


class CResourceTimer : public CTimer
{
public:
	CResourceTimer(CTimerFactory *fac,CGame *pGame)
	:CTimer(fac,CMudTime::PULSES_PER_REPLENISH_RESOURCES)
	,m_pGame(pGame)
	,m_tick(0) {}
	~CResourceTimer() {}

	void Run() {
		for (rooms_t::iterator it = m_pGame -> GetResourceRooms().begin();
			it != m_pGame -> GetResourceRooms().end(); it++)
		{
			CRoom *pRoom = static_cast<CRoom *>(*it);
			pRoom -> ReplenishResource( m_tick );
		}
		m_tick++;
	}
	MyString GetExtra() {
		MyString tmp;
		tmp.Format("%d rooms",m_pGame -> GetResourceRooms().size());
		return tmp;
	}
	MyString GetType() { return "CResourceTimer"; }

private:
	CGame *m_pGame;
	long m_tick;
};




#endif // _CRESOURCETIMER_H

