/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _CSOCKETSTHREAD_H
#define _CSOCKETSTHREAD_H

#include "CThread.h"

#define MAX_HANDLED 63


class MySocketsThread : public CThread
{
public:
			MySocketsThread();
			~MySocketsThread();

  void			Run();

  void			Add(SOCKET,sPlayerDescriptor *);
  void			Remove(SOCKET);

private:
  sockmap_t		m_sock; // defined as map<SOCKET,sPlayerDescriptor *> in MySocket.h
  fd_set		m_rfds;
  fd_set		m_wfds;
  CMutex		m_lock;
  int			m_n;
  int			m_in;
  int			m_out;
};


#endif // _CSOCKETSTHREAD
