/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _CSPLIT_H
#define _CSPLIT_H


class CSplit
{
public:
			CSplit(const MyString &str) : m_str(new char[str.GetLength() + 1])
			,index(0)
			{
				MyString tmp = str;
				strcpy(m_str,(char *)tmp);
			}
			~CSplit()
			{
				delete m_str;
			}

  int	                GetWord(MyString &str)
  			{
  				MyString tmp = "";
  				bool ignore = false;
  				int l = 0;

  				while (index < strlen(m_str) && (
  					m_str[index] == ' ' ||
  					m_str[index] == 9 ||
  					m_str[index] == 13 ||
  					m_str[index] == 10))
  				{
  					index++;
  				}

  				while (index < strlen(m_str) && 
  					m_str[index] != ' ' &&
  					m_str[index] != 9 &&
  					m_str[index] != 13 &&
  					m_str[index] != 10)
  				{
					tmp.Format("%s%c",(char *)tmp,m_str[index]);
  					if (ignore)
  					{
  						ignore = false;
  					}
  					else
  					{
	  					if (m_str[index] == '&')
	  					{
	  						ignore = true;
	  					}
	  					else
	  					{
	  						l++;
	  					}
  					}
  					index++;
  				}
  				str = tmp;
  				return l;
  			}

private:
  char *		m_str;
  size_t                index;

};


#endif // _CSPLIT_H

