/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _CTHREAD_H
#define _CTHREAD_H


class CThread
{
  typedef void * threadfunc_t;

public:
                        CThread(bool release = true);
  virtual              ~CThread();

  static threadfunc_t   Start(void *);
  virtual void          Run();

  void			Stop();
  bool			Quit() { return m_stop; }

  bool                  IsRunning();
  bool                  IsReleased();
  void                  SetRelease(bool x);

protected:
  void                  SetRunning(bool x);

private:
  pthread_t             m_thread;
  bool                  m_running;
  bool                  m_release;
  bool			m_stop;
};


#endif // _CTHREAD_H

