/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include "stdinclude.h"
#include <vector>
#include <string>
#include "CTimerFactory.h"
#include "CTimer.h"


CTimer::CTimer(CTimerFactory *fac,long lTime,bool bActive /*= true*/)
:m_pFac(fac)
,m_lTime(lTime)
,m_lPulses(lTime)
,m_bActive(bActive)
,m_bKill(false)
{
}


CTimer::~CTimer()
{
}


void CTimer::Tick()
{
	if (m_bActive && !m_bKill)
	{
		m_lPulses--;
		if (!m_lPulses)
		{
			Run();
			m_lPulses = m_lTime;
		}
	}
}


void CTimer::SetTime(long lTime)
{
	m_lTime = lTime;
}


void CTimer::SetActive(bool bActive)
{
	m_bActive = bActive;
}


timers_t &CTimer::GetList()
{
	return m_pFac -> GetList();
}



