/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _CTIMER_H
#define _CTIMER_H


/*
 * Time is in server pulses
 *
 * Use the CMudTime public static variable PULSES_PER_REAL_SECOND to
 * calculate correct number of pulses
*/

class CTimerFactory;

class CTimer
{
public:
			CTimer(CTimerFactory *,long lTime,bool bActive = true);
  virtual		~CTimer();

  void			Tick();
  virtual void		Run() = 0;
  virtual MyString	GetType() = 0;
  virtual MyString	GetExtra() { return ""; }

  void			SetTime(long lTime);
  void			SetActive(bool bActive = true);
  void			KillTimer() { m_bKill = true; }
  bool			KillThis() { return m_bKill; }
  long			GetTicks() { return m_lPulses; }
  long			GetTime() { return m_lTime; }
  bool			IsActive() { return m_bActive; }

protected:
  CTimerFactory *	GetFactory() { return m_pFac; }
  timers_t &		GetList();

private:
  CTimerFactory *	m_pFac;
  long			m_lTime;
  long			m_lPulses; // left
  bool			m_bActive;
  bool			m_bKill;
};


#endif // _CTIMER_H

