/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _CTIMERFACTORY_H
#define _CTIMERFACTORY_H

class CTimer;
typedef std::vector<CTimer *> timers_t;


class CTimerFactory
{
public:
			CTimerFactory();
			~CTimerFactory();

  CTimer *		AddTimer(CTimer *);
  void			RemoveTimer(CTimer *);
  void			Pulse(long);
  void			DeleteTimers();
  timers_t &		GetList();

private:
  timers_t		m_timers;
};


#endif // _CTIMERFACTORY_H

