#include "stdinclude.h"
// Database includes
#include <mysql/mysql.h>
#include <libsql++.h>
#include <libwolfshade.h>
//
#include "CRoom.h"
#include "CGame.h"
#include "CVirtualGen.h"

//#define DEB(x) x; fflush(stdout);
#define DEB(x)


CVirtualGen::CVirtualGen(CGame *pGame,db::Vzone &vzone)
:CGen(pGame,vzone.sizex,vzone.sizey)
,m_z(1)
,m_num(vzone.num)
,m_map(NULL)
{
	char sql[200];

DEB(printf("CVirtualGen()\n");)
	sprintf(sql,"select * from vmap where vzone=%ld and level=0",vzone.num);
DEB(printf("SQL: '%s'\n",sql);)
	m_map = new db::Vmap(pGame -> GetDatabase(),sql);
DEB(printf("m_map: %s\n",m_map ? "OK" : "NULL");)
	SetVnumStart(vzone.vnumstart);

/*
	m_tmp = new char *[m_z];
	for (int i = 0; i < m_z; i++)
	{
		m_tmp[i] = new char[m_x * m_y];
	}
*/
	for (int i = 0; i < 128; i++)
		v[i] = i;

	v['A'] = ' ';
	v['B'] = ' ';
	v['C'] = 'X';
	v['D'] = ' ';
	v['E'] = 'X';
	v['F'] = ' ';
	v['G'] = 'X';

DEB(printf("CVirtualGen() ok\n");)
} // constructor


CVirtualGen::~CVirtualGen()
{
DEB(printf("~CVirtualGen()\n");)
/*
	if (m_tmp)
	{
		for (int i = 0; i < m_z; i++)
			delete m_tmp[i];
		delete m_tmp;
	}
*/
DEB(printf("~CVirtualGen()...\n");)
} // destructor


void CVirtualGen::generate()
{
	sPos pos(m_x,m_y,m_z);
DEB(printf("CVirtualGen::generate()\n");)

	// new generate from vmap
	for (int y = 0; y < m_y; y++)
	{
		pos.y = y;
		for (int x = 0; x < m_x; x++)
		{
			pos.x = x;
			if (GetAt(pos) != 'X')
			{
				int virtvnum = GetAt(pos) - 96; // 'a' == 1
				CRoom *pRoom,*pNewRoom;
				db::Room *room;
DEB(printf(" virtvnum@%d,%d = %d ('%c')\n",x,y,virtvnum,GetAt(pos));)

				if ((pRoom = GetVirtualRoom(virtvnum)) != NULL)
				{
					room = GetRoom(virtvnum);
					pNewRoom = new CRoom(pRoom);
					pNewRoom -> m_nXpos = pos.x;
					pNewRoom -> m_nYpos = pos.y;
					pNewRoom -> m_lVnum = GetVnum( pos );
					pNewRoom -> m_bZoneRoom = false;
					GetGame()->GetWorld()->GetWorldMap().Add(pNewRoom->m_lVnum,pNewRoom);
//					SetVirtualDoors(vz, pNewRoom, pos, vr.exits);
					// Connect North
					if (y > 0)
					{
						sPos pos2(pos);
						pos2.MoveNorth();
						if (GetAt(pos2) != 'X') // null-room
						{
							Connect(pNewRoom, NORTH, GetVnum(pos2));
						}
					}
					// Connect South
					if (y < m_y - 1)
					{
						sPos pos2(pos);
						pos2.MoveSouth();
						if (GetAt(pos2) != 'X')
						{
							Connect(pNewRoom, SOUTH, GetVnum(pos2));
						}
					}
					// Connect East
					if (x < m_x - 1)
					{
						sPos pos2(pos);
						pos2.MoveEast();
						if (GetAt(pos2) != 'X')
						{
							Connect(pNewRoom, EAST, GetVnum(pos2));
						}
					}
					// Connect West
					if (x > 0)
					{
						sPos pos2(pos);
						pos2.MoveWest();
						if (GetAt(pos2) != 'X')
						{
							Connect(pNewRoom, WEST, GetVnum(pos2));
						}
					}
				}
			} // pos != 'X'
		}
	}
DEB(printf("CVirtualGen::generate() ok\n");)
	return;

/*
	// old generate()
	Query q(GetDatabase());
	db::Vzone vz(GetDatabase(),m_num); // Load virtual zone#1
	char sql[200];

	sprintf(sql,"select * from vroom where vzone=%ld order by y,x",vz.num);
	q.get_result(sql);
	while (q.fetch_row())
	{
		db::Vroom vr(GetDatabase(),&q);
		CRoom *pRoom,*pNewRoom;
		sPos pos(m_x,m_y,m_z);
		db::Room *room;

		if ((pRoom = GetVirtualRoom(vr.roomvnum)) != NULL)
		{
			room = GetRoom(vr.roomvnum);
			pNewRoom = new CRoom(pRoom);
//			pNewRoom -> m_lVnum = ((vr.y * vz.sizex) + vr.x) + vz.vnumstart;
			pNewRoom -> m_nXpos = pos.x = vr.x;
			pNewRoom -> m_nYpos = pos.y = vr.y;
			pNewRoom -> m_lVnum = GetVnum( pos );
			pNewRoom -> m_bZoneRoom = false;
			GetGame()->GetWorld()->GetWorldMap().Add(pNewRoom->m_lVnum,pNewRoom);
			SetVirtualDoors(vz, pNewRoom, pos, vr.exits);
			SetAt(pos,*room -> design_char);
		}
	}
	q.free_result();
*/
} // generate


void CVirtualGen::SetVirtualDoors(db::Vzone &vzone, CRoom *pRoom, sPos &pos, int DoorCode)
{
	if (DoorCode==0)
		return;

	assert(pRoom);
	if ((DoorCode & CRoom::VIRTUAL_DOOR_NORTH)==CRoom::VIRTUAL_DOOR_NORTH)
	{
		sPos pos2(pos);
		pos2.MoveNorth();
		Connect(pRoom,NORTH,GetVnum(pos2));
//		pRoom->m_Doors[NORTH] = new CRoom::sDoor();
//		pRoom->m_Doors[NORTH]->DoorType = 1;
//		pRoom->m_Doors[NORTH]->ToRoom = GetVnum(pos2);
/*
		if (pRoom->m_nYpos==0)
			pRoom->m_Doors[NORTH]->ToRoom = 
				(( vzone.sizey -1)* vzone.sizex )+pRoom->m_nXpos;
		else
			pRoom->m_Doors[NORTH]->ToRoom = pRoom->m_lVnum- vzone.sizex ;
*/
	}
	if ((DoorCode & CRoom::VIRTUAL_DOOR_SOUTH)==CRoom::VIRTUAL_DOOR_SOUTH)
	{
		sPos pos2(pos);
		pos2.MoveSouth();
		Connect(pRoom,SOUTH,GetVnum(pos2));
//		pRoom->m_Doors[SOUTH] = new CRoom::sDoor();
//		pRoom->m_Doors[SOUTH]->DoorType = 1;
//		pRoom->m_Doors[SOUTH]->ToRoom = GetVnum(pos2);
/*
		if (pRoom->m_nYpos==( vzone.sizey -1))
			pRoom->m_Doors[SOUTH]->ToRoom = pRoom->m_nXpos+MIN_VIRTUAL_VNUM;
		else
			pRoom->m_Doors[SOUTH]->ToRoom = pRoom->m_lVnum+ vzone.sizex ;
*/
	}
	if ((DoorCode & CRoom::VIRTUAL_DOOR_EAST)==CRoom::VIRTUAL_DOOR_EAST)
	{
		sPos pos2(pos);
		pos2.MoveEast();
		Connect(pRoom,EAST,GetVnum(pos2));
//		pRoom->m_Doors[EAST] = new CRoom::sDoor();
//		pRoom->m_Doors[EAST]->DoorType = 1;
//		pRoom->m_Doors[EAST]->ToRoom = GetVnum(pos2);
/*
		if (pRoom->m_nXpos==( vzone.sizex -1))
			pRoom->m_Doors[EAST]->ToRoom = pRoom->m_lVnum-( vzone.sizex -1);
		else
			pRoom->m_Doors[EAST]->ToRoom = pRoom->m_lVnum+1;
*/
	}
	if ((DoorCode & CRoom::VIRTUAL_DOOR_WEST)==CRoom::VIRTUAL_DOOR_WEST)
	{
		sPos pos2(pos);
		pos2.MoveWest();
		Connect(pRoom,WEST,GetVnum(pos2));
//		pRoom->m_Doors[WEST] = new CRoom::sDoor();
//		pRoom->m_Doors[WEST]->DoorType = 1;
//		pRoom->m_Doors[WEST]->ToRoom = GetVnum(pos2);
/*
		if (pRoom->m_nXpos==0)
			pRoom->m_Doors[WEST]->ToRoom =  vzone.sizex -1;
		else
			pRoom->m_Doors[WEST]->ToRoom = pRoom->m_lVnum-1;
*/
	}
}


void CVirtualGen::display(int z)
{
	sPos pos(m_x,m_y,m_z);
	int i = z;
DEB(printf("display()\n");)

	ClearVisited();
	{
		pos.z = i;
		printf("Level %d\n",i);
		for (int j = 0; j < m_y; j++)
		{
			pos.y = j;
			for (int k = 0; k < m_x; k++)
			{
				pos.x = k;
				if (visited(pos) && GetAt(pos) == ' ')
					printf(".");
				else
					printf("%c",GetAt(pos)); //v[m_tmp[i][j * m_x + k]]);
			}
			printf("\n");
		}
	}
}


char CVirtualGen::GetAt(sPos &p)
{
//	return v[m_tmp[p.z][p.y * m_x + p.x]];
	return m_map -> map[p.y][p.x];
}


void CVirtualGen::SetAt(sPos &pos,char c)
{
//	m_tmp[pos.z][pos.y * m_x + pos.x] = c;
	m_map -> map[pos.y][pos.x] = c;
}



