//////////////////////////////////////////////////////////////
//Wolfshade MUD server
//Copyright (C) 1999 Demetrius and John Comes
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//////////////////////////////////////////////////////////////
/*
*
*  CZone Implemetation
*
*
*/

#include "stdinclude.h"
#ifdef PRAGMAHDRSTOP
#pragma hdrstop
#endif
// Database includes
#include <mysql/mysql.h>
#include <libsql++.h>
#include <libwolfshade.h>
//
#include <stdlib.h>
#include <ctype.h>
#include "CWolfshadeLog.h"
#include "CZone.h"
#include "CGame.h"


CZone::CZone()
:m_nSize(100)
{
	MobCommands.SetDeleteData();
	ObjsToRemove.SetDeleteData();
	RoomObjs.SetDeleteData();
	Doors.SetDeleteData();
	RoomCash.SetDeleteData();
	LifeSpan = -1;
}


void CZone::ReadZone(Database *db,db::Zone &zz)
{
	Query q(db);
	Query q2(db);
	char sql[200];

	ZoneNum = zz.num;
	ZoneName = zz.name;
	LifeSpan = zz.lifespan;
	ResetMode = zz.resetmode;
	m_nSize = zz.size;
fprintf(stderr," zone %d size %d\n",ZoneNum,m_nSize);
/*
 num
 name
 lifespan
 resetmode
 COMMAND c/m/o/g/p/d/r/;(comment)
  -c: baseamt | roomvnum | loadeverytime
  -m: mobvnum | max | roomvnum
  -o: objvnum | max | roomvnum
  -g: objvnum | eqpos
   p: <not implemented>
  -d: roomvnum | direction | doorstate
  -r: roomvnum | objvnum
*/
	sprintf(sql,"select * from zone_c where zone=%d", ZoneNum);
	q.get_result(sql);
	while (q.fetch_row())
	{
		db::Zone_c zc(db,&q);
		sRoomCash *pRoomCash = new sRoomCash();
		pRoomCash->m_lBaseAmt = zc.baseamt;
		pRoomCash->m_lRoomVnum = zc.roomvnum;
		pRoomCash->m_bLoadEveryTime = zc.loadeverytime;
		RoomCash.Add( pRoomCash );
	}
	q.free_result();

	sprintf(sql,"select * from zone_m where zone=%d", ZoneNum);
	q.get_result(sql);
	while (q.fetch_row())
	{
		db::Zone_m zc(db,&q);
		sMobCommands *MobCom = new sMobCommands();
		MobCom->MobVNum = zc.mobvnum;
		MobCom->Max = zc.max;
		MobCom->RoomVNum = zc.roomvnum;
		MobCommands.Add( MobCom );
		// Equip Mob
		sprintf(sql,"select * from zone_g where zone_m=%ld",zc.num);
		q2.get_result(sql);
		while (q2.fetch_row())
		{
			db::Zone_g zg(db,&q2);
			sMobCommands::sMobObj *ObjForMob = new sMobCommands::sMobObj();
			ObjForMob->ObjVnum = zg.objvnum;
			ObjForMob->EqPos = zg.eqpos;
			MobCom->MobObjs.Add( ObjForMob );
		}
		q2.free_result();
	}
	q.free_result();

	sprintf(sql,"select * from zone_o where zone=%d", ZoneNum);
	q.get_result(sql);
	while (q.fetch_row())
	{
		db::Zone_o zc(db,&q);
		sRoomObj *ObjToPutInRoom = new sRoomObj();
		ObjToPutInRoom->ObjVNum = zc.objvnum;
		ObjToPutInRoom->Max = zc.max;
		ObjToPutInRoom->RoomVNum = zc.roomvnum;
		RoomObjs.Add( ObjToPutInRoom );
	}
	q.free_result();

	sprintf(sql,"select * from zone_d where zone=%d", ZoneNum);
	q.get_result(sql);
	while (q.fetch_row())
	{
		db::Zone_d zc(db,&q);
		sDoorFlag *DoorFlags = new sDoorFlag();
		CAscii tmp;
		DoorFlags->RoomVnum = zc.roomvnum;
		DoorFlags->Dir = zc.direction;
		DoorFlags->State = tmp.AsciiConvert( zc.doorstate );
		Doors.Add( DoorFlags );
	}
	q.free_result();

	sprintf(sql,"select * from zone_r where zone=%d", ZoneNum);
	q.get_result(sql);
	while (q.fetch_row())
	{
		db::Zone_r zc(db,&q);
		sObjRemove *RemovalObj = new sObjRemove();
		RemovalObj->RoomVNum = zc.roomvnum;
		RemovalObj->ObjVNum = zc.objvnum;
		ObjsToRemove.Add( RemovalObj );
	}
	q.free_result();
}


void CZone::ReadZone(CGame *pGame,Database *db,MyString FileName)
{
	char CommandType, Throwaway[MAX_FILE_STRING_SIZE];
	sMobCommands *MobCom = NULL;
	sMobCommands::sMobObj *ObjForMob = NULL;
	sObjRemove *RemovalObj = NULL;
	sRoomObj *ObjToPutInRoom = NULL;
	sDoorFlag *DoorFlags = NULL;
	sRoomCash *pRoomCash = NULL;
	char flag[33];
#ifdef DODB
	long lastmob = -1;
	char sql[200];
	MyString tmp1;
#endif // DODB

/*
 num
 name
 lifespan
 resetmode
 COMMAND c/m/o/g/p/d/r/;(comment)
  c: baseamt | roomvnum | loadeverytime
  m: mobvnum | max | roomvnum
  o: objvnum | max | roomvnum
  g: objvnum | eqpos
  p: <not implemented>
  d: roomvnum | direction | doorstate
  r: roomvnum | objvnum
*/

	CAscii CurrentFile(FileName,ios::in/*|ios::nocreate*/);

	CurrentFile.Numeric("%b",&ZoneNum);
	CurrentFile.ReadFileString(ZoneName); //delim preset to ~
	CurrentFile.Numeric("%b %b",&LifeSpan,&ResetMode);
#ifdef DODB
	db::Zone zz(db,ZoneNum);
	if (pGame -> GenerateDB())
	{
	zz.num = ZoneNum;
	strcpy(zz.name, ZoneName);
	zz.lifespan = LifeSpan;
	zz.resetmode = ResetMode;
	if (CurrentFile.good())
	{
		zz.save();
	}
	zz.num = ZoneNum;
	} // GenerateDB
#endif // DODB
	while(CurrentFile.good())
	{
		CurrentFile >> CommandType;
		switch(tolower(CommandType))
		{
		case 'c':
			RoomCash.Add((pRoomCash = new sRoomCash()));
			CurrentFile.Numeric("%l %l %d",&pRoomCash->m_lBaseAmt,
				&pRoomCash->m_lRoomVnum,&pRoomCash->m_bLoadEveryTime);
#ifdef DODB
			if (pGame -> GenerateDB())
			{
				sprintf(sql,"select * from zone_c where zone=%ld and roomvnum=%ld",
					zz.num,pRoomCash -> m_lRoomVnum);
				db::Zone_c zc(db,sql);
				zc.zone = zz.num;
				zc.baseamt = pRoomCash -> m_lBaseAmt;
				zc.roomvnum = pRoomCash -> m_lRoomVnum;
				zc.loadeverytime = pRoomCash -> m_bLoadEveryTime;
				zc.save();
			} // GenerateDB
#endif // DODB
			break;
		case 'm':
			MobCommands.Add((MobCom = new sMobCommands()));
			CurrentFile.Numeric("%d %b %l",&MobCom->MobVNum,
				&MobCom->Max,&MobCom->RoomVNum);
#ifdef DODB
			if (pGame -> GenerateDB())
			{
				sprintf(sql,"select * from zone_m where zone=%ld and roomvnum=%ld and mobvnum=%ld",
					zz.num,MobCom -> RoomVNum,MobCom -> MobVNum);
				db::Zone_m zc(db,sql);
				zc.zone = zz.num;
				zc.mobvnum = MobCom -> MobVNum;
				zc.max = MobCom -> Max;
				zc.roomvnum = MobCom -> RoomVNum;
				zc.save();
				lastmob = zc.num;
			} // GenerateDB
#endif // DODB
			break;
		case 'o':
			RoomObjs.Add((ObjToPutInRoom = new sRoomObj()));
			CurrentFile.Numeric("%d %b %l",&ObjToPutInRoom->ObjVNum,
				&ObjToPutInRoom->Max,&ObjToPutInRoom->RoomVNum);
#ifdef DODB
			if (pGame -> GenerateDB())
			{
				sprintf(sql,"select * from zone_o where zone=%ld and roomvnum=%ld and objvnum=%d",
					zz.num,ObjToPutInRoom -> RoomVNum,ObjToPutInRoom -> ObjVNum);
				db::Zone_o zc(db,sql);
				zc.zone = zz.num;
				zc.objvnum = ObjToPutInRoom -> ObjVNum;
				zc.max = ObjToPutInRoom -> Max;
				zc.roomvnum = ObjToPutInRoom -> RoomVNum;
				zc.save();
			} // GenerateDB
#endif // DODB
			break;
		case 'g': // equip lastmob
			MobCom = MobCommands.GetLast();
			MobCom->MobObjs.Add((ObjForMob = new sMobCommands::sMobObj()));
			CurrentFile.Numeric("%d %d",&ObjForMob->ObjVnum,
				&ObjForMob->EqPos);
#ifdef DODB
			if (pGame -> GenerateDB())
			{
				sprintf(sql,"select * from zone_g where zone_m=%ld and objvnum=%ld and eqpos=%d",
					lastmob,ObjForMob -> ObjVnum,ObjForMob -> EqPos);
				db::Zone_g zc(db,sql);
				zc.zone_m = lastmob;
				zc.objvnum = ObjForMob -> ObjVnum;
				zc.eqpos = ObjForMob -> EqPos;
				zc.save();
			} // GenerateDB
#endif // DODB
			break;
		case 'p':
			ErrorLog << "Not written yet! put obj in obj" << endl;
			break;
		case 'd':
			Doors.Add((DoorFlags = new sDoorFlag()));
			CurrentFile.Numeric("%l %d %s",&DoorFlags->RoomVnum,
				&DoorFlags->Dir,flag);
			tmp1 = flag;
			DoorFlags->State = CurrentFile.AsciiConvert(flag);
#ifdef DODB
			if (pGame -> GenerateDB())
			{
				sprintf(sql,"select * from zone_d where zone=%ld and roomvnum=%ld and direction=%d",
					zz.num,DoorFlags -> RoomVnum,DoorFlags -> Dir);
				db::Zone_d zc(db,sql);
				zc.zone = zz.num;
				zc.roomvnum = DoorFlags -> RoomVnum;
				zc.direction = DoorFlags -> Dir;
//				zc.doorstate = DoorFlags -> State;
				strcpy(zc.doorstate, tmp1);
				zc.save();
			} // GenerateDB
#endif // DODB
			break;
		case 'r':
			ObjsToRemove.Add((RemovalObj = new sObjRemove()));
			CurrentFile.Numeric("%l %d",&RemovalObj->RoomVNum,&RemovalObj->ObjVNum);
#ifdef DODB
			if (pGame -> GenerateDB())
			{
				sprintf(sql,"select * from zone_r where zone=%ld and roomvnum=%ld and objvnum=%d",
					zz.num,RemovalObj -> RoomVNum,RemovalObj -> ObjVNum);
				db::Zone_r zc(db,sql);
				zc.zone = zz.num;
				zc.objvnum = RemovalObj -> ObjVNum;
				zc.roomvnum = RemovalObj -> RoomVNum;
				zc.save();
			} // GenerateDB
#endif // DODB
			break;
		case ';':
			break;
		default:
			ErrorLog << "We are reading something but not a command " << FileName << endl;
			CurrentFile.getline(Throwaway,MAX_FILE_STRING_SIZE);
			break;
		}
	}
	CurrentFile.close();
}

CZone::~CZone()
{

}

//////////////////////////
//	Overloaded constructor for readin
//////////////////////////
CZone::CZone(CZone * pZone)
{
	MobCommands.SetDeleteData();
	ObjsToRemove.SetDeleteData();
	RoomObjs.SetDeleteData();
	Doors.SetDeleteData();
	RoomCash.SetDeleteData();

	LifeSpan = pZone->LifeSpan;
	ResetMode = pZone->ResetMode;
	Timer = pZone->LifeSpan;
	ZoneName = pZone->ZoneName;
	ZoneNum = pZone->ZoneNum;
	m_nSize = pZone -> m_nSize;
	POSITION pos = pZone->Doors.GetStartPosition();
	while(pos)
	{
		Doors.Add(new sDoorFlag(pZone->Doors.GetNext(pos)));
	}
	pos = pZone->MobCommands.GetStartPosition();
	while(pos)
	{
		MobCommands.Add(new sMobCommands(pZone->MobCommands.GetNext(pos)));
	}
	pos = pZone->ObjsToRemove.GetStartPosition();
	while(pos)
	{
		ObjsToRemove.Add(new sObjRemove(pZone->ObjsToRemove.GetNext(pos)));
	}
	pos = pZone->RoomObjs.GetStartPosition();
	while(pos)
	{
		RoomObjs.Add(new sRoomObj(pZone->RoomObjs.GetNext(pos)));
	}
	pos = pZone->RoomCash.GetStartPosition();
	while(pos)
	{
		RoomCash.Add(new sRoomCash(pZone->RoomCash.GetNext(pos)));
	}
}

