//////////////////////////////////////////////////////////////
//Wolfshade MUD server
//Copyright (C) 1999 Demetrius and John Comes
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//////////////////////////////////////////////////////////////
/*
*
*	CZoneManagement
*		Manages the Zone table and Zone Resets
*
*
*/

#ifndef _ZONE_MANAGEMENT_H_
#define _ZONE_MANAGEMENT_H_
//#include "CZone.h"
//#include "CObjectManager.h"
//#include "CMobManager.h"

#include "CManager.h"

#define TOTAL_ZONE_RESET_TYPES 3


class CZone;

class CZoneManager : public CManager
{
public:
			CZoneManager(CGame *,MyString strIndex);
			~CZoneManager();

  static const MyString 	DEFAULT_ZONEINDEX;
  //
  void 			ResetZones(bool bResetAll, CObjectManager &ObjManager,CMobManager &MobManager);
  MyString 		GetZoneInformation();
  CZone *		GetZone(int);

private:
  void 			ResetRoomCash(CZone *pZone,bool bResetAll);
  void 			ResetRoomObjects(CZone *pZone,CObjectManager &ObjManager);
  void 			RemoveObjectsFromRoom(CZone *pZone,CObjectManager &ObjManager);
  void 			ResetMobs(CZone *pZone,CMobManager &MobManager,CObjectManager &ObjectManager,bool bResetAll);
  void 			ResetDoors(CZone *pZone);
  void 			BootZones();
  void 			BootZonesDB();
  //
  static const short 	ZONE_NORMAL_RESET;
  static const short 	ZONE_NEVER_RESET;
  static const short 	ZONE_ON_EMPTY_RESET;
  static const char *	strResetTypes[];
  //
  MyMap<int,CZone *> 	m_ZoneMap;
  MyString 		ZONEINDEX;
};

/*
inline const char* CZoneManager::GetResetName(short nType)
{
#ifdef _DEBUG
	if(nType<0 || nType>=TOTAL_ZONE_RESET_TYPES)
	{
		return "Type out of range";
	}
#endif
	return strResetTypes[nType];
}
*/
#endif

