#include <stdio.h>
#include <stdlib.h>
#include <mysql/mysql.h>
#include <libsql++.h>
#include <vector>
#include <string>
using std::vector;
using std::string;
#include <libwolfshade.h>

#include "Map.h"


Map::Map(Database *db,long zone,int level)
:m_db(db)
,m_vzone(db,zone)
,m_vmap(NULL)
{
	if (!m_vzone.num)
	{
		throw( "vzone does not exist in database" );
	}
	char default_char = 'a';
	char *default_row = new char[m_vzone.sizex + 1];
	char sql[200];

	memset(default_row, default_char, m_vzone.sizex);
	default_row[m_vzone.sizex] = 0;

	sprintf(sql,"select * from vmap where vzone=%ld and level=%d",zone,level);
	m_vmap = new db::Vmap(m_db,sql);
	m_vmap -> vzone = zone;
	m_vmap -> level = level;
	if (!m_vmap -> num) // create new
	{
		Query q(m_db);
		string query;
		// save to get a num
		m_vmap -> save();
		long num = m_vmap -> num;
		// build empty map
		query = "update vmap set map='";
		for (int i = 0; i < m_vzone.sizey; i++)
		{
			query += default_row;
			query += '\n';
		}
		sprintf(sql,"' where num=%ld",num);
		query += sql;
		q.execute( (char *)query.c_str());
		// recreate object
		delete m_vmap;
		m_vmap = new db::Vmap(m_db,num);
	}
	// append missing rows
	while (m_vmap -> map.size() < (size_t)m_vzone.sizey)
	{
		m_vmap -> map.push_back("");
	}
	for (int i = 0; i < m_vzone.sizey; i++)
	{
		while (m_vmap -> map[i].size() < (size_t)m_vzone.sizex)
			m_vmap -> map[i] += default_char;
	}
}


Map::~Map()
{
	if (m_vmap)
	{
		delete m_vmap;
	}
}


void Map::SetAt(int x,int y,char c)
{
	if (y < m_vmap -> map.size() && x < m_vmap -> map[y].size())
	{
		m_vmap -> map[y][x] = c;
	}
}


void Map::Save()
{
	Query q(m_db);
	string query;
	char sql[200];

	// build empty map
	query = "update vmap set map='";
	for (vector<string>::iterator it = m_vmap -> map.begin(); it != m_vmap -> map.end(); it++)
	{
		query += *it;
		query += '\n';
	}
	sprintf(sql,"' where num=%ld",m_vmap -> num);
	query += sql;
	q.execute( (char *)query.c_str());
}


char Map::GetAt(int x,int y)
{
	if (y < m_vmap -> map.size() && x < m_vmap -> map[y].size())
	{
		return m_vmap -> map[y][x];
	}
	return 0;
}


