//////////////////////////////////////////////////////////////
//Wolfshade MUD server
//Copyright (C) 1999 Demetrius and John Comes
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//////////////////////////////////////////////////////////////
#include "stdinclude.h"
#ifdef PRAGMAHDRSTOP
#pragma hdrstop
#endif
#include "CMageClass.h"

#include "MyList.h"


// only used for static stuff
///////////////////////////////////////////////////////////////
//	using new'ed static memory b/c every complier seems to handle
//	destroying static members at different times.  So we'll just 
//	take the memory from the heap instead of the stack and 
//	eliminate that problem

CMemoryAllocator<MyList<long>::sNode> &MyList<long>::sNode::GetAllocator()
{
	CMemoryAllocator<MyList<long>::sNode> *p = new CMemoryAllocator<MyList<long>::sNode>(1,10,sizeof(MyList<long>::sNode));
	 return *p;
}

CMemoryAllocator<MyList<CCharacter *>::sNode> &MyList<CCharacter *>::sNode::GetAllocator()
{
	static CMemoryAllocator<MyList<CCharacter *>::sNode> *p = 
		new CMemoryAllocator<MyList<CCharacter *>::sNode> (1,10,sizeof(MyList<CCharacter *>::sNode));
	return *p;
}

CMemoryAllocator<MyList<CObject *>::sNode> &MyList<CObject *>::sNode::GetAllocator()
{
	static CMemoryAllocator<MyList<CObject *>::sNode> *p = 
		new CMemoryAllocator<MyList<CObject *>::sNode>(1,10,sizeof(MyList<CObject *>::sNode));
	return *p;
}

CMemoryAllocator<MyList<CCorpse *>::sNode> &MyList<CCorpse *>::sNode::GetAllocator()
{
	static CMemoryAllocator<MyList<CCorpse *>::sNode> *p = 
		new CMemoryAllocator<MyList<CCorpse *>::sNode>(1,10,sizeof(MyList<CCorpse *>::sNode));
	return *p;
}

CMemoryAllocator<MyList<MyString>::sNode> &MyList<MyString>::sNode::GetAllocator()
{
	static CMemoryAllocator<MyList<MyString>::sNode> *p = 
		new CMemoryAllocator<MyList<MyString>::sNode>(1,10,sizeof(MyList<MyString>::sNode));
	return *p;
}

CMemoryAllocator<MyList<const CSpell<CMage> *>::sNode> &MyList<const CSpell<CMage> *>::sNode::GetAllocator()
{
	static CMemoryAllocator<MyList<const CSpell<CMage> *>::sNode> *p = 
		new CMemoryAllocator<MyList<const CSpell<CMage> *>::sNode>(1,10,sizeof(MyList<const CSpell<CMage> *>::sNode));
	return *p;
}

CMemoryAllocator<MyList<CRoom *>::sNode> &MyList<CRoom *>::sNode::GetAllocator()
{
	static CMemoryAllocator<MyList<CRoom *>::sNode> *p = 
		new CMemoryAllocator<MyList<CRoom *>::sNode>(1,10,sizeof(MyList<CRoom *>::sNode));
	return *p;
}

CMemoryAllocator<MyList<int>::sNode> &MyList<int>::sNode::GetAllocator()
{
	static CMemoryAllocator<MyList<int>::sNode> *p = 
		new CMemoryAllocator<MyList<int>::sNode>(1,5,sizeof(MyList<int>::sNode));
	return *p;
}
