/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include <mysql/mysql.h>
#include <libsql++.h>
#include <string>
using std::string;
#include <libcgi++.h>
#include <libwolfshade.h>

#include "BaseForm.h"
#include "WolfshadeWeb.h"
//#include "CMemoryAllocator.h"
//#include "MyString.h"
#include "ObjectForm.h"


namespace cgi
{


ObjectForm::ObjectForm(Web *web)
:BaseForm(web, "objectform")
,m_edit(0)
,m_error(false)
,m_edita(0)
,m_editx(0)
,m_editr(0)
{
	Query q(GetDatabase());

	q.get_result("select * from obj_type");
	while (q.fetch_row())
	{
		db::Obj_type *tmp = new db::Obj_type(GetDatabase(),&q);
		m_objtype[tmp -> num] = tmp;
	}
	q.free_result();

	q.get_result("select * from obj_material");
	while (q.fetch_row())
	{
		db::Obj_material *tmp = new db::Obj_material(GetDatabase(),&q);
		m_material[tmp -> num] = tmp;
	}
	q.free_result();
}


ObjectForm::~ObjectForm()
{
	for (objtypes_t::iterator it = m_objtype.begin(); it != m_objtype.end(); it++)
	{
		delete (*it).second;
	}
	for (materials_t::iterator it = m_material.begin(); it != m_material.end(); it++)
	{
		delete (*it).second;
	}
}


void ObjectForm::Process()
{
	WolfshadeWeb *pclWeb = static_cast<WolfshadeWeb *>(GetWeb());
	char action[200];
	
	if (GetForm() -> getvalue("objectform",action,200))
	{
		char slask[100];
		if (GetForm() -> getvalue("edita",slask,100))
		{
			m_edita = atol(slask);
		}
		if (GetForm() -> getvalue("editx",slask,100))
		{
			m_editx = atol(slask);
		}
		if (GetForm() -> getvalue("editr",slask,100))
		{
			m_editr = atol(slask);
		}
		if (!strcmp(action,"edit"))
		{
			GetForm() -> getvalue("edit",slask,100);
			m_edit = atol(slask);
		}
		else
		if (!strcmp(action," Save "))
		{
			GetForm() -> getvalue("num",slask,100);
			long num = atol(slask);
			GetForm() -> getvalue("onum",slask,100);
			long onum = atol(slask);
			db::Obj obj(GetDatabase(),num);

			if (num != onum && obj.num)
			{
				m_error = true;
			}
			else
			{
				long affbit = 0;
				long wearbit = 0;
				char value[256];
				GetForm() -> getfirst(slask,100,value,256);
				while (*slask)
				{
					if (!strcmp(slask,"affbit"))
						affbit |= atol(value);
					if (!strcmp(slask,"wearbit"))
						wearbit |= atol(value);
					GetForm() -> getnext(slask,100,value,256);
				}
// alias, name, descr, sdescr
				GetForm() -> EnableRaw( true );
				obj.num = num;
				GetForm() -> getvalue("alias",obj.alias,255);
				GetForm() -> getvalue("name",obj.name,255);
				GetForm() -> getvalue("descr",obj.description,255);
				GetForm() -> getvalue("sdescr",obj.sitting_description,255);
				GetForm() -> getvalue("type",slask,100);
				obj.object_type = atol(slask);
				sprintf(obj.affbit,"%ld",affbit);
				sprintf(obj.wearbit,"%ld",wearbit);
				GetForm() -> getvalue("val0",slask,100);
				obj.val0 = atol(slask);
				GetForm() -> getvalue("val1",slask,100);
				obj.val1 = atol(slask);
				GetForm() -> getvalue("val2",slask,100);
				obj.val2 = atol(slask);
				GetForm() -> getvalue("val3",slask,100);
				obj.val3 = atol(slask);
				GetForm() -> getvalue("val4",slask,100);
				obj.val4 = atol(slask);
				GetForm() -> getvalue("weight",slask,100);
				obj.weight = atol(slask);
				GetForm() -> getvalue("cost",slask,100);
				obj.cost = atol(slask);
				GetForm() -> getvalue("material",slask,100);
				obj.material = atol(slask);

				obj.save();
				m_edit = num;
			}
		}
		else
		if (!strcmp(action," Delete Affect "))
		{
			GetForm() -> getvalue("num",slask,100);
			long num = atol(slask);
			db::Obj_affect x(GetDatabase(),num);
			x.erase();
			GetForm() -> getvalue("objnum",slask,100);
			m_edit = atol(slask);
		}
		else
		if (!strcmp(action," Save Affect ") ||
		    !strcmp(action," Add Affect ") )
		{
			GetForm() -> getvalue("num",slask,100);
			long num = atol(slask);
			db::Obj_affect x(GetDatabase(),num);
			GetForm() -> getvalue("objnum",slask,100);
			long objnum = atol(slask);

			x.obj = objnum;
			GetForm() -> getvalue("location",slask,100);
			x.location = atol(slask);
			GetForm() -> getvalue("affect",slask,100);
			x.affect = atol(slask);
			if (x.location)
				x.save();
			//
			m_edit = objnum;
		}
		else
		if (!strcmp(action," Save Extra ") ||
		    !strcmp(action," Add Extra ") )
		{
			GetForm() -> getvalue("num",slask,100);
			long num = atol(slask);
			db::Obj_extra x(GetDatabase(),num);
			GetForm() -> getvalue("objnum",slask,100);
			long objnum = atol(slask);

			GetForm() -> EnableRaw(true);
			x.obj = objnum;
			GetForm() -> getvalue("keyword",x.keyword,255);
			GetForm() -> getvalue("descr",x.description,255);
			x.save();
			//
			m_edit = objnum;
		}
		else
		if (!strcmp(action," Delete Resource "))
		{
			GetForm() -> getvalue("num",slask,100);
			long num = atol(slask);
			db::Obj_resource x(GetDatabase(),num);
			x.erase();
			GetForm() -> getvalue("objnum",slask,100);
			m_edit = atol(slask);
		}
		else
		if (!strcmp(action," Save Resource ") ||
		    !strcmp(action," Add Resource "))
		{
			GetForm() -> getvalue("num",slask,100);
			long num = atol(slask);
			db::Obj_resource x(GetDatabase(),num);
			GetForm() -> getvalue("objnum",slask,100);
			long objnum = atol(slask);

			x.obj = objnum;
			GetForm() -> getvalue("resource",slask,100);
			x.resource = atol(slask);
			GetForm() -> getvalue("amount",slask,100);
			x.amount = atol(slask);
			if (x.resource)
				x.save();
			//
			m_edit = objnum;
		}
		else
		if (!strcmp(action," Post Picture "))
		{
			char fn[256];
			GetForm() -> getvalue("objnum",slask,100);
			long objnum = atol(slask);
			GetForm() -> getvalue("the_file",fn,255);
			if (!strncmp(fn,"/tmp/",5) && strlen(fn) > 5)
			{
				db::Obj obj(GetDatabase(),objnum);
				obj.pic = AddPic(obj.pic,fn);
				obj.save();
			}
			//
			m_edit = objnum;
		}
		else
		if (!strcmp(action,"pic"))
		{
			GetForm() -> getvalue("obj",slask,100);
			long objnum = atol(slask);
			GetForm() -> getvalue("pic",slask,100);
			long picnum = atol(slask);
			db::Obj obj(GetDatabase(),objnum);
			if (obj.pic == picnum)
			{
				db::Pic x(GetDatabase(),obj.pic);
				pclWeb -> SetPic(x.pic,x.ext);
			}
		}
	}
}


void ObjectForm::Select(const string &)
{
}


void ObjectForm::List()
{
}


void ObjectForm::Display(long)
{
	WolfshadeWeb *web = static_cast<WolfshadeWeb *>(GetWeb());
	Database *db = GetDatabase();
	Query q(db);
	Query q2(db);
	long zonesize = 0;
	char sql[200];

	zonesize = EditingZone();

	if (!m_edit)
		web -> DisplayStartAntalForm();

	if (m_error)
	{
		printf("<h3>New Object# is already taken</h3>");
	}

	{
		if (m_edit)
			sprintf(sql,"select * from obj where num=%ld",m_edit);
		else
		{
			if (GetObjtype() || GetMaterial())
			{
				char slask[100];

				strcpy(sql,"select * from obj");
				strcpy(slask," where");
				if (GetObjtype())
				{
					sprintf(sql + strlen(sql),"%s object_type=%ld",slask,GetObjtype());
					strcpy(slask," and");
				}
				if (GetMaterial())
				{
					sprintf(sql + strlen(sql),"%s material=%ld",slask,GetMaterial());
					strcpy(slask," and");
				}
				if (GetZone())
				{
					sprintf(sql + strlen(sql),"%s num>=%ld and num<%ld",
						slask,
						GetZone() * 100,GetZone() * 100 + zonesize);
				}
				strcat(sql," order by num");
			}
			else
			if (GetZone())
			{
				sprintf(sql,"select * from obj where num>=%ld and num<%ld order by num",
					GetZone() * 100,GetZone() * 100 + zonesize);
			}
			else
			{
				sprintf(sql,"select * from obj where num>=%ld order by num limit %ld",GetStart(),GetAntal());
			}
		}
		q.get_result(sql);
		char header[100];

		if (m_edit)
			sprintf(header,"&nbsp;Editing Item#%ld",m_edit);
		else
			sprintf(header,"&nbsp;Items (%ld items displayed)",q.num_rows());
		Table tbl("#000000", 3, header);
		printf("<tr bgcolor=#ffffff>");
		printf("<th align=left>&nbsp;Pic</th>");
		printf("<th align=left>&nbsp;Obj | Vnum</th>");
		printf("<th align=left>&nbsp;Type</th>");
		printf("<th align=left>&nbsp;Material</th>");
		printf("<th>Cost</th>");
		printf("</tr>");

		while (q.fetch_row())
		{
			db::Obj obj(db,&q);
			db::Obj_type *tmp = m_objtype[obj.object_type];
			db::Obj_material *pm = m_material[obj.material];

			printf("<tr bgcolor=#c0c0c0>");
			printf("<td bgcolor=#000000 align=middle>");
			if (obj.pic)
			{
				Table tbl("#ffffff", 0);
				printf("<tr><td bgcolor=#000000>");
				printf("<img src=%s?%s=pic&obj=%ld&pic=%ld>",
					GetCgiName().c_str(),
					GetFormName().c_str(),obj.num,obj.pic);
				printf("</td></tr>");
			}
			printf("</td>");
			printf("<td bgcolor=#808080 valign=middle>");
			ShowObj(obj,true);
			printf("</td>");
			printf("<td bgcolor=#c0c0c0>");
			if (tmp)
				printf("&nbsp;%s&nbsp;",tmp -> name);
			printf("</td>");
			printf("<td bgcolor=#c0c0c0>");
			if (pm)
				printf("&nbsp;%s&nbsp;",pm -> name);
			printf("</td>");
			printf("<td align=right>&nbsp;%ld&nbsp;copper&nbsp;</td>",obj.cost);
			printf("</tr>");
		}
		q.free_result();
	}
	printf("<br>");

	if (m_edit)
	{
		db::Obj obj(db,m_edit);

		// pic
		{
			Table tbl("#000000", 3, "&nbsp;Picture");
			printf("<form action=%s method=post enctype=\"multipart/form-data\">",
				GetCgiName().c_str());
			printf("<input type=hidden name=objnum value=%ld>",obj.num);
			if (obj.pic)
			{
				printf("<tr bgcolor=#ffffff><td colspan=2 align=middle>");
				printf("<img src=%s?%s=pic&obj=%ld&pic=%ld>",
					GetCgiName().c_str(),
					GetFormName().c_str(),obj.num,obj.pic);
				printf("</td></tr>");
			}
			printf("<tr bgcolor=#ffffff><td colspan=2>&nbsp;");
			printf("<input type=file name=the_file>");
			printf("&nbsp;</td></tr>");
			inputsubmit(" Post Picture ");
			printf("</form>");
		}
		printf("<br>");

		if (m_editr) // edit obj_resource
		{
			db::Obj_resource x(db,m_editr);
			{
				Table tbl("#000000", 3);

				printf("<form action=%s method=post>",GetCgiName().c_str());
				printf("<input type=hidden name=num value=%ld>",x.num);
				printf("<input type=hidden name=objnum value=%ld>",obj.num);

				inputselect(q2,"Resource","resource","select num,alias from resource order by alias",x.resource,true);
				inputnum("Amount","amount",x.amount);
				inputsubmit(" Save Resource ");
				inputsubmit(" Delete Resource ");

				printf("</form>");
			}
			printf("<br>");
		}
		else
		if (m_edita) // edit affect
		{
			db::Obj_affect x(db,m_edita);
			{
				Table tbl("#000000", 3);
				
				printf("<form action=%s method=post>",GetCgiName().c_str());
				printf("<input type=hidden name=num value=%ld>",x.num);
				printf("<input type=hidden name=objnum value=%ld>",obj.num);

				inputselect(q2,"Location","location","select num,name from obj_affectnames",x.location);
				inputnum("Affect","affect",x.affect);
				inputsubmit(" Save Affect ");
				inputsubmit(" Delete Affect ");

				printf("</form>");
			}
			printf("<br>");
		}
		else
		if (m_editx) // edit extra
		{
		}
		else
		{
			Table tbl("#000000", 3);
			long affbit = asciiconvert(obj.affbit);
			long wearbit = asciiconvert(obj.wearbit);

			printf("<form action=%s method=post>",GetCgiName().c_str());
			printf("<input type=hidden name=onum value=%ld>",obj.num);

			inputnum("Vnum", "num", obj.num);
			inputstr("Alias","alias",40,obj.alias);
			inputstr("Name","name",60,obj.name,true);
			textarea("Description","descr",obj.description,true);
			textarea("Sitting Description","sdescr",obj.sitting_description,true);
			inputselect(q,"Type","type","select num,name from obj_type order by name",obj.object_type);
			// AffBit
			inputbit(q,"Extra Bits","affbit","select num,name from obj_affbit order by name",affbit,3);
			// WearBit
			inputbit(q,"Wear Bits","wearbit","select num,name from obj_wearbit order by name",wearbit,3);
			// Valx
			// beroende p. object type:
			switch (obj.object_type)
			{
			case 6: //ITEM_TYPE_ARMOR:
				inputnum("AC", "val0", obj.val0);
				printf("<input type=hidden name=val1 value=%ld>",obj.val1);
				printf("<input type=hidden name=val2 value=%ld>",obj.val2);
				printf("<input type=hidden name=val3 value=%ld>",obj.val3);
				printf("<input type=hidden name=val4 value=%ld>",obj.val4);
				break;
			case 12: //ITEM_TYPE_PORTAL: //portal time loaded in minutes we need it in pulses
				inputnum("ToRoom", "val0", obj.val0);
				inputnum("TimeToLive (minutes)", "val1", obj.val1);
				printf("<input type=hidden name=val2 value=%ld>",obj.val2);
				printf("<input type=hidden name=val3 value=%ld>",obj.val3);
				printf("<input type=hidden name=val4 value=%ld>",obj.val4);
				break;
			case 2: //ITEM_TYPE_LIGHT: 
				inputnum("LightPower (1-6)", "val0", obj.val0);
				inputnum("Capacity (hours)", "val1", obj.val1);
				printf("<input type=hidden name=val2 value=%ld>",obj.val2);
				printf("<input type=hidden name=val3 value=%ld>",obj.val3);
				printf("<input type=hidden name=val4 value=%ld>",obj.val4);
				break;
			case 3: //ITEM_TYPE_SCROLL:
				inputnum("SpellLevel", "val0", obj.val0);
				inputnum("Spell#1", "val1", obj.val1);
				inputnum("Spell#2", "val2", obj.val2);
				inputnum("Spell#3", "val3", obj.val3);
				inputnum("Spell#4", "val4", obj.val4);
				break;
			case 11: //ITEM_TYPE_POTION:
			case 10: //ITEM_TYPE_WEAPON: 
			case 5: //ITEM_TYPE_STAFF:
			case 14: //ITEM_TYPE_TRANSPORT:
				inputnum("Val0", "val0", obj.val0);
				inputnum("Val1", "val1", obj.val1);
				inputnum("Val2", "val2", obj.val2);
				inputnum("Val3", "val3", obj.val3);
				inputnum("Val4", "val4", obj.val4);
				break;
			case 8: //ITEM_TYPE_CONTAINER:
			case 9: //ITEM_TYPE_FOUNTAIN:
				inputnum("Val0", "val0", obj.val0);
				inputnum("Val1", "val1", obj.val1);
				inputnum("Val2", "val2", obj.val2);
				printf("<input type=hidden name=val3 value=%ld>",obj.val3);
				printf("<input type=hidden name=val4 value=%ld>",obj.val4);
				break;
			}
			//
			inputnum("Weight","weight",obj.weight);
			inputnum("Cost","cost",obj.cost);
			inputselect(q,"Material","material","select num,name from obj_material order by name",obj.material);

			//
			inputsubmit(" Save ");

			printf("</form>");
		}
		printf("<br>");

		// obj_affect's
/*
CREATE TABLE obj_affect (
  num int(11) NOT NULL auto_increment,
  obj int(11) NOT NULL default '0',
  location int(11) NOT NULL default '0',
  affect int(11) NOT NULL default '0',
  PRIMARY KEY  (num)
) TYPE=MyISAM;
*/
		sprintf(sql,"select * from obj_affect where obj=%ld",obj.num);
		q.get_result(sql);
		if (q.num_rows())
		{
			Table tbl("#000000", 3, "&nbsp;Affects");
			printf("<tr bgcolor=#ffffff>");
			printf("<th>Location</th>");
			printf("<th>Affect</th>");
			printf("<th></th>");
			printf("</tr>");
			while (q.fetch_row())
			{
				db::Obj_affect x(db,&q);
				db::Obj_affectnames loc(db,x.location);
				printf("<tr bgcolor=#ffffff>");
				printf("<td>&nbsp;%s&nbsp;</td>",loc.name);
				printf("<td align=right>&nbsp;%ld&nbsp;</td>",x.affect);
				printf("<td>&nbsp;[&nbsp;");
				printf("<a href=%s?objectform=edit&edit=%ld&edita=%ld>edit</a>",
					GetCgiName().c_str(),obj.num,x.num);
				printf("&nbsp;]&nbsp;</td>");
				printf("</tr>");
			}
		}
		if (q.num_rows())
		{
			printf("<br>");
		}
		q.free_result();
		
		// new affect
		{
			Table tbl("#000000", 3);
			
			SetColor("#c0ffff");
			printf("<form action=%s method=post>",GetCgiName().c_str());
			printf("<input type=hidden name=num value=%d>",0);
			printf("<input type=hidden name=objnum value=%ld>",obj.num);

			inputselect(q2,"Location","location","select num,name from obj_affectnames",-1);
			inputnum("Affect","affect",0);
			inputsubmit(" Add Affect ");

			printf("</form>");
			SetColor("#ffffc0");
		}
		printf("<br>");

		// obj_extra's
/*
CREATE TABLE obj_extra (
  num int(11) NOT NULL auto_increment,
  obj int(11) NOT NULL default '0',
  keyword varchar(255) NOT NULL default '',
  description varchar(255) NOT NULL default '',
  PRIMARY KEY  (num)
) TYPE=MyISAM;
*/
		sprintf(sql,"select * from obj_extra where obj=%ld",obj.num);
		q.get_result(sql);
		while (q.fetch_row())
		{
			db::Obj_extra x(db,&q);
			{
				Table tbl("#000000", 3);
				
				printf("<form action=%s method=post>",GetCgiName().c_str());
				printf("<input type=hidden name=num value=%ld>",x.num);
				printf("<input type=hidden name=objnum value=%ld>",obj.num);

				inputstr("Keyword","keyword",60,x.keyword);
				textarea("Description","descr",x.description,true);
				inputsubmit(" Save Extra ");

				printf("</form>");
			}
			printf("<br>");
		}
		q.free_result();
		
		// new extra
		{
			Table tbl("#000000", 3);
			
			SetColor("#c0ffff");
			printf("<form action=%s method=post>",GetCgiName().c_str());
			printf("<input type=hidden name=num value=%d>",0);
			printf("<input type=hidden name=objnum value=%ld>",obj.num);

			inputstr("Keyword","keyword",60,"");
			textarea("Description","descr","");
			inputsubmit(" Add Extra ");

			printf("</form>");
			SetColor("#ffffc0");
		}
		printf("<br>");

		// resource
		sprintf(sql,"select * from obj_resource where obj=%ld",obj.num);
		q.get_result(sql);
		if (q.num_rows())
		{
			Table tbl("#000000", 3, "&nbsp;Resources");
			printf("<tr bgcolor=#ffffff>");
			printf("<th>Resource</th>");
			printf("<th>Amount</th>");
			printf("<th></th>");
			printf("</tr>");
			while (q.fetch_row())
			{
				db::Obj_resource x(db,&q);
				db::Resource loc(db,x.resource);
				printf("<tr bgcolor=#808080>");
				printf("<td>&nbsp;%s&nbsp;</td>",htmlcolor(loc.name));
				printf("<td align=right>&nbsp;%ld&nbsp;</td>",x.amount);
				printf("<td>&nbsp;[&nbsp;");
				printf("<a href=%s?objectform=edit&edit=%ld&editr=%ld>edit</a>",
					GetCgiName().c_str(),obj.num,x.num);
				printf("&nbsp;]&nbsp;</td>");
				printf("</tr>");
			}
		}
		if (q.num_rows())
		{
			printf("<br>");
		}
		q.free_result();

		// new resource
		{
			Table tbl("#000000", 3);
			
			SetColor("#c0ffff");
			printf("<form action=%s method=post>",GetCgiName().c_str());
			printf("<input type=hidden name=num value=%d>",0);
			printf("<input type=hidden name=objnum value=%ld>",obj.num);

			inputselect(q2,"Resource","resource","select num,alias from resource order by alias",-1);
			inputnum("Amount","amount",0);
			inputsubmit(" Add Resource ");

			printf("</form>");
			SetColor("#ffffc0");
		}
		printf("<br>");

	}
}


} // namespace cgi


/*
CREATE TABLE obj (
  num int(11) NOT NULL default '0',
  alias varchar(255) NOT NULL default '',
  name varchar(255) NOT NULL default '',
  description varchar(255) NOT NULL default '',
  sitting_description varchar(255) NOT NULL default '',
  object_type int(11) NOT NULL default '0',
  AffBit varchar(255) NOT NULL default '',
  WearBit varchar(255) NOT NULL default '',
  strval1 varchar(255) NOT NULL default '',
  Val0 int(11) NOT NULL default '0',
  Val1 int(11) NOT NULL default '0',
  Val2 int(11) NOT NULL default '0',
  Val3 int(11) NOT NULL default '0',
  Val4 int(11) NOT NULL default '0',
  Weight int(11) NOT NULL default '0',
  Cost int(11) NOT NULL default '0',
  Material int(11) NOT NULL default '0',
  PRIMARY KEY  (num)
) TYPE=MyISAM;
*/

