/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include <mysql/mysql.h>
#include <libsql++.h>
#include <string>
using std::string;
#include <libcgi++.h>
#include <libwolfshade.h>

#include "BaseForm.h"
#include "WolfshadeWeb.h"
//#include "CMemoryAllocator.h"
//#include "MyString.h"
#include "RaceForm.h"


namespace cgi
{


RaceForm::RaceForm(Web *web)
:BaseForm(web, "raceform")
,m_edit(0)
,m_error(false)
{
	Query q(GetDatabase());

	q.get_result("select * from race_size");
	while (q.fetch_row())
	{
		db::Race_size *tmp = new db::Race_size(GetDatabase(),&q);
		m_size[tmp -> num] = tmp;
	}
	q.free_result();
}


RaceForm::~RaceForm()
{
	for (racesizes_t::iterator it = m_size.begin(); it != m_size.end(); it++)
	{
		delete (*it).second;
	}
}


void RaceForm::Process()
{
	char action[200];
	
	if (GetForm() -> getvalue("raceform",action,200))
	{
		if (!strcmp(action,"edit"))
		{
			char slask[100];
			GetForm() -> getvalue("edit",slask,100);
			m_edit = atol(slask);
		}
		else
		if (!strcmp(action," Save "))
		{
			char slask[100];
			GetForm() -> getvalue("num",slask,100);
			long num = atol(slask);
			GetForm() -> getvalue("onum",slask,100);
			long onum = atol(slask);
			db::Race race(GetDatabase(),num);

			if (num != onum && race.num)
			{
				m_error = true;
			}
			else
			{
				long innatebits = 0;
				char value[256];
				GetForm() -> getfirst(slask,100,value,256);
				while (*slask)
				{
					if (!strcmp(slask,"abilities"))
						innatebits |= atol(value);
					//
					GetForm() -> getnext(slask,100,value,256);
				}
// alias, name, dpd, descr, longdescr
				GetForm() -> EnableRaw( true );
				race.num = num;
				GetForm() -> getvalue("alias",race.alias,255);
				GetForm() -> getvalue("name",race.name,255);
#define GET(x,y) \
	GetForm() -> getvalue(x,slask,100); \
	y = atol(slask);
				GET("start_room",race.start_room);
				GET("size",race.size);
				//
				race.abilities = innatebits;
				GET("height_min",race.height_min);
				GET("height_max",race.height_max);
				GET("weight_min",race.weight_min);
				GET("weight_max",race.weight_max);
				GET("age_min",race.age_min);
				GET("age_max",race.age_max);
				GET("starting_alignment",race.starting_alignment);
				GET("race_war",race.race_war);
/*
const short CAttributes::SAVE_BREATH = 0;
const short CAttributes::SAVE_PARA = 1;
const short CAttributes::SAVE_SPELL = 2;
const short CAttributes::SAVE_POISON = 3;
*/
				GET("save_breath",race.save_breath);
				GET("save_para",race.save_para);
				GET("save_spell",race.save_spell);
				GET("save_poison",race.save_poison);
				//
				race.save();
				m_edit = num;
			}
		}
	}
}


void RaceForm::Select(const string &)
{
}


void RaceForm::List()
{
}


void RaceForm::Display(long)
{
	WolfshadeWeb *web = static_cast<WolfshadeWeb *>(GetWeb());
	Database *db = GetDatabase();
	Query q(db);
	long zonesize = 0;
	char sql[200];

	zonesize = EditingZone();

	if (!m_edit)
		web -> DisplayStartAntalForm();

	if (m_error)
	{
		printf("<h3>New Race# is already taken</h3>");
	}

	{
		if (m_edit)
			sprintf(sql,"select * from race where num=%ld",m_edit);
		else
		{
			sprintf(sql,"select * from race where num>=%ld order by num limit %ld",GetStart(),GetAntal());
		}
		q.get_result(sql);
		char header[100];
		
		if (m_edit)
			sprintf(header,"&nbsp;Editing Race#%ld",m_edit);
		else
			sprintf(header,"&nbsp;Races (%ld races displayed)",q.num_rows());
		Table tbl("#000000", 3, header);
		printf("<tr bgcolor=#ffffff>");
		printf("<th align=left>&nbsp;Race | Vnum</th>");
		printf("<th align=left>&nbsp;Start Room</th>");
		printf("<th align=left>&nbsp;Size</th>");
		printf("<th align=left colspan=2>&nbsp;Height</th>");
		printf("<th align=left colspan=2>&nbsp;Weight</th>");
		printf("<th align=left colspan=2>&nbsp;Age</th>");
		printf("</tr>");

		while (q.fetch_row())
		{
			db::Race race(db,&q);
			db::Room room(db,race.start_room);
			db::Race_size *tmp = m_size[race.size];

			printf("<tr bgcolor=#808080>");
			ShowRace(race,true,true);
			if (room.num)
			{
				ShowRoom(room,true,true);
			}
			else
			{
				printf("<td align=middle>-</td>");
			}
			// race size
			printf("<td bgcolor=#c0c0c0 align=middle>%s</td>",
				tmp ? tmp -> name : "");
			printf("<td bgcolor=#c0c0c0 align=right>&nbsp;%ld&nbsp;</td>",race.height_min);
			printf("<td bgcolor=#c0c0c0 align=right>&nbsp;%ld&nbsp;</td>",race.height_max);
			printf("<td bgcolor=#c0c0c0 align=right>&nbsp;%ld&nbsp;</td>",race.weight_min);
			printf("<td bgcolor=#c0c0c0 align=right>&nbsp;%ld&nbsp;</td>",race.weight_max);
			printf("<td bgcolor=#c0c0c0 align=right>&nbsp;%ld&nbsp;</td>",race.age_min);
			printf("<td bgcolor=#c0c0c0 align=right>&nbsp;%ld&nbsp;</td>",race.age_max);
			printf("</tr>");
		}
		q.free_result();
	}
	printf("<br>");

	if (m_edit)
	{
		db::Race race(db,m_edit);

		// references to this race
		{
		}

		// edit
		{
			Table tbl("#000000", 3);

			printf("<form action=%s method=post>",GetCgiName().c_str());
			printf("<input type=hidden name=onum value=%ld>",race.num);

			inputnum("Vnum", "num", race.num);
			inputstr("Alias","alias",40,race.alias);
			inputstr("RaceName","name",60,race.name,true);
			inputnum("StartRoom","start_room",race.start_room,VALUE_IS_ROOM);
			inputselect(q,"Size","size","select num,name from race_size order by num",race.size);
			// abilities inputbit
			inputbit(q,"Abilities","abilities","select num,name from innate order by name",race.abilities,3);
			inputnum("Min Height","height_min",race.height_min);
			inputnum("Max Height","height_max",race.height_max);
			inputnum("Min Weight","weight_min",race.weight_min);
			inputnum("Max Weight","weight_max",race.weight_max);
			inputnum("Min Age","age_min",race.age_min);
			inputnum("Max Age","age_max",race.age_max);
			inputnum("StartingAlignment","starting_alignment",race.starting_alignment);
			inputnum("RaceWar","race_war",race.race_war);
			inputnum("Save Breath","save_breath",race.save_breath);
			inputnum("Save Para","save_para",race.save_para);
			inputnum("Save Spell","save_spell",race.save_spell);
			inputnum("Save Poison","save_poison",race.save_poison);
			inputsubmit(" Save ");
/*
const short CAttributes::SAVE_BREATH = 0;
const short CAttributes::SAVE_PARA = 1;
const short CAttributes::SAVE_SPELL = 2;
const short CAttributes::SAVE_POISON = 3;
*/
/*
CREATE TABLE race (
  num int(11) NOT NULL default '0',
  alias varchar(255) NOT NULL default '',
  name varchar(255) NOT NULL default '',
  start_room int(11) NOT NULL default '0',
  size int(11) NOT NULL default '0',
  abilities int(11) NOT NULL default '0',
  height_min int(11) NOT NULL default '0',
  height_max int(11) NOT NULL default '0',
  weight_min int(11) NOT NULL default '0',
  weight_max int(11) NOT NULL default '0',
  age_min int(11) NOT NULL default '0',
  age_max int(11) NOT NULL default '0',
  starting_alignment int(11) NOT NULL default '0',
  race_war int(11) NOT NULL default '0',
  PRIMARY KEY  (num)
) TYPE=MyISAM;
*/
			printf("</form>");
		}
		printf("<br>");
	}
}


} // namespace cgi



