/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include <mysql/mysql.h>
#include <libsql++.h>
#include <string>
using std::string;
#include <libcgi++.h>
#include <libwolfshade.h>

#include "BaseForm.h"
#include "WolfshadeWeb.h"
//#include "CMemoryAllocator.h"
//#include "MyString.h"
#include "ResourceForm.h"


namespace cgi
{


ResourceForm::ResourceForm(Web *web)
:BaseForm(web, "resourceform")
,m_edit(0)
,m_error(false)
{
	Query q(GetDatabase());
	
	q.get_result("select * from skill");
	while (q.fetch_row())
	{
		db::Skill *tmp = new db::Skill(GetDatabase(),&q);
		m_skill[tmp -> num] = tmp;
	}
	q.free_result();
}


ResourceForm::~ResourceForm()
{
	for (skills_t::iterator it = m_skill.begin(); it != m_skill.end(); it++)
	{
		delete (*it).second;
	}
}


void ResourceForm::Process()
{
	char action[200];
	
	if (GetForm() -> getvalue("resourceform",action,200))
	{
		if (!strcmp(action,"edit"))
		{
			char slask[100];
			GetForm() -> getvalue("edit",slask,100);
			m_edit = atol(slask);
		}
		else
		if (!strcmp(action," Save "))
		{
			char slask[100];
			GetForm() -> getvalue("num",slask,100);
			long num = atol(slask);
			GetForm() -> getvalue("onum",slask,100);
			long onum = atol(slask);
			db::Resource resource(GetDatabase(),num);

			if (num != onum && resource.num)
			{
				m_error = true;
			}
			else
			{
// alias, name, dpd, descr, longdescr
				GetForm() -> EnableRaw( true );
				resource.num = num;
				GetForm() -> getvalue("name",resource.name,255);
				GetForm() -> getvalue("skill",slask,100);
				resource.skill = atol(slask);
				GetForm() -> getvalue("alias",resource.alias,255);
				GetForm() -> getvalue("low_price",slask,100);
				resource.low_price = atol(slask);
				GetForm() -> getvalue("high_price",slask,100);
				resource.high_price = atol(slask);
				GetForm() -> getvalue("low_count",slask,100);
				resource.low_count = atol(slask);
				GetForm() -> getvalue("high_count",slask,100);
				resource.high_count = atol(slask);
				GetForm() -> getvalue("base_resource",slask,100);
				resource.base_resource = atol(slask);
				//
				resource.save();
//				m_edit = num;
			}
		}
	}
}


void ResourceForm::Select(const string &)
{
}


void ResourceForm::List()
{
}


void ResourceForm::Display(long)
{
	WolfshadeWeb *web = static_cast<WolfshadeWeb *>(GetWeb());
	Database *db = GetDatabase();
	Query q(db);
	long zonesize = 0;
	char sql[200];

	zonesize = EditingZone();

	if (!m_edit)
		web -> DisplayStartAntalForm();

	if (m_error)
	{
		printf("<h3>New Resource# is already taken</h3>");
	}

	{
		if (m_edit)
			sprintf(sql,"select * from resource where num=%ld",m_edit);
		else
		{
			sprintf(sql,"select * from resource where num>=%ld order by num limit %ld",GetStart(),GetAntal());
		}
		q.get_result(sql);
		char header[100];
		
		if (m_edit)
			sprintf(header,"&nbsp;Editing Resource#%ld",m_edit);
		else
			sprintf(header,"&nbsp;Resources (%ld resources displayed)",q.num_rows());
		Table tbl("#000000", 3, header);
		printf("<tr bgcolor=#ffffff>");
		printf("<th align=left>&nbsp;Resource | Vnum</th>");
		printf("<th align=left>&nbsp;Skill</th>");
		printf("<th align=left>&nbsp;Base resource</th>");
		printf("<th align=left>&nbsp;Low price/count</th>");
		printf("<th align=left>&nbsp;High price/count</th>");
		printf("</tr>");

		while (q.fetch_row())
		{
			db::Resource resource(db,&q);
			db::Skill *tmp = m_skill[resource.skill];
			db::Resource base(db,resource.base_resource);

			printf("<tr bgcolor=#808080>");
			ShowResource(resource,true,true);
			if (tmp)
				ShowSkill(*tmp,true,true);
			else
				printf("<td align=middle>-</td>");
			if (base.num)
				ShowResource(base,true,true);
			else
				printf("<td align=middle>-</td>");
			printf("<td align=middle>&nbsp;%ld/%ld&nbsp;</td>",
				resource.low_price,resource.high_count);
			printf("<td align=middle>&nbsp;%ld/%ld&nbsp;</td>",
				resource.high_price,resource.low_count);
			printf("</tr>");
		}
		q.free_result();
	}
	printf("<br>");

	if (m_edit)
	{
		db::Resource resource(db,m_edit);

		// references to this resource
		{
		}

		// edit
		{
			Table tbl("#000000", 3);

			printf("<form action=%s method=post>",GetCgiName().c_str());
			printf("<input type=hidden name=onum value=%ld>",resource.num);

			inputnum("Vnum", "num", resource.num);
			inputstr("ResourceAlias","alias",60,resource.alias);
			inputstr("ResourceName","name",60,resource.name,true);
			inputselect(q,"Skill","skill","select num,name from skill order by name",resource.skill);
			inputselect(q,"Base Resource","base_resource","select num,alias from resource order by alias",resource.base_resource);
			inputnum("Low Price","low_price",resource.low_price);
			inputnum("High Price","high_price",resource.high_price);
			inputnum("Low Count","low_count",resource.low_count);
			inputnum("High Count","high_count",resource.high_count);

			inputsubmit(" Save ");

			printf("</form>");
		}
		printf("<br>");
	}
}


} // namespace cgi



