/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _CGI_ROOMFORM_H
#define _CGI_ROOMFORM_H

#include <map>


namespace cgi
{
typedef std::map<long,db::Zone *> zones_t;
typedef std::map<long,db::Room_type *> types_t;
typedef std::map<long,db::Room_size *> sizes_t;


class RoomForm : public BaseForm
{
public:
	RoomForm(Web *);
	~RoomForm();

	void Process();
	void Select(const string &);
	void List();
	void Display(long = 0);

private:
	long m_edit;
	bool m_error;
	zones_t m_zone;
	types_t m_type;
	sizes_t m_size;
};


} // namespace cgi


#endif // _CGI_ROOMFORM_H

