/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include <mysql/mysql.h>
#include <libsql++.h>
#include <string>
using std::string;
#include <libcgi++.h>
#include <libwolfshade.h>

#include "BaseForm.h"
#include "WolfshadeWeb.h"
//#include "CMemoryAllocator.h"
//#include "MyString.h"
#include "SkillForm.h"


namespace cgi
{


SkillForm::SkillForm(Web *web)
:BaseForm(web, "skillform")
,m_edit(0)
,m_error(false)
{
}


SkillForm::~SkillForm()
{
}


void SkillForm::Process()
{
	char action[200];
	
	if (GetForm() -> getvalue("skillform",action,200))
	{
		if (!strcmp(action,"edit"))
		{
			char slask[100];
			GetForm() -> getvalue("edit",slask,100);
			m_edit = atol(slask);
		}
		else
		if (!strcmp(action," Save "))
		{
			char slask[100];
			GetForm() -> getvalue("num",slask,100);
			long num = atol(slask);
			GetForm() -> getvalue("onum",slask,100);
			long onum = atol(slask);
			db::Skill skill(GetDatabase(),num);

			if (num != onum && skill.num)
			{
				m_error = true;
			}
			else
			{
// alias, name, dpd, descr, longdescr
				GetForm() -> EnableRaw( true );
				skill.num = num;
				GetForm() -> getvalue("name",skill.name,255);
				//
				skill.save();
//				m_edit = num;
			}
		}
	}
}


void SkillForm::Select(const string &)
{
}


void SkillForm::List()
{
}


void SkillForm::Display(long)
{
	WolfshadeWeb *web = static_cast<WolfshadeWeb *>(GetWeb());
	Database *db = GetDatabase();
	Query q(db);
	long zonesize = 0;
	char sql[200];

	zonesize = EditingZone();

	if (!m_edit)
		web -> DisplayStartAntalForm();

	if (m_error)
	{
		printf("<h3>New Skill# is already taken</h3>");
	}

	{
		if (m_edit)
			sprintf(sql,"select * from skill where num=%ld",m_edit);
		else
		{
			sprintf(sql,"select * from skill where num>=%ld order by num limit %ld",GetStart(),GetAntal());
		}
		q.get_result(sql);
		char header[100];
		
		if (m_edit)
			sprintf(header,"&nbsp;Editing Skill#%ld",m_edit);
		else
			sprintf(header,"&nbsp;Skills (%ld skills displayed)",q.num_rows());
		Table tbl("#000000", 3, header);
		printf("<tr bgcolor=#ffffff>");
		printf("<th align=left>&nbsp;Skill | Vnum</th>");
		printf("</tr>");

		while (q.fetch_row())
		{
			db::Skill skill(db,&q);

			printf("<tr bgcolor=#808080>");
			ShowSkill(skill,true,true);
			printf("</tr>");
		}
		q.free_result();
	}
	printf("<br>");

	if (m_edit)
	{
		db::Skill skill(db,m_edit);

		// references to this skill
		{
		}

		// edit
		{
			Table tbl("#000000", 3);

			printf("<form action=%s method=post>",GetCgiName().c_str());
			printf("<input type=hidden name=onum value=%ld>",skill.num);

			inputnum("Vnum", "num", skill.num);
			inputstr("SkillName","name",60,skill.name,true);
			inputsubmit(" Save ");

			printf("</form>");
		}
		printf("<br>");
	}
}


} // namespace cgi



