/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include <mysql/mysql.h>
#include <libsql++.h>
#include <string>
using std::string;
#include <libcgi++.h>
#include <libwolfshade.h>
#include <libgd.h>

#include "BaseForm.h"
#include "WolfshadeWeb.h"
//#include "CMemoryAllocator.h"
//#include "MyString.h"
#include "Map.h"
#include "VirtualForm.h"


namespace cgi
{


VirtualForm::VirtualForm(Web *web)
:BaseForm(web, "virtualform")
,m_edit(0)
,m_error(false)
,m_preview(false)
,m_area(0)
,m_level(0)
,m_x(0)
,m_y(0)
{
	Query q(GetDatabase());

	q.get_result("select * from room where virtual_room<>0");
	while (q.fetch_row())
	{
		db::Room *tmp = new db::Room(GetDatabase(),&q);
		m_prototype[tmp -> num] = tmp;
	}
	q.free_result();
}


VirtualForm::~VirtualForm()
{
	for (rooms_t::iterator it = m_prototype.begin(); it != m_prototype.end(); it++)
	{
		delete (*it).second;
	}
}


void VirtualForm::Process()
{
	char action[200];
	
	if (GetForm() -> getvalue("virtualform",action,200))
	{
		if (!strcmp(action,"edit"))
		{
			char slask[100];
			GetForm() -> getvalue("edit",slask,100);
			m_edit = atol(slask);
			if (GetForm() -> getvalue("preview",slask,100))
			{
				m_preview = true;
			}
		}
		else
		if (!strcmp(action," Save "))
		{
			char slask[100];
			GetForm() -> getvalue("num",slask,100);
			long num = atol(slask);
			GetForm() -> getvalue("onum",slask,100);
			long onum = atol(slask);
			db::Vzone vzone(GetDatabase(),num);
			bool new_zone = false;

			if (num != onum && vzone.num)
			{
				m_error = true;
			}
			else
			{
// alias, name, dpd, descr, longdescr
				GetForm() -> EnableRaw( true );
//				vzone.num = num;
				GetForm() -> getvalue("name",vzone.name,255);
				if (!vzone.num)
				{
					GetForm() -> getvalue("type",slask,100);
					vzone.type = atol(slask);
					GetForm() -> getvalue("vnumstart",slask,100);
					vzone.vnumstart = atol(slask);
					GetForm() -> getvalue("sizex",slask,100);
					vzone.sizex = atol(slask);
					GetForm() -> getvalue("sizey",slask,100);
					vzone.sizey = atol(slask);
					GetForm() -> getvalue("sizez",slask,100);
					vzone.sizez = atol(slask);
					GetForm() -> getvalue("seed",slask,100);
					vzone.seed = atol(slask);
					GetForm() -> getvalue("temporary",slask,100);
					vzone.temporary = atol(slask);
					//
					new_zone = true;
				}
				vzone.save();
				if (new_zone)
				{
					Map x(GetDatabase(),vzone.num,0);
					// create type 1 2d zone
					x.Save();
				}
				//
				m_edit = vzone.num;
			}
		}
		else
		if (!strcmp(action,"area"))
		{
			char slask[100];
			// area,lvl,x,y
			GetForm() -> getvalue("area",slask,100);
			m_area = atol(slask);
			GetForm() -> getvalue("lvl",slask,100);
			m_level = atoi(slask);
			GetForm() -> getvalue("x",slask,100);
			m_x = atoi(slask);
			GetForm() -> getvalue("y",slask,100);
			m_y = atoi(slask);
			//
			m_edit = m_area;
		}
		else
		if (!strcmp(action," Change "))
		{
			char slask[100];
			char sql[200];
			// area,lvl,x,y
			GetForm() -> getvalue("area",slask,100);
			m_area = atol(slask);
			GetForm() -> getvalue("lvl",slask,100);
			m_level = atoi(slask);
			GetForm() -> getvalue("x",slask,100);
			m_x = atoi(slask);
			GetForm() -> getvalue("y",slask,100);
			m_y = atoi(slask);
			//
			sprintf(sql,"select * from vmap where vzone=%ld and level=%d",m_area,m_level);
			db::Vmap map(GetDatabase(),sql);
			db::Vzone vzone(GetDatabase(),m_area);
			for (int y = m_y; y < m_y + 16; y++)
			{
				if (y < vzone.sizey)
				{
					int i = 0;
					sprintf(slask,"row%d",y);
					GetForm() -> getvalue(slask,slask,100);
					for (int x = m_x; x < m_x + 16; x++,i++)
					{
						if (x < vzone.sizex)
						{
							map.map[y][x] = slask[i];
						}
					}
				}
			}
			// save map and create new image
			{
				Query q(GetDatabase());
				string query;
				query = "update vmap set map='";
				for (vector<string>::iterator it = map.map.begin(); it != map.map.end(); it++)
				{
					query += *it;
					query += '\n';
				}
				sprintf(slask,"' where num=%ld",map.num);
				query += slask;
				q.execute( (char *)query.c_str());
				CreatePicture(vzone,map,"/tmp/tmp_pic.gif");
				map.pic = AddPic(map.pic,"/tmp/tmp_pic.gif");
			}
			//
			m_edit = m_area;
		}
	}
}


void VirtualForm::Select(const string &)
{
}


void VirtualForm::List()
{
}


void VirtualForm::Display(long)
{
	WolfshadeWeb *web = static_cast<WolfshadeWeb *>(GetWeb());
	Database *db = GetDatabase();
	Query q(db);
	Query q2(db);
	char sql[200];

	if (!m_edit)
		web -> DisplayStartAntalForm();

	if (m_error)
	{
		printf("<h3>New Virtual# is already taken</h3>");
	}

	{
		if (m_edit)
			sprintf(sql,"select * from vzone where num=%ld",m_edit);
		else
		{
			sprintf(sql,"select * from vzone where num>=%ld order by num limit %ld",GetStart(),GetAntal());
		}
		q.get_result(sql);
		char header[100];
		
		if (m_edit)
			sprintf(header,"&nbsp;Editing Virtual zone#%ld",m_edit);
		else
			sprintf(header,"&nbsp;Virtual zones (%ld vzones displayed)",q.num_rows());
		Table tbl("#000000", 3, header);
		printf("<tr bgcolor=#ffffff>");
		printf("<th align=left>&nbsp;Virtual | Vnum</th>");
		printf("<th align=left>&nbsp;Links to</th>");
		printf("<th></th>"); // preview
		printf("</tr>");

		while (q.fetch_row())
		{
			db::Vzone vzone(db,&q);

			printf("<tr bgcolor=#808080>");
			printf("<td bgcolor=#808080>");
			ShowVirtual(vzone,true);
			printf("</td>");
			sprintf(sql,"select count(*) from room_door where toroom>=%ld and toroom<%ld",
				vzone.vnumstart,
				vzone.vnumstart + vzone.sizex * vzone.sizey);
			printf("<td align=right>&nbsp;%ld&nbsp;</td>",q2.get_count(sql));
			printf("<td>&nbsp;");
			printf("<a href=%s?virtualform=edit&edit=%ld&preview=1>preview</a>",
				GetCgiName().c_str(),vzone.num);
			printf("&nbsp;</td>");
			printf("</tr>");
		}
		q.free_result();
	}
	printf("<br>");

	if (m_edit)
	{
		db::Vzone vzone(db,m_edit);

		// link to gif
		{
			Table tbl("#000000", 3, "&nbsp;Map");
			printf("<tr bgcolor=#ffffff>");
			printf("<td>");
			printf("<img border=0 src=%s?mapform=map&map=%ld usemap=mmap>",GetCgiName().c_str(),vzone.num);
			printf("</td>");
			printf("</tr>");
		}
		printf("<br>");
		// the gif map
		{
			// area,lvl,x,y
			printf("<map name=mmap>");
			for (int y = 0; y < vzone.sizey; y += 16)
				for (int x = 0; x < vzone.sizex; x += 16)
					printf("<area href=%s?%s=area&area=%ld&lvl=0&x=%d&y=%d alt=\"%d,%d\" shape=rect coords=%d,%d,%d,%d>",
						GetCgiName().c_str(),
						GetFormName().c_str(),
						vzone.num,
						x,y,x,y,x,y,x + 16,y + 16);
			printf("</map>");
		}

		// edit part of this map
		if (m_area)
		{
			sprintf(sql,"select * from vmap where vzone=%ld and level=%d",m_area,m_level);
			db::Vmap map(db,sql);
			char slask[100];
			printf("<form action=%s method=post>",GetCgiName().c_str());
			printf("<input type=hidden name=area value=%ld>",m_area);
			printf("<input type=hidden name=level value=%d>",m_level);
			printf("<input type=hidden name=x value=%d>",m_x);
			printf("<input type=hidden name=y value=%d>",m_y);
			printf("<table>");
			for (int y = m_y; y < m_y + 16; y++)
			{
				if (y < vzone.sizey)
				{
					printf("<tr><td align=right>");
					strncpy(slask,map.map[y].c_str() + m_x,16);
					slask[16] = 0;
					printf("%d:&nbsp;",y);
					printf("</td><td>&nbsp;");
					printf("<input class=map type=text size=20 name=row%d value=\"%s\">",y,slask);
//					printf("<br>");
					printf("</td></tr>");
				}
			}
			printf("</table>");
			printf("<input type=submit name=%s value=\" Change \">",GetFormName().c_str());
			printf("</form>");
			printf("<br>");
		}

		// references to this vzone
		{
		}

		// edit
		if (!m_preview)
		{
			Table tbl("#000000", 3);

			printf("<form action=%s method=post>",GetCgiName().c_str());
			printf("<input type=hidden name=onum value=%ld>",vzone.num);

			inputnum("Vnum", "num", vzone.num);
			inputstr("VirtualName","name",60,vzone.name,true);
			inputselect(q,"Type","type","select num,name from vzone_type order by num",vzone.type);
			inputnum("VnumStart","vnumstart",vzone.vnumstart);
			inputnum("SizeX","sizex",vzone.sizex);
			inputnum("SizeY","sizey",vzone.sizey);
			inputnum("SizeZ","sizez",vzone.sizez);
			inputnum("Seed","seed",vzone.seed);
			inputcheck("Temporary","temporary",vzone.temporary ? true : false);
			inputsubmit(" Save ");

			printf("</form>");
		}
		if (!m_preview)
			printf("<br>");

		// show map
		if (m_preview)
		{
			Table tbl("#000000", 3);
			Map map(GetDatabase(),vzone.num,0);

			printf("<tr><td bgcolor=#ffffff>");

//			sprintf(sql,"select * from vroom where vzone=%ld order by y,x",vzone.num);
//			q.get_result(sql);
			printf("<font face=courier style=\"background-color: #808080\">");
//			while (q.fetch_row())
			for (int y = 0; y < vzone.sizey; y++)
			{
			for (int x = 0; x < vzone.sizex; x++)
			{
//				db::Vroom vr(db,&q);
				long num = map.GetAt(x,y) - 96;
				db::Room *tmp = m_prototype[num]; //vr.roomvnum];
/*
				while (cx != vr.x && cy != vr.y && cy < vzone.sizey)
				{
					printf("X");
					cx++;
					if (cx >= vzone.sizex)
					{
						printf("</font><br><font face=courier style=\"background-color: #808080\">");
						cx = 0;
						cy++;
					}
				}
*/
				if (tmp)
				{
					printf("%s",htmlcolor(tmp -> virtual_char));
				}
				else
				{
					printf("X");
				}
			} // for (x)
					printf("</font><br><font face=courier style=\"background-color: #808080\">");
			} // for (y)
			printf("</font>");
			q.free_result();
			
			printf("</td></tr>");
		} // m_preview
		if (m_preview)
			printf("<br>");

		sprintf(sql,"select * from room_door where toroom>=%ld and toroom<%ld",
			vzone.vnumstart,
			vzone.vnumstart + vzone.sizex * vzone.sizey);
		q.get_result(sql);
		if (q.num_rows())
		{
			Table tbl("#000000", 3, "&nbsp;Real room links");
			printf("<tr bgcolor=#ffffff>");
			printf("<th align=left>&nbsp;From</th>");
			printf("<th align=left>&nbsp;Dir</th>");
			printf("<th align=left>&nbsp;To</th>");
			printf("<th align=left>&nbsp;x,y</th>");
			printf("</tr>");
			while (q.fetch_row())
			{
				db::Room_door x(db,&q);
				db::Room room(db,x.room);
				db::Room_dir dir(db,x.direction);
				printf("<tr bgcolor=#808080>");
				ShowRoom(room,true,true);
				printf("<td align=middle>&nbsp;%s&nbsp;</td>",dir.name);
				printf("<td align=right>&nbsp;%ld&nbsp;</td>",x.toroom);
				printf("<td align=middle>&nbsp;%ld,%ld&nbsp;</td>",
					(x.toroom - vzone.vnumstart) % vzone.sizex,
					(x.toroom - vzone.vnumstart) / vzone.sizex);
				printf("</tr>");
			}
		}
		q.free_result();
	}
}


void VirtualForm::CreatePicture(db::Vzone &vzone,db::Vmap &map,const string &filename)
{
	gd::Image img(vzone.sizex,vzone.sizey,vzone.sizex,vzone.sizey);
	int black = img.AddColor(0,0,0);
	int colors[256];

	colors[0] = black;
	for (int i = 1; i < 256; i++)
		colors[i] = 0;
	for (int i = 'a'; i < 'z'; i++)
	{
		int tmp = i - 'a';
		int intensity = 4 * tmp / 8;
		int r = (tmp & 1) ? 0x33 : 0;
		int g = (tmp & 2) ? 0x33 : 0;
		int b = (tmp & 4) ? 0x33 : 0;
		r *= intensity;
		g *= intensity;
		b *= intensity;
		colors[i] = img.AddColor(r,g,b);
	}
	for (int y = 0; y < vzone.sizey; y++)
	{
		for (int x = 0; x < vzone.sizex; x++)
		{
			char c = map.map[y][x];
			if (!colors[c])
				colors[c] = img.AddColor(random()%256,random()%256,random()%256);
			img.Line(x,y,x,y,colors[c]);
		}
	}
	{
		FILE *fil = fopen(filename.c_str(),"wb");
		if (fil)
		{
			img.SaveTo(fil);
			fclose(fil);
		}
	}
}


} // namespace cgi


/*
CREATE TABLE vzone (
  num int(11) NOT NULL auto_increment,
  name varchar(255) NOT NULL default '',
  vnumstart int(11) NOT NULL default '0',
  sizex int(11) NOT NULL default '0',
  sizey int(11) NOT NULL default '0',
  PRIMARY KEY  (num)
) TYPE=MyISAM;
*/
/*
CREATE TABLE vroom (
  num int(11) NOT NULL auto_increment,
  vzone int(11) NOT NULL default '0',
  x int(11) NOT NULL default '0',
  y int(11) NOT NULL default '0',
  roomvnum int(11) NOT NULL default '0',
  exits int(11) NOT NULL default '0',
  PRIMARY KEY  (num),
  KEY vzone (vzone,y,x)
) TYPE=MyISAM;
*/


