/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _CGI_VIRTUALFORM_H
#define _CGI_VIRTUALFORM_H

#include <map>


namespace cgi
{
typedef std::map<long,db::Room *> rooms_t;


class VirtualForm : public BaseForm
{
public:
	VirtualForm(Web *);
	~VirtualForm();

	void Process();
	void Select(const string &);
	void List();
	void Display(long = 0);

private:
	void CreatePicture(db::Vzone &,db::Vmap &,const string &);
	//
	long m_edit;
	bool m_error;
	rooms_t m_prototype;
	bool m_preview;
	long m_area; // vzone
	int m_level;
	int m_x;
	int m_y;
};


} // namespace cgi


#endif // _CGI_VIRTUALFORM_H

