/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include <mysql/mysql.h>
#include <libsql++.h>
#include <string>
using std::string;
#include <libcgi++.h>
#include <libwolfshade.h>

#include "BaseForm.h"
#include "WolfshadeWeb.h"
//#include "CMemoryAllocator.h"
//#include "MyString.h"
#include "WeaponForm.h"


namespace cgi
{


WeaponForm::WeaponForm(Web *web)
:BaseForm(web, "weaponform")
,m_edit(0)
,m_error(false)
{
	Query q(GetDatabase());
	
	q.get_result("select * from skill");
	while (q.fetch_row())
	{
		db::Skill *tmp = new db::Skill(GetDatabase(),&q);
		m_skill[tmp -> num] = tmp;
	}
	q.free_result();
}


WeaponForm::~WeaponForm()
{
	for (skills_t::iterator it = m_skill.begin(); it != m_skill.end(); it++)
	{
		delete (*it).second;
	}
}


void WeaponForm::Process()
{
	char action[200];
	
	if (GetForm() -> getvalue("weaponform",action,200))
	{
		if (!strcmp(action,"edit"))
		{
			char slask[100];
			GetForm() -> getvalue("edit",slask,100);
			m_edit = atol(slask);
		}
		else
		if (!strcmp(action," Save "))
		{
			long weapflags = 0;
			char slask[100];
			char value[256];
			GetForm() -> getvalue("num",slask,100);
			long num = atol(slask);
			GetForm() -> getvalue("onum",slask,100);
			long onum = atol(slask);
			db::Weapon weap(GetDatabase(),num);

			if (num != onum && weap.num)
			{
				m_error = true;
			}
			else
			{
// alias, name, dpd, descr, longdescr
				GetForm() -> EnableRaw( true );
				weap.num = num;
				GetForm() -> getvalue("name",weap.name,255);
				// loop to get multiple checkbox values
				GetForm() -> getfirst(slask,100,value,256);
				while (*slask)
				{
					if (!strcmp(slask,"weapflags"))
						weapflags |= atol(value);
					//
					GetForm() -> getnext(slask,100,value,256);
				}
//				sprintf(weap.weapflags,"%ld",weapflags);
				GetForm() -> getvalue("twohand",slask,100);
				weap.twohand = atol(slask);
				GetForm() -> getvalue("str",slask,100);
				weap.str = atol(slask);
				GetForm() -> getvalue("dam1",slask,100);
				weap.dam1 = atol(slask);
				GetForm() -> getvalue("dam2",slask,100);
				weap.dam2 = atol(slask);
				GetForm() -> getvalue("speed",slask,100);
				weap.speed = atol(slask);
				GetForm() -> getvalue("skill",slask,100);
				weap.skill = atol(slask);
				//
				weap.save();
//				m_edit = num;
			}
		}
	}
}


void WeaponForm::Select(const string &)
{
}


void WeaponForm::List()
{
}


void WeaponForm::Display(long)
{
	WolfshadeWeb *web = static_cast<WolfshadeWeb *>(GetWeb());
	Database *db = GetDatabase();
	Query q(db);
	long zonesize = 0;
	char sql[200];

	zonesize = EditingZone();

	if (!m_edit)
		web -> DisplayStartAntalForm();

	if (m_error)
	{
		printf("<h3>New Weapon# is already taken</h3>");
	}

	{
		if (m_edit)
			sprintf(sql,"select * from weapon where num=%ld",m_edit);
		else
		{
			sprintf(sql,"select * from weapon where num>=%ld order by num limit %ld",GetStart(),GetAntal());
		}
		q.get_result(sql);
		char header[100];
		
		if (m_edit)
			sprintf(header,"&nbsp;Editing Weapon#%ld",m_edit);
		else
			sprintf(header,"&nbsp;Weapons (%ld weaps displayed)",q.num_rows());
		Table tbl("#000000", 3, header);
		printf("<tr bgcolor=#ffffff>");
		printf("<th align=left>&nbsp;Weapon Type</th>");
		printf("<th align=left>&nbsp;StrReq</th>");
		printf("<th align=left>&nbsp;Damage</th>");
		printf("<th align=left>&nbsp;Speed</th>");
		printf("<th align=left>&nbsp;Skill</th>");
		printf("</tr>");

		while (q.fetch_row())
		{
			db::Weapon weap(db,&q);
			db::Skill *tmp = m_skill[weap.skill];

			printf("<tr bgcolor=#808080>");
			printf("<td bgcolor=#808080>");
			ShowWeapon(weap,true);
			printf("</td>");
			printf("<td align=right>&nbsp;%ld&nbsp;</td>",weap.str);
			printf("<td align=middle>&nbsp;%ld&nbsp;D&nbsp;%ld&nbsp;</td>",weap.dam1,weap.dam2);
			printf("<td align=right>&nbsp;%ld&nbsp;</td>",weap.speed);
			if (tmp)
				ShowSkill(*tmp,true,true);
			else
				printf("<td align=middle>-</td>");
			printf("</tr>");
		}
		q.free_result();
	}
	printf("<br>");

	if (m_edit)
	{
		db::Weapon weap(db,m_edit);

		// references to this weap
		{
		} // end of references

		// edit
		{
			Table tbl("#000000", 3);
//			long weapflags = asciiconvert(weap.weapflags);
//			long loadpos = asciiconvert(weap.loadpos);
//			long defpos = asciiconvert(weap.defaultpos);

			printf("<form action=%s method=post>",GetCgiName().c_str());
			printf("<input type=hidden name=onum value=%ld>",weap.num);

			inputnum("Num","num",weap.num);
			inputstr("WeaponName","name",60,weap.name,true);
//			inputbit(q,"WeaponFlags","weapflags","select num,name from weapon_action order by name",weapflags,4);
			inputdie("Damage","dam",weap.dam1,weap.dam2);
			inputnum("Speed","speed",weap.speed);
			inputnum("TwoHanded", "twohand", weap.twohand);
			inputnum("StrReq", "str", weap.str);
			inputselect(q,"Skill","skill","select num,name from skill order by name",weap.skill);
			inputsubmit(" Save ");

			printf("</form>");
		}
		printf("<br>");
	}
}


} // namespace cgi



