/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include <mysql/mysql.h>
#include <libsql++.h>
#include <string>
using std::string;
#include <libcgi++.h>
#include <libwolfshade.h>

#include "WolfshadeWeb.h"


namespace cgi
{


WolfshadeWeb::WolfshadeWeb(const string &domain,const string &path)
:MenuWeb(domain, path)
,m_db("localhost","web","","wolfshade")
,m_bSetCookie(false)
,m_start(0)
,m_antal(0)
,m_zone(0)
,m_race(0)
,m_class(0)
,m_objtype(0)
,m_material(0)
,m_pic_ext("")
//
,m_form1( this )
,m_form2( this )
,m_form3( this )
,m_form4( this )
,m_form5( this )
,m_form6( this )
,m_form7( this )
,m_form8( this )
,m_form9( this )
,m_form10(this )
,m_form11(this )
{
	RegWebForm( &m_form1 );
	RegWebForm( &m_form2 );
	RegWebForm( &m_form3 );
	RegWebForm( &m_form4 );
	RegWebForm( &m_form5 );
	RegWebForm( &m_form6 );
	RegWebForm( &m_form7 );
	RegWebForm( &m_form8 );
	RegWebForm( &m_form9 );
	RegWebForm( &m_form10 );
	RegWebForm( &m_form11 );

	m_menuZone = AddMenuItem(&m_form3, "Zones").num;
	m_menuMob = AddMenuItem(&m_form1, "Mobs").num;
	m_menuObj = AddMenuItem(&m_form2, "Items").num;
	m_menuRoom = AddMenuItem(&m_form4, "Rooms").num;
	m_menuVirtual = AddMenuItem(&m_form5, "Virtual").num;
	AddMenuSeparator();
	m_menuWeapon = AddMenuItem(&m_form8, "Weapons").num;
	m_menuSkill = AddMenuItem(&m_form9, "Skills").num;
	m_menuResource = AddMenuItem(&m_form10, "Resources").num;
//	AddMenuSeparator();
//	m_menuRace = AddMenuItem(&m_form7, "Races").num;

//	AddMenuSeparator();
//	AddMenuItem(&m_form6, "Bugs");

	AddMenuSeparator();
	{
		char url[256];
		sprintf(url,"%s?style=%d",GetCgiName().c_str(),MENU_STYLE_TOP);
		AddMenuLink(url,"Top");
		sprintf(url,"%s?style=%d",GetCgiName().c_str(),MENU_STYLE_LEFT);
		AddMenuLink(url,"Left");
	}
}


WolfshadeWeb::~WolfshadeWeb()
{
}


void WolfshadeWeb::ReadCookies()
{
	char slask[200];
	
	MenuWeb::ReadCookies();

	if (GetCookies() -> getvalue("ws",slask,200))
	{
		Parse pa(slask,":");
		m_start = pa.getvalue();
		m_antal = pa.getvalue();
		m_zone = pa.getvalue();
		m_race = pa.getvalue();
		m_class = pa.getvalue();
		m_objtype = pa.getvalue();
		m_material = pa.getvalue();
	}
}


void WolfshadeWeb::FormInput()
{
	char slask[200];

	MenuWeb::FormInput();

	if (GetForm() -> getvalue("start",slask,200) && *slask)
	{
		SetStart(atol(slask));
	}
	if (GetForm() -> getvalue("antal",slask,200) && *slask)
	{
		SetAntal(atol(slask));
	}
	if (GetForm() -> getvalue("xzonex",slask,200) && *slask)
	{
		SetZone(atol(slask));
	}
	if (GetForm() -> getvalue("xracex",slask,200) && *slask)
	{
		SetRace(atol(slask));
	}
	if (GetForm() -> getvalue("xclassx",slask,200) && *slask)
	{
		SetClass(atol(slask));
	}
	if (GetForm() -> getvalue("xobjtypex",slask,200) && *slask)
	{
		SetObjtype(atol(slask));
	}
	if (GetForm() -> getvalue("xmaterialx",slask,200) && *slask)
	{
		SetMaterial(atol(slask));
	}
	if (!GetPage())
	{
		SetPage(m_menuZone);
	}
	if (!GetStart())
	{
		SetStart(1);
	}
	if (!GetAntal())
	{
		SetAntal(10);
	}
}


void WolfshadeWeb::CreateHeader()
{
	if (m_pic.size())
	{
		printf("Content-type: image/%s\n",m_pic_ext.c_str());
		printf("\n");
		return;
	}
	if (m_bSetCookie)
	{
		SetTheCookie();
	}
	MenuWeb::CreateHeader();
}


void WolfshadeWeb::GenerateDocument()
{
	SetMenuclass("menu");

	if (m_pic.size())
	{
		Base64 bomb;
		bomb.decode_to_stdout(m_pic);
		return;
	}
	printf("<html>");
	printf("<head>");
	printf("<link rel=\"STYLESHEET\" href=\"/style/ws.css\" type=\"text/css\">");
	printf("</head>");
	printf("<body>");
/*
	if (!m_start)
	{
		m_form1.Display();
	}
	else
*/
	{
		MenuWeb::GenerateDocument();
	}
	printf("</body>");
	printf("</html>");
}


void WolfshadeWeb::SetTheCookie()
{
	char slask[200];

	sprintf(slask,"%ld:%ld:%ld:%ld:%ld:%ld:%ld",
		m_start,m_antal,m_zone,m_race,m_class,m_objtype,m_material);
	SetCookie("ws",slask);
}


Database *WolfshadeWeb::GetDatabase()
{
	return &m_db;
}


void WolfshadeWeb::DisplayStartAntalForm()
{
	Query q(GetDatabase());
	{
		Table tbl("#000000", 5);

//		printf("<table cellpadding=5>");
		printf("<form action=%s method=POST>",GetCgiName().c_str());
		printf("<tr bgcolor=#ffffff>");
		printf("<td valign=top>First<br><input type=text size=8 name=start value=\"%ld\"></td>",GetStart());
		printf("<td valign=top>Qty<br><input type=text size=8 name=antal value=\"%ld\"></td>",GetAntal());
		if (GetPage() == m_menuMob)
		{
			// race
			printf("<td valign=top>Race<br><select name=xracex><option value=0>");
			q.get_result("select * from race where num>0 order by alias");
			while (q.fetch_row())
			{
				db::Race x(GetDatabase(),&q);
				printf("<option value=%ld%s>%s",
					x.num,
					(x.num == m_race) ? " SELECTED" : "",
					x.alias);
			}
			q.free_result();
			printf("</select>");
			printf("</td>");
			// class
			printf("<td valign=top>Class<br><select name=xclassx><option value=0>");
			q.get_result("select * from classes where num>0 order by alias");
			while (q.fetch_row())
			{
				db::Classes x(GetDatabase(),&q);
				printf("<option value=%ld%s>%s",
					x.num,
					(x.num == m_class) ? " SELECTED" : "",
					x.alias);
			}
			q.free_result();
			printf("</select>");
			printf("</td>");
		}
		else
		if (GetPage() == m_menuObj)
		{
			printf("<td valign=top>Object Type<br><select name=xobjtypex><option value=0>");
			q.get_result("select * from obj_type where num>0 order by name");
			while (q.fetch_row())
			{
				db::Obj_type x(GetDatabase(),&q);
				printf("<option value=%ld%s>%s",
					x.num,
					(x.num == m_objtype) ? " SELECTED" : "",
					x.name);
			}
			q.free_result();
			printf("</select>");
			printf("</td>");
			// material
			printf("<td valign=top>Material<br><select name=xmaterialx><option value=0>");
			q.get_result("select * from obj_material where num>0 order by name");
			while (q.fetch_row())
			{
				db::Obj_material x(GetDatabase(),&q);
				printf("<option value=%ld%s>%s",
					x.num,
					(x.num == m_material) ? " SELECTED" : "",
					x.name);
			}
			q.free_result();
			printf("</select>");
			printf("</td>");
		}
		else
		if (GetPage() == m_menuRoom)
		{
			printf("<td valign=top>Zone<br><select name=xzonex><option value=0>");
			q.get_result("select * from zone order by name");
			while (q.fetch_row())
			{
				db::Zone x(GetDatabase(),&q);
				printf("<option value=%ld%s>%s",
					x.num,
					(x.num == m_zone) ? " SELECTED" : "",
					m_form1.nocolor(x.name));
			}
			q.free_result();
			printf("</select>");
			printf("</td>");
		} // m_menuRoom
		printf("<td valign=bottom><input type=submit name=submit value=\" Change \"></td>");
		printf("</tr>");
		printf("</form>");
//		printf("</table>");
	}
	printf("<br>");
}


} // namespace cgi



