/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _CGI_WOLFSHADEWEB_H
#define _CGI_WOLFSHADEWEB_H

#include "BaseForm.h"
#include "MobForm.h"
#include "ObjectForm.h"
#include "ZoneForm.h"
#include "RoomForm.h"
#include "VirtualForm.h"
#include "FelForm.h"
#include "RaceForm.h"
#include "WeaponForm.h"
#include "SkillForm.h"
#include "ResourceForm.h"
#include "MapForm.h"


namespace cgi
{


class WolfshadeWeb : public MenuWeb
{
public:
	/** Constructor
	*/
	WolfshadeWeb(const string &d, //!< Cookie domain
	             const string &p); //!< Cookie path
	~WolfshadeWeb();

	void ReadCookies();
	void FormInput();
	void CreateHeader();
	void GenerateDocument();

	Database *GetDatabase();
	void SetTheCookie();

	long GetStart() { return m_start; }
	void SetStart(long x) { m_start = x; m_bSetCookie = true; }
	long GetAntal() { return m_antal; }
	void SetAntal(long x) { m_antal = x; m_bSetCookie = true; }
	long GetZone() { return m_zone; }
	void SetZone(long x) { m_zone = x; m_bSetCookie = true; }
	long GetRace() { return m_race; }
	void SetRace(long x) { m_race = x; m_bSetCookie = true; }
	long GetClass() { return m_class; }
	void SetClass(long x) { m_class = x; m_bSetCookie = true; }
	long GetObjtype() { return m_objtype; }
	void SetObjtype(long x) { m_objtype = x; m_bSetCookie = true; }
	long GetMaterial() { return m_material; }
	void SetMaterial(long x) { m_material = x; m_bSetCookie = true; }

	long GetMenuMob() { return m_menuMob; }
	long GetMenuObj() { return m_menuObj; }
	long GetMenuRoom() { return m_menuRoom; }
	long GetMenuZone() { return m_menuZone; }
	long GetMenuVirtual() { return m_menuVirtual; }
	long GetMenuRace() { return m_menuRace; }
	long GetMenuWeapon() { return m_menuWeapon; }
	long GetMenuSkill() { return m_menuSkill; }
	long GetMenuResource() { return m_menuResource; }

	void DisplayStartAntalForm();
	void SetPic(const vector<string> &pic,const string &ext) { m_pic = pic; m_pic_ext = ext; }

private:
	Database m_db;
	bool m_bSetCookie;
	long m_start;
	long m_antal;
	long m_zone;
	long m_race;
	long m_class;
	long m_objtype;
	long m_material;
	vector<string> m_pic;
	string m_pic_ext;
	//
	long m_menuMob;
	long m_menuObj;
	long m_menuRoom;
	long m_menuZone;
	long m_menuVirtual;
	long m_menuRace;
	long m_menuWeapon;
	long m_menuSkill;
	long m_menuResource;
	//
	MobForm m_form1;
	ObjectForm m_form2;
	ZoneForm m_form3;
	RoomForm m_form4;
	VirtualForm m_form5;
	FelForm m_form6;
	RaceForm m_form7;
	WeaponForm m_form8;
	SkillForm m_form9;
	ResourceForm m_form10;
	MapForm m_form11;
};


} // namespace cgi


#endif // _CGI_WOLFSHADEWEB_H

