/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include <mysql/mysql.h>
#include <libsql++.h>
#include <string>
using std::string;
#include <libcgi++.h>
#include <libwolfshade.h>

#include "BaseForm.h"
#include "WolfshadeWeb.h"
//#include "CMemoryAllocator.h"
//#include "MyString.h"
#include "ZoneForm.h"


namespace cgi
{


ZoneForm::ZoneForm(Web *web)
:BaseForm(web, "zoneform")
,m_edit(0)
,m_error(false)
,m_editm(0)
,m_edito(0)
,m_editg(0)
{
	Query q(GetDatabase());
	q.get_result("select * from zone_reset");
	while (q.fetch_row())
	{
		db::Zone_reset *tmp = new db::Zone_reset(GetDatabase(),&q);
		m_reset[tmp -> num] = tmp;
	}
	q.free_result();
}


ZoneForm::~ZoneForm()
{
	for (resets_t::iterator it = m_reset.begin(); it != m_reset.end(); it++)
	{
		delete (*it).second;
	}
}


void ZoneForm::Process()
{
	char action[200];
	
	if (GetForm() -> getvalue("zoneform",action,200))
	{
		char slask[200];
		if (GetForm() -> getvalue("editg",slask,100))
		{
			m_editg = atol(slask);
		}
		if (GetForm() -> getvalue("editm",slask,100))
		{
			m_editm = atol(slask);
		}
		if (GetForm() -> getvalue("edito",slask,100))
		{
			m_edito = atol(slask);
		}
		if (!strcmp(action,"edit"))
		{
			GetForm() -> getvalue("edit",slask,100);
			m_edit = atol(slask);
		}
		else
		if (!strcmp(action," Save "))
		{
			GetForm() -> getvalue("num",slask,100);
			long num = atol(slask);
			GetForm() -> getvalue("onum",slask,100);
			long onum = atol(slask);
			db::Zone zone(GetDatabase(),num);

			if (num != onum && zone.num)
			{
				m_error = true;
			}
			else
			{
				GetForm() -> EnableRaw( true );
				zone.num = num;
				GetForm() -> getvalue("name",zone.name,255);
				GetForm() -> getvalue("lifespan",slask,100);
				zone.lifespan = atol(slask);
				GetForm() -> getvalue("resetmode",slask,100);
				zone.resetmode = atol(slask);
				GetForm() -> getvalue("size",slask,100);
				zone.size = atol(slask);
				zone.save();
				m_edit = num;
			}
		}
		else
		if (!strcmp(action," Delete Mob "))
		{
			Query q(GetDatabase());
			char sql[200];
			GetForm() -> getvalue("num",slask,100);
			long num = atol(slask);
			GetForm() -> getvalue("zonenum",slask,100);
			long zonenum = atol(slask);
			sprintf(sql,"delete from zone_m where num=%ld and zone=%ld",num,zonenum);
			q.execute(sql);
			m_edit = zonenum;
		}
		else
		if (!strcmp(action," Add Mob ") ||
		    !strcmp(action," Save Mob ") )
		{
			GetForm() -> getvalue("num",slask,100);
			long num = atol(slask);
			db::Zone_m zm(GetDatabase(),num);
			bool ok = true;
			zm.num = num;
			GetForm() -> getvalue("zonenum",slask,100);
			zm.zone = atol(slask);
			GetForm() -> getvalue("mobnum",slask,100);
			zm.mobvnum = atol(slask);
			GetForm() -> getvalue("max",slask,100);
			zm.max = atol(slask);
			GetForm() -> getvalue("roomnum",slask,100);
			zm.roomvnum = atol(slask);
			{
				db::Mob mob(GetDatabase(),zm.mobvnum);
				db::Room room(GetDatabase(),zm.roomvnum);
				if (!mob.num || !room.num)
				{
					ok = false;
				}
			}
			if (ok)
			{
				zm.save();
			}
			m_edit = zm.zone;
		}
		else
		if (!strcmp(action," Delete Obj "))
		{
			Query q(GetDatabase());
			char sql[200];
			GetForm() -> getvalue("num",slask,100);
			long num = atol(slask);
			GetForm() -> getvalue("zonenum",slask,100);
			long zonenum = atol(slask);
			sprintf(sql,"delete from zone_o where num=%ld and zone=%ld",num,zonenum);
			q.execute(sql);
			m_edit = zonenum;
		}
		else
		if (!strcmp(action," Add Obj ") ||
		    !strcmp(action," Save Obj ") )
		{
			GetForm() -> getvalue("num",slask,100);
			long num = atol(slask);
			db::Zone_o zo(GetDatabase(),num);
			bool ok = true;
			zo.num = num;
			GetForm() -> getvalue("zonenum",slask,100);
			zo.zone = atol(slask);
			GetForm() -> getvalue("objnum",slask,100);
			zo.objvnum = atol(slask);
			GetForm() -> getvalue("max",slask,100);
			zo.max = atol(slask);
			GetForm() -> getvalue("roomnum",slask,100);
			zo.roomvnum = atol(slask);
			{
				db::Obj obj(GetDatabase(),zo.objvnum);
				db::Room room(GetDatabase(),zo.roomvnum);
				if (!obj.num || !room.num)
				{
					ok = false;
				}
			}
			if (ok)
			{
				zo.save();
			}
			m_edit = zo.zone;
		}
		else
		if (!strcmp(action," Delete Eq "))
		{
			char sql[200];
			GetForm() -> getvalue("num",slask,100);
			long num = atol(slask);
			GetForm() -> getvalue("mnum",slask,100);
			long mnum = atol(slask);
			sprintf(sql,"select * from zone_g where num=%ld and zone_m=%ld",num,mnum);
			db::Zone_g zg(GetDatabase(),sql);
			zg.erase();
			GetForm() -> getvalue("zonenum",slask,100);
			m_edit = atol(slask);
			m_editm = mnum;
		}
		else
		if (!strcmp(action," Add Eq ") ||
		    !strcmp(action," Save Eq "))
		{
			GetForm() -> getvalue("num",slask,100);
			long num = atol(slask);
			GetForm() -> getvalue("mnum",slask,100);
			long mnum = atol(slask);
			db::Zone_g zg(GetDatabase(),num);
			zg.zone_m = mnum;
			GetForm() -> getvalue("objnum",slask,100);
			zg.objvnum = atol(slask);
			GetForm() -> getvalue("eqpos",slask,100);
			zg.eqpos = atol(slask);
			zg.save();
			GetForm() -> getvalue("zonenum",slask,100);
			m_edit = atol(slask);
			m_editm = mnum;
		}
	}
}


void ZoneForm::Select(const string &)
{
}


void ZoneForm::List()
{
}


void ZoneForm::Display(long)
{
	WolfshadeWeb *web = static_cast<WolfshadeWeb *>(GetWeb());
	Database *db = GetDatabase();
	Query q(db);
	Query q2(db);
	char sql[200];

	if (!m_edit)
		web -> DisplayStartAntalForm();

	if (m_error)
	{
		printf("<h3>New Zone# is already taken</h3>");
	}

	{
		if (m_edit)
			sprintf(sql,"select * from zone where num=%ld",m_edit);
		else
			sprintf(sql,"select * from zone where num>=%ld order by num limit %ld",GetStart(),GetAntal());
		q.get_result(sql);
		char header[100];
		
		if (m_edit)
			sprintf(header,"&nbsp;Editing Zone#%ld",m_edit);
		else
			sprintf(header,"&nbsp;Zones (%ld zones displayed)",q.num_rows());
		Table tbl("#000000", 3, header);
		printf("<tr bgcolor=#ffffff>");
		printf("<th align=left>&nbsp;Zone | Vnum</th>");
		printf("<th align=left>&nbsp;LifeSpan</th>");
		printf("<th align=left>&nbsp;ResetMode</th>");
		printf("<th align=left>&nbsp;Size</th>");
		printf("</tr>");

		while (q.fetch_row())
		{
			db::Zone zone(db,&q);

			printf("<tr bgcolor=#c0c0c0>");
			printf("<td bgcolor=#808080>");
			ShowZone(zone,true);
			printf("</td>");
			printf("<td align=right>&nbsp;%ld mins&nbsp;</td>",zone.lifespan);
			printf("<td>&nbsp;%s&nbsp;</td>",m_reset[zone.resetmode] -> name);
			printf("<td align=right>&nbsp;%ld&nbsp;</td>",zone.size);
			printf("</tr>");
		}
		q.free_result();
	}
	printf("<br>");

	if (m_editg)
	{
		db::Zone_g zg(db,m_editg);
		{
			Table tbl("#000000", 3);

			printf("<form action=%s method=post>",GetCgiName().c_str());
			printf("<input type=hidden name=num value=%ld>",zg.num);
			printf("<input type=hidden name=zonenum value=%ld>",m_edit);
			printf("<input type=hidden name=mnum value=%ld>",zg.zone_m);

			inputnum("Obj Vnum","objnum",zg.objvnum,VALUE_IS_OBJ);
			inputnum("EqPos","eqpos",zg.eqpos);
			inputsubmit(" Save Eq ");
			inputsubmit(" Delete Eq ");

			printf("</form>");
		}
/*
// G <Obj Vnum> <0,1,2,or 3>
CREATE TABLE zone_g (
  num int(11) NOT NULL auto_increment,
  zone_m int(11) NOT NULL default '0',
  objvnum int(11) NOT NULL default '0',
  eqpos int(11) NOT NULL default '0',
  PRIMARY KEY  (num),
  KEY zone_m (zone_m,objvnum,eqpos)
) TYPE=MyISAM;
*/
	}
	else
	if (m_editm) // edit a zone mobile
	{
		db::Zone_m zm(db,m_editm);
		{
			Table tbl("#000000", 3);

			printf("<form action=%s method=post>",GetCgiName().c_str());
			printf("<input type=hidden name=num value=%ld>",zm.num);
			printf("<input type=hidden name=zonenum value=%ld>",m_edit);

			inputnum("Mob Vnum","mobnum",zm.mobvnum,VALUE_IS_MOB);
			inputnum("Max","max",zm.max);
			inputnum("Room Vnum","roomnum",zm.roomvnum,VALUE_IS_ROOM);
			inputsubmit(" Save Mob ");
			inputsubmit(" Delete Mob ");

			printf("</form>");
		}
		printf("<br>");
		{
			Table tbl("#000000", 3, "&nbsp;Equipment");

			sprintf(sql,"select * from zone_g where zone_m=%ld",zm.num);
			q2.get_result(sql);
			if (q2.num_rows())
			{
				printf("<tr bgcolor=#ffffff>");
				printf("<td colspan=3>");
				{
					Table tbl("#000000",3);
					printf("<tr bgcolor=#ffffff>");
					printf("<th align=left>Item | Vnum</th>");
					printf("<th align=left>EqPos</th>");
					printf("<th></th>");
					printf("</tr>");
					while (q2.fetch_row())
					{
						db::Zone_g zg(db,&q2);
						db::Obj obj(db,zg.objvnum);
						printf("<tr bgcolor=#808080>");
						ShowObj(obj,true,true);
						printf("<td bgcolor=#c0c0c0>");
						printf("eqpos %ld",zg.eqpos);
						printf("</td>");
						printf("<td align=middle>&nbsp;");
						printf("<a href=%s?%s=edit&edit=%ld&editg=%ld>edit</a>",
							GetCgiName().c_str(),
							GetFormName().c_str(),
							m_edit,zg.num);
						printf("&nbsp;</td>");
						printf("</tr>");
					}
				}
				printf("</td>");
				printf("</tr>");
			}
			q2.free_result();
		}
		printf("<br>");
		// add eq
		{
			Table tbl("#000000", 3);

			printf("<form action=%s method=post>",GetCgiName().c_str());
			printf("<input type=hidden name=num value=%d>",0);
			printf("<input type=hidden name=zonenum value=%ld>",m_edit);
			printf("<input type=hidden name=mnum value=%ld>",zm.num);

			inputnum("Obj Vnum","objnum",-1);
			inputnum("EqPos","eqpos",0);
			inputsubmit(" Add Eq ");

			printf("</form>");
		}
		printf("<br>");
	}
	else
	if (m_edito) // edit a zone object
	{
		db::Zone_o zo(db,m_edito);
		{
			Table tbl("#000000", 3);

			printf("<form action=%s method=post>",GetCgiName().c_str());
			printf("<input type=hidden name=num value=%ld>",zo.num);
			printf("<input type=hidden name=zonenum value=%ld>",m_edit);

			inputnum("Obj Vnum","objnum",zo.objvnum,VALUE_IS_OBJ);
			inputnum("Max","max",zo.max);
			inputnum("Room Vnum","roomnum",zo.roomvnum,VALUE_IS_ROOM);
			inputsubmit(" Save Obj ");
			inputsubmit(" Delete Obj ");

			printf("</form>");
		}
		printf("<br>");
	}
	else
	if (m_edit) // edit the zone
	{
		db::Zone zone(db,m_edit);
		{
			Table tbl("#000000", 3);

			printf("<form action=%s method=post>",GetCgiName().c_str());
			printf("<input type=hidden name=onum value=%ld>",zone.num);

			inputnum("Vnum","num",zone.num);
			inputstr("Name","name",60,zone.name,true);
			inputnum("LifeSpan","lifespan",zone.lifespan);
			inputselect(q,"ResetMode","resetmode","select num,name from zone_reset order by num",zone.resetmode);
			inputnum("Size","size",zone.size);
			inputsubmit(" Save ");

			printf("</form>");
		}
		printf("<br>");

		// mobs
/*
// M <mob Vnum> <Max Existing> <RoomVnum>
CREATE TABLE zone_m (
  num int(11) NOT NULL auto_increment,
  zone int(11) NOT NULL default '0',
  mobvnum int(11) NOT NULL default '0',
  max int(11) NOT NULL default '0',
  roomvnum int(11) NOT NULL default '0',
  PRIMARY KEY  (num),
  KEY zone (zone,roomvnum,mobvnum),
  KEY mobvnum (mobvnum)
) TYPE=MyISAM;
// G <Obj Vnum> <0,1,2,or 3>
CREATE TABLE zone_g (
  num int(11) NOT NULL auto_increment,
  zone_m int(11) NOT NULL default '0',
  objvnum int(11) NOT NULL default '0',
  eqpos int(11) NOT NULL default '0',
  PRIMARY KEY  (num),
  KEY zone_m (zone_m,objvnum,eqpos)
) TYPE=MyISAM;
*/
		sprintf(sql,"select * from zone_m where zone=%ld order by mobvnum,roomvnum",zone.num);
		q.get_result(sql);
		if (q.num_rows())
		{
			Table tbl("#000000", 3);
			printf("<tr bgcolor=#ffffff>");
			printf("<th>Mob</th>");
			printf("<th>Max</th>");
			printf("<th>Room</th>");
			printf("<th>Equipment</th>");
			printf("<th></th>");
			printf("</tr>");
			while (q.fetch_row())
			{
				db::Zone_m x(db,&q);
				db::Mob mob(db,x.mobvnum);
				db::Room room(db,x.roomvnum);
				printf("<tr bgcolor=#808080>");
				ShowMob(mob,true,true);
				printf("<td bgcolor=#c0c0c0 align=right>&nbsp;%ld&nbsp;</td>",x.max);
				ShowRoom(room,true,true);
				sprintf(sql,"select count(*) from zone_g where zone_m=%ld",x.num);
				printf("<td bgcolor=#c0c0c0 align=right>&nbsp;%ld&nbsp;</td>",q2.get_count(sql));
				printf("<td bgcolor=#c0c0c0 align=middle>&nbsp;[&nbsp;");
				printf("<a href=%s?zoneform=edit&edit=%ld&editm=%ld>edit</a>",
					GetCgiName().c_str(),m_edit,x.num);
				printf("&nbsp;]&nbsp;</td>");
				printf("</tr>");
			}
		}
		if (q.num_rows())
		{
			printf("<br>");
		}
		q.free_result();

		// Add Mob
		{
			Table tbl("#000000", 3);

			SetColor("#c0ffff");
			printf("<form action=%s method=post>",GetCgiName().c_str());
			printf("<input type=hidden name=num value=%d>",0);
			printf("<input type=hidden name=zonenum value=%ld>",zone.num);

			inputnum("Mob Vnum","mobnum",-1);
			inputnum("Max","max",-1);
			inputnum("Room Vnum","roomnum",-1);

			inputsubmit(" Add Mob ");

			printf("</form>");
			SetColor("#ffffc0");
		}
		printf("<br>");

		// objects
/*
// O <Obj Vnum> <Max Existing (Set to -1 for no max)> <Room Vnum>
CREATE TABLE zone_o (
  num int(11) NOT NULL auto_increment,
  zone int(11) NOT NULL default '0',
  objvnum int(11) NOT NULL default '0',
  max int(11) NOT NULL default '0',
  roomvnum int(11) NOT NULL default '0',
  PRIMARY KEY  (num),
  KEY zone (zone,roomvnum,objvnum)
) TYPE=MyISAM;
*/
		sprintf(sql,"select * from zone_o where zone=%ld order by objvnum,roomvnum",zone.num);
		q.get_result(sql);
		if (q.num_rows())
		{
			Table tbl("#000000", 3);
			printf("<tr bgcolor=#ffffff>");
			printf("<th>Obj</th>");
			printf("<th>Max</th>");
			printf("<th>Room</th>");
			printf("<th></th>");
			printf("</tr>");
			while (q.fetch_row())
			{
				db::Zone_o x(db,&q);
				db::Obj obj(db,x.objvnum);
				db::Room room(db,x.roomvnum);
				printf("<tr bgcolor=#808080>");
				ShowObj(obj,true,true);
				printf("<td bgcolor=#c0c0c0 align=right>&nbsp;%ld&nbsp;</td>",x.max);
				ShowRoom(room,true,true);
				printf("<td bgcolor=#c0c0c0 align=middle>&nbsp;[&nbsp;");
				printf("<a href=%s?zoneform=edit&edit=%ld&edito=%ld>edit</a>",
					GetCgiName().c_str(),m_edit,x.num);
				printf("&nbsp;]&nbsp;</td>");
				printf("</tr>");
			}
		}
		if (q.num_rows())
		{
			printf("<br>");
		}
		q.free_result();


		// Add Obj
		{
			Table tbl("#000000", 3);

			SetColor("#c0ffff");
			printf("<form action=%s method=post>",GetCgiName().c_str());
			printf("<input type=hidden name=num value=%d>",0);
			printf("<input type=hidden name=zonenum value=%ld>",zone.num);

			inputnum("Obj Vnum","objnum",-1);
			inputnum("Max","max",-1);
			inputnum("Room Vnum","roomnum",-1);

			inputsubmit(" Add Obj ");

			printf("</form>");
			SetColor("#ffffc0");
		}
		printf("<br>");

	}
}


} // namespace cgi


/*
CREATE TABLE zone (
  num int(11) NOT NULL default '0',
  name varchar(255) NOT NULL default '',
  lifespan int(11) NOT NULL default '0',
  resetmode int(11) NOT NULL default '0',
  PRIMARY KEY  (num)
) TYPE=MyISAM;
*/

/*
// C <Amount in Copper> <RoomVnum> <only load once (1 or 0)>
CREATE TABLE zone_c (
  num int(11) NOT NULL auto_increment,
  zone int(11) NOT NULL default '0',
  baseamt int(11) NOT NULL default '0',
  roomvnum int(11) NOT NULL default '0',
  loadeverytime int(11) NOT NULL default '0',
  PRIMARY KEY  (num),
  KEY zone (zone,roomvnum)
) TYPE=MyISAM;
// D <Room Num><Which Door><Door Bit>
CREATE TABLE zone_d (
  num int(11) NOT NULL auto_increment,
  zone int(11) NOT NULL default '0',
  roomvnum int(11) NOT NULL default '0',
  direction int(11) NOT NULL default '0',
  doorstate varchar(255) NOT NULL default '',
  PRIMARY KEY  (num),
  KEY zone (zone,roomvnum,direction)
) TYPE=MyISAM;
// R <RoomVnum> <Obj Vnum>
CREATE TABLE zone_r (
  num int(11) NOT NULL auto_increment,
  zone int(11) NOT NULL default '0',
  roomvnum int(11) NOT NULL default '0',
  objvnum int(11) NOT NULL default '0',
  PRIMARY KEY  (num),
  KEY zone (zone,roomvnum,objvnum)
) TYPE=MyISAM;
*/

